*****************************************************************************
* Modulname:	RPL Development System
* Modultype:	Absolute Library
* Dest.Comp.:	HP48 GX/SX
* Language:	System RPL
* Author:	Detlef Mueller, Bellerbek 33, 22559 Hamburg, +49 40 8119280
*		Raymond Hellstern, Liebigstr.8, 30163 Hannover,+49 511 661011
* Interface:
* Description:	<rs> in stack descriptions means <pointer to runstream>
*		or <list of &ob/ob>.
* To do:	- add debugger
*		- correct Ereal/Ecmp DC/C
*		- add better array et c. support
*		- add RRP support
*		- change BINT DC (allw. # xx)
*		- add MACROs to assembler
*		- add * at SOL comments in RPL->
*		- add nested IF ELSE ENDIF in ASS
*
* $Id: rpl.s 5.2.1.1 1998/11/05 21:37:18 Detlef Rel $
*
* Revision history:
*
* $Log: rpl.s $
* Revision 5.2.1.1  1998/11/05 21:37:18  Detlef
* Public release
*
* Edition History :
*     0.000 26.08.1991	DM	alpha version
*	...
*****************************************************************************

    TITLE	RPL Development System

*****************************************************************************
*		INCLUDE FILES
*****************************************************************************

    INCLUDE	keydefs.h
    INCLUDE	rpl_42.h

*****************************************************************************
*		DEFINES
*****************************************************************************

ASSEMBLE

RomId		EQU	#4D2

XNAME	MACRO		* name
	CON(1)	8
	CON(6)	~x$1
x$1
XNAME	ENDM

PCode	MACRO
	CON(5)	(*)+5
PCode	ENDM

	INCLUDE ENTRIES.H
RPL


DEFINE	RevStr	"\F7\C8\C5 5k\D3l\10\0D\07\13R\09\D2\19R\\P\CD\80\9F"
DEFINE	CpyStr	"\F7\C8\C5\D2\C5\87\D3\80\D0\CFDK\19H\D2\CF\C7\D2\C1\CD\80\9F"
DEFINE	WhoStr	"\F7,K?\99K\1FE\0BI'\\h\15\1E\03\14\06\04\1FN\9F"
DEFINE	EmpStr	"\F7\C8\C5\D2\C5\87\D3\80\D9\CF\D5\D2\80\D0\D2\CF\C7\D2\C1\CD\80\9F"
DEFINE	RegStr	"\F7\C8\C5\D27B\14I\0A\1B\10\00E\14\D2\CF\13\1D\C1\CD\80\9F"
DEFINE	SNoStr	"\F7\C8\C5!\00U\1AA\15\CF\1B\1D\0E\D0B_WBQ\CD\80\9F"
DEFINE	NamStr	"\F7\C8\C5\D2O\0DY\807\00\17\1DD\09\D2EMX\C1\CD\80\9F"

					( *Decompiler LAMs* )
DEFINE	ExRPLTab?	1GETLAM 	( *Shared with compiler/dis/assembler* )
DEFINE	@RPLTab 	2GETLAM 	( *Shared with compiler/dis/assembler* )
DEFINE	@sol		3GETLAM 	( *Start of line [blanks]* )
DEFINE	!sol		3PUTLAM
DEFINE	@semistk	4GETLAM 	( *SEMI stack, used for ;, } gen.* )
DEFINE	!semistk	4PUTLAM
DEFINE	@rsLen		5GETLAM 	( *Last nibb of rs* )
DEFINE	@rs		6GETLAM 	( *rs* )
DEFINE	@mlrows 	7GETLAM 	( *max. row in Rpl->nLine* )

DEFINE	DECOLAMS	SIX		( *No. of decompiler LAMs* )
DEFINE	MRDECOLAMS	SEVEN		( *Multi-row DC LAMs* )

					( *Compiler LAMs* )
DEFINE	@src		3GETLAM 	( *Source string* )
DEFINE	!src		3PUTLAM
DEFINE	@pos		4GETLAM 	( *Position* )
DEFINE	!pos		4PUTLAM
DEFINE	@INest		5GETLAM 	( *INCLUDE nesting depth* )
DEFINE	!INest		5PUTLAM
DEFINE	@comp#		6GETLAM 	( *Composite nesting depth* )
DEFINE	!comp#		6PUTLAM
DEFINE	@AsTmp		7GETLAM 	( *Ass tmp* )
DEFINE	!AsTmp		7PUTLAM

DEFINE	COMPLAMS	SEVEN		( *No. of compiler LAMs* )

					( *Assembler LAMs* )
DEFINE	@AsLoC		8GETLAM 	( *Location counter* )
DEFINE	!AsLoC		8PUTLAM
DEFINE	@AsLabVal	9GETLAM 	( *Label value* )
DEFINE	!AsLabVal	9PUTLAM
DEFINE	@AsSymTab	10GETLAM	( *Symbol table* )
DEFINE	!AsSymTab	10PUTLAM
DEFINE	@AsLin# 	11GETLAM	( *Lines counter* )
DEFINE	!AsLin# 	11PUTLAM
DEFINE	@LoC		12GETLAM	( *Global location counter* )
DEFINE	!LoC		12PUTLAM

DEFINE	ASLAMS		TWELVE		( *No of assembler LAMs* )

					( *Disassembler LAMs* )
DEFINE	@lines		3GETLAM 	( *Line no.* )
DEFINE	!lines		3PUTLAM
DEFINE	@lastadr	4GETLAM 	( *Stop address* )

DEFINE	DIASLAMS	FOUR		( *No. of disassembler LAMs* )

DEFINE	DispAct 	DispCoord1
DEFINE	BlankDAR	BlankDA2
DEFINE	DispRep 	DISPROW5
DEFINE	DispPLRep	DISPROW4
DEFINE	DispTRep	DISPROW6
DEFINE	RepL#		THIRTYTWO	( *Pixel y of line 4* )


*****************************************************************************
*		ROMPART header
*****************************************************************************

ASSEMBLE

	ABS	#C0000

RPLlib	CON(5)	=DOLIB
=LIB
	REL(5)	SYSEND
	CON(2)	20
	NIBASC	`RPL :5.1,DM&RH'98`
	CON(2)	20
=SYS	CON(3)	RomId
	REL(5)	HasH
	REL(5)	RPLmsg
	REL(5)	LinK
	REL(5)	RPLcfg
RPL

*****************************************************************************
*		ROMPART hashtable
*****************************************************************************

ASSEMBLE

HasH
	CON(5)	=DOHSTR
	REL(5)	TaBlEnD

	CON(5)	0
	REL(5)	oBleN2
	REL(5)	oBleN3
	REL(5)	oBleN4
	REL(5)	oBleN5
	REL(5)	oBleN6
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0
	CON(5)	0

	REL(5)	naMEend

oBleN2
ec	CON(2)	#2
	NIBASC	\EC\
	CON(3)	12
$->	CON(2)	#2
	NIBASC	\$\
	CON(3)	10
->$	CON(2)	#2
	NIBASC	\$\
	CON(3)	11
cc	CON(2)	#2
	NIBASC	\CC\
	CON(3)	16

oBleN3
->ob	CON(2)	#3
	NIBASC	\OB\
	CON(3)	5
da1	CON(2)	#3
	NIBASC	\DA1\
	CON(3)	7
dan	CON(2)	#3
	NIBASC	\DAN\
	CON(3)	6

oBleN4
rpl->	CON(2)	#4
	NIBASC	\RPL\
	CON(3)	0
->rpl	CON(2)	#4
	NIBASC	\RPL\
	CON(3)	1
cod->	CON(2)	#4
	NIBASC	\COD\
	CON(3)	3
->cod	CON(2)	#4
	NIBASC	\COD\
	CON(3)	4
daxy	CON(2)	#4
	NIBASC	\DAXY\
	CON(3)	8
e<-->a	CON(2)	#4
	NIBASC	\EA\
	CON(3)	13
sym->	CON(2)	#4
	NIBASC	\SYM\
	CON(3)	9

oBleN5
dcadr	CON(2)	#5
	NIBASC	\DCADR\
	CON(3)	2
_4_5_7	CON(2)	#5
	NIBASC	'4/5/7'
	CON(3)	15

oBleN6
rpltab	CON(2)	#6
	NIBASC	\RPLtab\
	CON(3)	14
naMEend

*****************************************************************************
*		ROMPART DecompPart (part of hash table)
*****************************************************************************

	CON(5)	(*)-(rpl->)
	CON(5)	(*)-(->rpl)
	CON(5)	(*)-(dcadr)
	CON(5)	(*)-(cod->)
	CON(5)	(*)-(->cod)
	CON(5)	(*)-(->ob)

	CON(5)	(*)-(dan)
	CON(5)	(*)-(da1)
	CON(5)	(*)-(daxy)
	CON(5)	(*)-(sym->)
	CON(5)	(*)-($->)
	CON(5)	(*)-(->$)

	CON(5)	(*)-(ec)
	CON(5)	(*)-(e<-->a)
	CON(5)	(*)-(rpltab)
	CON(5)	(*)-(_4_5_7)
	CON(5)	(*)-(cc)
TaBlEnD

***************************************
*	ROMPTR Definitions
***************************************

~xRPL		EQU	(RomId)+4096*0
~xRPL		EQU	(RomId)+4096*1
~xDCADR 	EQU	(RomId)+4096*2
~xCOD		EQU	(RomId)+4096*3
~xCOD		EQU	(RomId)+4096*4
~xOB		EQU	(RomId)+4096*5
~xDAN		EQU	(RomId)+4096*6
~xDA1		EQU	(RomId)+4096*7
~xDAXY		EQU	(RomId)+4096*8
~xSYM		EQU	(RomId)+4096*9
~x$		EQU	(RomId)+4096*10
~x$		EQU	(RomId)+4096*11
~xEC		EQU	(RomId)+4096*12
~xEA		EQU	(RomId)+4096*13
~xRPLtab	EQU	(RomId)+4096*14
~x4/5/7 	EQU	(RomId)+4096*15
~xCC		EQU	(RomId)+4096*16

*****************************************************************************
*		ROMPART linktable
*****************************************************************************

LinK
	CON(5)	=DOHSTR
	REL(5)	enDLink
*				ROMPTR
	REL(5)	xRPL		0
	REL(5)	xRPL		1
	REL(5)	xDCADR		2
	REL(5)	xCOD		3
	REL(5)	xCOD		4
	REL(5)	xOB		5

	REL(5)	xDAN		6
	REL(5)	xDA1		7
	REL(5)	xDAXY		8
	REL(5)	xSYM		9
	REL(5)	x$		A
	REL(5)	x$		B

	REL(5)	xEC		C
	REL(5)	xEA		D
	REL(5)	xRPLtab 	E
	REL(5)	x4/5/7		F
	REL(5)	xCC		10
	CON(5)	0		11	xDBG - Debugger

	CON(5)	0		12	xMKROM - library builder
	REL(5)	dispstack	13	Display the sys-RPL stack
	REL(5)	RPLNInstERR	14	Error, if <-RPL-> isn't ATTACHED
	REL(5)	editDeco$	15	Hook for decompile sysRPL (eg. edit)
	REL(5)	->Rpl		16	Hook for compiling sysRPL after edit
enDLink

RPL


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** RPLcfg ******************************************************************
* Interface :	( --> )
* Description : Autoattach during configuration time
* Ed. Hist. :
*     1.000	26.08.1991	DM	start
*****************************************************************************

LABEL	RPLcfg
::
    LABEL	CfgAdr
    CODE
* CPU			A	C	D0	P	R0
	LC(5)	CfgAdr	O	P2 adr
	?A#C	A	    O <> CfgAdr ?
	GOYES	TstP1	    yes: maybe port 1 ?

*			    lib is 1st in port 2, push FALSE to cont. cfg
PTFL	GOTO	PshTFL

TstP1	P=	4				4
	LC(1)	#8		P1 base
	P=	0				0
	?A#C	A	    O <> P1[CfgAdr] ?
	GOYES	PTFL	    yes: lib is somewhere, push TRUE to abort cfg

*			    Lib is the 1st in port 1, check if no copy is
*			    allready running in port 2

	CD0EX				->rs
	R0=C						->rs
	D0=(5)	RPLlib			C0000
	A=DAT0	A	[C0000]
	LC(5)	=DOLIB		DOLIB
	?A#C	A	    1st ob in p2 <> lib ?
	GOYES	SwapAdr     yes: swap addresses

*			    1st ob in p2 is a lib, check for a copy of this
*			    lib and the HP41CV emu card

	D0=D0+	10			->name
	A=0	A	0
	A=DAT0	B	len(nam)
	?A=0	B
	GOYES	NulNam
	A=A+A	A	len*=2
	CD0EX			->name
	C=C+A	A
	D0=C
	D0=D0+	2

NulNam	D0=D0+	2			->id
	A=DAT0	X	id
	C=R0			->rs
	D0=C				->rs

	LC(3)	RomId
	?A=C	X	    ROMID of lib in p2 = RomId ?
	GOYES	PshTFL	    yes: push TRUE to abort cfg

	LC(3)	1402	    Ctl41, 1. lib HP41
	?A=C	X	    HP41 emu running in port 2 ?
	GOYES	PshTFL	    yes: push TRUE to abort cfg

*			    lib is 1st library in port 1, swap addresses
*			    by swapping the base addresses in the cfg. tab.
*			    for p1/p2, then doing a warmstart

SwapAdr
	D0=(5)	(=CONFTAB)+10  Skip CRC(4)/status(1)/size(5)
	C=DAT0	A		p1 address
	D0=D0+	11	    Offset to 2nd entry
	A=DAT0	A	p2 addr
	DAT0=C	A	    Port 2 becomes address of port 1
	D0=D0-	11
	DAT0=A	A	    Port 1 becomes address of port 2

	GOSBVL	=COMPCONFCRC
	DAT0=C	4	    Patch new CRC
	GOVLNG	=Warmstart  Do it again Sam ...

    ENDCODE

    ?SEMI				( *Cont. only if we are 1st in p2* )

    CODE
Chk48	AD0EX
	D0=(5)	(=addrADISP)+6
	C=DAT0	B
	AD0EX
	?CBIT=1 3
	GOYES	PshTFL		carry set if GX
PshTFL	GOVLNG	=PushT/FLoop
    ENDCODE

    IT					( *we're on a GX* )
    ::	[#] RomId ONE X@_G		( *try to recall <-RPL-> from p1* )
	case2DROP			( *GX & p1 -> ok* )
	DROPRDROP			( *GX & ! p1 -> bye* )
    ;

    RomID TOSRRP			( *Autoattach* )

    Protect SEMI

    ASSEMBLE
	CON(1)	#C
	CON(5)	=DOCODE
	REL(5)	secure

	A=PC
	A=A+CON A,10
	PC=(A)
    RPL

    LABEL DispVer
    ::
	# 4D201 JstGETTHEMSG
	ARRY
	[   RevStr CpyStr WhoStr EmpStr SNoStr RegStr NamStr
	]
	ARRYLP_DO (DO)
	    INDEX@ OVER GETATELN DROP	( --> $ arry $ )
	    3PICK XOR$ INDEX@ DISPN
	LOOP

	2DROP

	FIFTYSIX TestSysFlag
	DUP IT
	::  FIFTYSIX ClrSysFlag
	;

	FIFTEEN 400 TWENTYFOUR 300
	setbeep setbeep

	NOT?SEMI

	FIFTYSIX SetSysFlag
    ;

  LABEL secure

    65 SIXTYONE 			( *reset flags 61-64* )
    DO
	INDEX@ ClrUserFlag
    LOOP

    %1 dowait
;

LABEL	Protect

ASSEMBLE
	PCode
	D0=D0+	6
	GOLONG	loop
RPL

*** RPLmsg ******************************************************************
* Description : Message table
* Ed. History :
*     1.000	25.08.1991	DM	alpha
*****************************************************************************

LABEL	RPLmsg
ARRY
[
    "Where's your program ?"
    "Primitive Code Object"
    "Need Binary Integer"
    "Need String"
    "Data Modifies Stack"
]

DEFINE	NPRGError	ONE
DEFINE	PCOError	TWO
DEFINE	NHXSError	THREE
DEFINE	NSTRError	FOUR
DEFINE	MSTKError	FIVE

*** RPLNInstERR *************************************************************
* Interface :	( --> )
* Description : Set No Library error if <-RPL-> isn't attached to the SRRP
* Ed. Hist. :
*     1.000	22.01.1993 DM	alpha
*	001	21.07.1993 DM	add GX check
*****************************************************************************

DEFINE	CKRPLInst	ROMPTR 4D2 14

LABEL	RPLNInstERR
::
    LABEL	RomID
	[#] RomId

    LABEL	EvalSG:
    ::
	'R'R IsGX? IT SWAP DROP
	COLA_EVAL
    ;

    ONSRRP? ONSRRP?_G

    ?SEMI

    SETROMPERR			( *Undef. XLIB Name* )
;


LABEL	'SG:
::
    'R'R IsGX? IT SWAP DROP
;


LABEL	IsGX?

	Chk48

** Error ********************************************************************
* Interface :	( #[MsgNr] --> )
* Description : Error exit with message from the message table
* Uses :	RomId
* Ed. Hist. :
*     1.000	26.08.1991	DM	alpha
*****************************************************************************

LABEL	Error
::
    [#]
    ASSEMBLE
	CON(5)	(RomId)*256
    RPL
    #+ ERROROUT
;

** I/C/XError ***************************************************************
* Interface :	( $ $ | $ --> )
* Description : <-RPL-> error exit points
* Uses :	pos INest
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

LABEL	IError
::
    "Inv. " !insert$

    LABEL	CError
    ::
	CHR_: >T$ APPEND_SPACE !insert$ ( --> '$: $tok' )

	LABEL	XError
	::
	    LastRomWord@ PTR>ROMPTR
	    PALPTRDCMP DROP
	    APPEND_SPACE
	    #Error: JstGETTHEMSG !append$
	    APPEND_SPACE
	    @INest #>$ !append$
	    CHR_: >T$
	    @pos #>$ !append$
	    CHR_Newline >T$
	    !insert$
	    EXITMSGSTO #EXITERR ERROROUT
	;
    ;
;

** SaveUFlags/ClrUF1-8/RestUFlags *******************************************
* Interface :	( --> )
* Description : Save, clear, restore UF 1-8
* Ed. Hist. :
*     1.000	19.07.1993	DM	alpha
*****************************************************************************

					( *system flags* )
DEFINE	fsReport	THIRTEEN	( *unused on G/S* )
DEFINE	fsUseDA 	FOUR		( *unused on G/S* )

					( *user flags
					   ! hardcoded into flaghandler !* )
DEFINE	fReserved	SIXTYFOUR	( *must not be cleared by ClrFs* )
DEFINE	f5/7		SIXTYTHREE	( *must not be cleared by ClrFs* )
DEFINE	fQuit		SIXTYTWO	( *must not be cleared by ClrFs* )
DEFINE	fSysED		SIXTYONE	( *must not be cleared by ClrFs* )

DEFINE	fReport 	SIXTY		( *must not be cleared by ClrFs* )
DEFINE	fUseDA		FIFTYNINE	( *must not be cleared by ClrFs* )
DEFINE	fCJump		FIFTYEIGHT	( *must not move* )
DEFINE	fIF		FIFTYSEVEN

DEFINE	fIgnore 	FIFTYSIX
DEFINE	fLabel		FIFTYFIVE
DEFINE	fComment	FIFTYFOUR

DEFINE	SetF		SetUserFlag
DEFINE	ClrF		ClrUserFlag
DEFINE	TstF		TestUserFlag
DEFINE	fITE		UserITE


LABEL	SaveUFlags
::
    RCLUSRF
    '
    LABEL fuSave
	ID Urpl 				( *hidden dir save area UFs* )

    StoHiddenVar
;

LABEL	AddUFlags1-8
::
    ' fuSave DUP RclHiddenVar NOTcaseDROP
    THREE SIXTEEN SUBHXS
    RCLUSRF ONE TWO SUBHXS SWAP&$
    SWAP StoHiddenVar
;

LABEL	ClrUF1-8
::
    EIGHT
    #1+_ONE_DO (DO)
	INDEX@ ClrUserFlag
    LOOP
;

LABEL	ClrFs
::
    FIFTYNINE FIFTYFOUR 		( *clear UFs 54-58* )
    DO
	INDEX@ ClrUserFlag
    LOOP
;

LABEL	RestUFlags
::
    ' fuSave DUP RclHiddenVar NOTcaseDROP
    STOUSRF PuHiddenVar
;

** RestSFlags/InitSFlags ****************************************************
* Interface :	( --> )
* Description : Restore, initialize SF 5-12
* Modifies :	=SystemFlags+1(B) =SysNib15(B)
* Calls :	=D0=ALoop
* Defines :	DoS/R D0=ALp
* Ed. Hist. :
*     1.000	19.07.1993	DM	alpha
*****************************************************************************

LABEL	RestSFlags
::
    '
    LABEL fsSave
	ID Srpl 				( *hidden dir save area SFs* )
    DUP RclHiddenVar NOTcaseDROP
    STOSYSF PuHiddenVar
;

LABEL	InitSFlags
::
    RCLSYSF ' fsSave StoHiddenVar
    DOHEX SIXTYFOUR dostws
;

** Flags ********************************************************************
* Interface :	( --> )
* Description : Words to handle general flags
* Ed. Hist. :
*     1.000	19.07.1993	DM	alpha
*****************************************************************************

ASSEMBLE

_5_7OM		EQU	#F4
ReportOM	EQU	#E8

IFOM		EQU	#E1
IgnoreOM	EQU	#D8
CommentOM	EQU	#D2

5/7?
	PCode
	A=0	A
	LA(2)	_5_7OM
	GOTO	TstUF

ReportOff
	PCode
	A=0	A
	LA(2)	ReportOM
	GOTO	ClrUF

ReportOn
	PCode
	A=0	A
	LA(2)	ReportOM
	GOTO	SetUF

Report?
	PCode
	A=0	A
	LA(2)	ReportOM
	GOTO	TstUF

CommentOff
	PCode
	A=0	A
	LA(2)	CommentOM
	GOTO	ClrUF

CommentOn
	PCode
	A=0	A
	LA(2)	CommentOM
	GOTO	SetUF

Comment?
	PCode
	A=0	A
	LA(2)	CommentOM
	GOTO	TstUF

IgnoreOff
	PCode
	A=0	A
	LA(2)	IgnoreOM
	GOTO	ClrUF

IgnoreOn
	PCode
	A=0	A
	LA(2)	IgnoreOM
	GOTO	SetUF

Ignore?
	PCode
	A=0	A
	LA(2)	IgnoreOM
	GOTO	TstUF

IF?
	PCode
	A=0	A
	LA(2)	IFOM
	GOTO	TstUF

* CPU			A	B	C	D	D0	D1	P
*			ofs/msk R	*	M	I	D	0
SetUF	CD0EX				I
	RSTK=C
	GOSUB	GetFAdr *		ofs/msk 	->nib

	A=DAT0	B	nib
	A=A!C	P	nib'
	DAT0=A	1

	C=RSTK				I
	D0=C						I
	GOLONG	loop

* CPU			A	B	C	D	D0	D1	P
*			ofs/msk R	*	M	I	D	0
ClrUF	CD0EX				I
	RSTK=C
	GOSUB	GetFAdr *		ofs/msk 	->nib

	C=-C-1	P			!msk

	A=DAT0	B	nib
	A=A&C	P	nib'
	DAT0=A	1

	C=RSTK				I
	D0=C						I
	GOLONG	loop

* CPU			A	B	C	D	D0	D1	P
*			ofs/msk R	*	M	I	D	0
TstUF	CD0EX				I
	RSTK=C
	GOSUB	GetFAdr *		ofs/msk 	->nib

	A=DAT0	B	nib
	A=A&C	P	nib'

	C=RSTK				I
	D0=C						I

	?A=0	P
	GOYES	pshF

	LA(5)	=TRUE
	PC=(A)

pshF	LA(5)	=FALSE
	PC=(A)


GetFAdr D0=(5)	(=addrADISP)+6	magic location (->RAM start val)
	C=DAT0	B			N

	D0=A						ofs/msk
	ASR	A	ofs

	?CBIT#1 3
	GOYES	gSXa	carry set if SX

	LC(5)	UserFlags_G
	C=C+A	A
	CD0EX		ofs/msk 			->nib
	RTN

gSXa	LC(5)	UserFlags
	C=C+A	A
	CD0EX		ofs/msk 			->nib
	RTN
RPL

** ExecExt: *****************************************************************
* Interface :	( --> )
* Description : Execute extern; quote obj from return stack, save UF, save
*		and set SF, set Report and UseDA flag, clear stack decompile,
*		execute obj. Restore flags after execution or in case of errors.
* Uses :	-13 -4
* Ed. Hist. :
*     1.000	21.01.1993	DM	alpha
*****************************************************************************

LABEL	ExecExt:
::
    'R

    SaveUFlags InitSFlags

    fsReport SysITE ReportOff ReportOn
    fUseDA fsUseDA SysITE SetF ClrF

    CLRSTKDC

    ERRSET EVAL
    ERRTRAP
    ::	RestUFlags RestSFlags
	ERRJMP
    ;

    RestUFlags RestSFlags
;

** ExecInt: *****************************************************************
* Interface :	( --> )
* Description : Execute intern; quote obj from return stack, save UF, save
*		and set SF, execute obj. Restore flags and clear stack
*		decompile after execution or in case of errors.
* Ed. Hist. :
*     1.000	21.01.1993	DM	alpha
*****************************************************************************

LABEL	ExecInt:
::
    'R

    SaveUFlags InitSFlags

    fUseDA ClrF ReportOff

    ERRSET EVAL
    ERRTRAP
    ::	CLRSTKDC RestUFlags RestSFlags
	ERRJMP
    ;

    CLRSTKDC RestUFlags RestSFlags
;

** Report?: *****************************************************************
* Interface :	( --> )
* Description : Quote obj from return stack, execute if report flag is active
* Ed. Hist. :
*     1.000	26.08.1991	DM	alpha
*****************************************************************************

LABEL	Report?:
::
    'R Report? NOTcaseDROP
    COLA_EVAL
;

** xRPL-> *******************************************************************
* Interface :	( rs --> $ )
* Description : User visible RPL decompiler
* Defines :	ChkPCO ChkRef dir$
* Calls :	IsObPCO? Error InTemp? ExecExt: RPL->
* Ed. Hist. :
*     1.000	26.08.1991	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	RPL
RPL
::
    CK1 CKRPLInst

    DUPTYPERRP? casedrop
    LABEL	dir$
	"DIR\1FEND"

    LABEL	ChkPCO
    ::	IsObPCO? NOT?SEMI
	PCOError Error
    ;

    LABEL	ChkRef
    ::	InTemp? NOT?SEMI
	ONE{}N CARCOMP
    ;

    ExecExt: RPL->
;

** RPL-> ********************************************************************
* Interface :	( rs --> $ )
* Description : Kernel of xRPL->
* Modifies :	ExRPLTab RPLTab sol rsLen rs
* Defines :	DispDC
* Calls :	GetRPLTab DCObj Report? Report?: rs-
* Ed. Hist. :
*     1.000	26.08.1991	DM	alpha
*****************************************************************************

LABEL	RPL->
::
    LABEL	DispDC
    ::
	Report? NOT?SEMI
	"Decompiling sys-RPL\1F" DispAct
	BlankDAR
    ;

    CLRSTKDC
    ClrFs
					( *Initial:* )
    DUPDUP OSIZE #1-			( *rs rs #len* )
    NULL$ NEWLINE$ GetRPLTab		( *semistk sol RPLTab ExRPLTab* )
    ' NULLLAM DECOLAMS NDUPN DOBIND

    NULL$				( --> rs $ )

    DUP SKIP

    LABEL	RPL->Loop
	@sol
	ROT DCObj			( --> $ $sol rs' $' )
	Report?:
	::  DUP DispRep
	;
	ROTSWAP !append$		( --> $dc rs' $' )
	ROTSWAP !append$		( --> rs' $dc' )
	ATTN? case CancelDC
	OVER @rs rs- @rsLen #>
    NOT?GOTO RPL->Loop

    ABND
    SWAPDROP
;

LABEL	CancelDC
::
    ATTNFLGCLR SWAPDROP
    Attn# DO#EXIT
;

** x->RPL/->Rpl *************************************************************
* Interface :	( $ --> ob )
* Description : User visible RPL compiler
* Modifies :	Comm comp# pos RPLTab ExRPLTab
* Defines :	NStrCseErr
* Calls :	Error ExecExt: ->RPL
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	RPL
RPL
::
    CK1 CKRPLInst

    LABEL	NStrCseErr
    ::
	STRIPTAGS
	DUPTYPECSTR? ?SEMI
	NSTRError Error
    ;

    ExecExt: ->RPL
;

LABEL	->Rpl
::
    CKRPLInst
    ExecInt: ->RPL
;

** ->RPL ********************************************************************
* Interface :	( $ --> ob )
* Description : RPL compiler kernel
* Modifies :	Comm comp# pos RPLTab ExRPLTab
* Defines :	DispC What?
* Calls :	Report? GenLAM CommentOff GetToken CtrlWord? Entry? Symbol?
*		BuiltIn? UserOb? IError XError
*		XError x->$ Error #>ob hxs>ob
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

LABEL	->RPL
::
    LABEL	DispC
    ::
	Report? NOT?SEMI
	"Compiling sys-RPL\1F" DispAct
	BlankDAR
    ;

    GenLAM

    ClrFs

    NULLHXS				(  --> hxs )

    LABEL	->RPLoop
	::  GetToken DUPNULL$? casedrptru

	    LABEL	What?		( $ --> hxs )
	    ::	CtrlWord?
		@RPLTab ExRPLTab? Entry?
		Symbol?
		Bint?
		BuiltIn?
		UserOb?
		"Tok" IError
	    ;

	    !append$ FALSE
	;

	?ATTNQUIT

	NOT?GOTO ->RPLoop

  LABEL End->RPL

    Comment? case
    ::	") Expected" XError
    ;

    @comp# #0<>
    IT
    ::	NULLHXS
	@comp#
	ZERO_DO (DO)
	    LABEL hxsSEMI
		HXS 5 B2130
	    &$
	LOOP

	!append$
    ;

    ABND

    DUP LENHXS DUP#0=case
    ::	NPRGError Error
    ;

    FIVE OVER#> case SETIVLERR		( *Undefined Result* )

    FIVE #=case
    ::	HXS># #>ob
    ;

    hxs>ob
;

** xDCADR *******************************************************************
* Interface :	( hxs --> $ hxs' )
* Description : Decompile ob pointed to by value of hxs, correct hxs by size
* Defines :	NHxsCseErr
* Calls :	Error #>ob ChkPCO GetRPLTab ExecExt: DCObj adr>hxs
* Ed. Hist. :
*     1.000	19.10.1991	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	DCADR
RPL
::
    CK1 CKRPLInst

    LABEL	NHxsCseErr
    ::
	STRIPTAGS
	DUPTYPEHSTR? case HXS>#
	NHXSError Error
    ;

    #>ob ChkPCO
    NULL$ DUP GetRPLTab
    4NULLLAM{} BIND			( --> rs )
    ExecExt: DCObj
    ABND				( --> rs' $' )
    SWAP adr>hxs			( --> $' hxs )
;

** xCOD-> *******************************************************************
* Interface :	( code --> $ )
* Description : User visible disassembler
* Calls :	ExecExt: DACode
* Ed. Hist. :
*     1.000	22.02.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	COD
RPL
::
    CK1&Dispatch
    # 7F				( *Code* )
    ::	CKRPLInst
	ExecExt: DACode
    ;
;

** DAcode *******************************************************************
* Interface :	( code --> $ )
* Description : Disassembler kernel
* Modifies :	DA.code
* Defines :	DispDA RepLine DAxy RepLine# RepPLines
* Calls :	Report? InTemp? ob># ClrUF1-8 GetRPLTab Report?: DALine
*		StrpSpc Patch$ NextNL
* Ed. Hist. :
*     1.000	22.02.1992	DM	alpha
*****************************************************************************

LABEL	DACode
::
    LABEL	DispDA
    ::
	Report? NOT?SEMI

	"Disassembling\1F"
	LABEL	RepLine
	::
	    Report? NOTcaseDROP
	    DispAct
	    BlankDAR "Line" DispRep
	;
    ;

    InTemp? SWAPOVER			( --> f c f )
    IT
    ::	' ID DA.code UNROT ONE{}N       ( --> id f {c} )
	3PICK ?STO_HERE 		( --> id f )
	OVER XEQRCL INCOMPDROP		( --> id f c )
    ;

    ob># #10+ SWAP LENHXS OVER#+

    LABEL	DAxy			( #start #stop --> $ )
    ::
	ClrUF1-8

	ZERO				( --> .. f #start #stop #lines )
	GetRPLTab 4NULLLAM{} BIND	( ** )
	NULL$ TOTEMPSWAP NULL$
	UNROT				( --> .. f $l $ #start )

	LABEL	DaLoop
	    @lastadr OVER#> NOT?GOTO DaExit

	    @lines #1+
	    Report?:
	    LABEL	RepLine#
	    ::
		DUP #>$ $>GROB ABUFF THIRTYTWO RepL# GROB!
	    ;
	    !lines
	    DALine 4UNROLL		( --> .. f #adr $l $ $' )
	    DUP SEVENTEEN SUB$1#	( --> .. f #adr $l $ $' #c )
	    76				( *'#' 'L'* )
	    #= IT
	    ::	DUP SEVENTEEN TWENTYTWO
		SUB$			( --> .. f #adr $l $ $' $l' )
		4ROLL !insert$		( --> .. f #adr $ $' $l )
		UNROT			( --> .. f #adr $l $ $' )
	    ;

	    StrpSpc

	    Report?: Dsp$TRep

	    CHR_Newline >T$ !!append$	( --> .. f #adr $l $ )
	    ROT
	    ?ATTNQUIT

	    GOTO DaLoop

	LABEL	DaExit

	DROP				( --> .. f $l $ )
	@lines				( --> .. f $l $ #lines )
	DUP#0=ITE
	::  3DROP "* Empty *\n"
	;
	::
	    "Stripping Labels\1F"
	    LABEL	RepPLines
	    ::
		Report? NOTcaseDROP
		RepLine
		"Processing " OVER #>$ &$
		" Lines" &$ DispPLRep
	    ;

	    ZEROSWAP			( --> .. $l $ #pos #lines )

	    #1+_ONE_DO (DO)
		INDEX@ Report?: RepLine# DROP

		2DUP #1+DUP #5+ SUB$	( --> .. $l $ #p $' )

		4PICK SWAPONE POS$	( --> .. $l $ #p # )
		#0<> ?GOTO DaIsLab
		    SWAP "      " 3PICK
		    Patch$ SWAP

		LABEL	DaIsLab

		NextNL
		?ATTNQUIT
	    LOOP

	    ROT2DROP
	;

	ABND
    ;

    SWAP NOT?SEMI
    SWAP PURGE
;

** ->OB *********************************************************************
* Interface :	( ob --> ob' )
* Description : Object to object
* Calls :	#>ob IsObPCO? adr>hxs
* Ed. Hist. :
*     1.000	05.04.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	OB
RPL
::
    CK1&Dispatch
    rompointer
    ::	ROMPTR@ ?SEMI
	SETROMPERR
    ;
    hxs
    ::	CKRPLInst
	HXS># #>ob
    ;
    THIRTYONE				( *#* )
    ::	CKRPLInst
	EvalSG: ?Cov#> #>ob
    ;
    # BF				( *ACPTR* )
    ::	CKRPLInst
	EvalSG: APError ?ACCPTR>
    ;
    any
    ::	CKRPLInst
	IsObPCO? case adr>hxs
	TOTEMPOB
    ;
;

** xDAN *********************************************************************
* Interface :	( hxs %n --> $1 .. $n hxs' )
* Description : n-lines disassembler
* Defines :	DALine DisAss StrpSpc
* Calls :	ExecExt: SaveUFlags DispDA GetRPLTab Report?: RepLine# Make$n
*		DoDisAss rev$># SrchRTNam Patch$
* Ed. Hist. :
*     1.000	22.02.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	DAN
RPL
::
    CK2&Dispatch
    HXSREAL
    ::	CKRPLInst
	COERCE DUP#0<> NcaseSIZEERR
	ExecExt:
	::  Dan AddUFlags1-8
	;
    ;
;

LABEL	Dan
::
    DispDA

    GetRPLTab ' NULLLAM DUPTWO DOBIND

    SWAP HXS># SWAP

    #1+_ONE_DO (DO)
	INDEX@ Report?: RepLine# DROP

	LABEL	DALine
	::
	    LABEL	DisAss
	    ::
		SIXTYFOUR Make$n SWAP	( --> $ # )
		DoDisAss
	    ;

	    SEVEN TestUserFlag
	    IT			( *GO absolute* )
	    ::	ExRPLTab? NOT?SEMI
		OVER EIGHTEEN TWENTYTWO SUB$
		rev$># NOTcaseDROP
		@RPLTab SrchRTNam NOTcaseDROP
		ROTSWAP CHR_= >H$	( --> # $ $' )
		DUPLEN$ SIX #<
		IT
		::  FIVE Blank$ !append$
		;
		SIXTEEN Patch$ SWAP
	    ;
	;

	SWAP

	LABEL	StrpSpc 		( $ --> $' )
	::
	   DUPLEN$			( --> .. $ #len )

	   LABEL	StrpLp
	       2DUP SUB$1#		( --> .. $ #pos #chr )
	       THIRTYTWO #<> ?GOTO StrpEx
	       #1-
	       GOTO StrpLp

	   LABEL	StrpEx

	   ONESWAP SUB$
	;

	SWAP

	?ATTNQUIT
    LOOP
    ABND
    #>HXS
;

** xDA1 *********************************************************************
* Interface :	( hxs --> $ hxs )
* Description : Disassemble 1 line from address <hxs>
* Calls :	NHxsCseErr DisAss rev$># GetRPLTab SrchRTNam Patch$ StrpSpc
* Ed. Hist. :
*     1.000	22.02.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	DA1
RPL
::
    CK1 CKRPLInst
    NHxsCseErr

    DisAss SWAP

    SEVEN TestUserFlag
    IT					( *GO absolute* )
    ::	DUP EIGHTEEN TWENTYTWO SUB$	( --> # $ $' )
	rev$># NOTcaseDROP
	GetRPLTab NOTcase2DROP
	SrchRTNam NOTcaseDROP
	CHR_= >H$
	DUPLEN$ SIX #<
	IT
	::  FIVE Blank$ !append$
	;
	SIXTEEN Patch$
    ;

    StrpSpc SWAP			( --> $ # )

    #>HXS
;

** xDAXY ********************************************************************
* Interface :	( hxs[start] hxs[stop] --> $ )
* Description : Disassemble from start to stop
* Calls :	ExecExt: DispDA DAxy
* Ed. Hist. :
*     1.000	22.02.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	DAXY
RPL
::
    CK2&Dispatch
    2HXS
    ::	CKRPLInst
	HXS>#2 2DUP#> caseSIZEERR
	ExecExt:
	::  DispDA DAxy
	;
    ;
;

** x$-> *********************************************************************
* Interface :	( $ --> ob )
* Description : Compile a hex $ into an object
* Calls :	NStrCseErr rev$># rev#>ob $>hxs hxs>ob
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	$
RPL
::
    CK1 CKRPLInst
    NStrCseErr

    DUPLEN$ DUP FIVE #< 		( --> $ #len f )
    casedrop SYNTAXERR

    FIVE #=case
    ::	rev$># case rev#>ob
	SYNTAXERR
    ;

    $>hxs case hxs>ob

    SYNTAXERR
;

** x->$ *********************************************************************
* Interface :	( ob --> $ )
* Description : Decompile a ob into a hex $
* Calls :	ptr>$ ob>$
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

ASSEMBLE
	XNAME	$
RPL
::
    CK1 CKRPLInst
    INHARDROM? case ptr>$
    ob>$
;

** xE<-->A ******************************************************************
* Interface :	( hxs | $ --> $' | hxs' )
* Description : Search in reference table for given address or given string
* Calls :	GetRPLTab SrchRTNam #>ob Entry? BuiltIn?
* Ed. Hist. :
*     1.000 01.07.1992	DM	alpha, made from ->Addr & ->Name
*****************************************************************************

ASSEMBLE
	XNAME	EA
RPL
::
    CK1&Dispatch
    hxs
    ::	CKRPLInst
	DUP HXS># GetRPLTab		( --> hxs # $ f )
	ITE				( hxs #addr )
	::  SrchRTNam NOT?SEMI		( hxs $ )
	    SWAPDROP RDROP
	;
	    DROP

	#>ob				( hxs #addr --> hxs ob )
	DUPROM-WORD? IT
	::  DUP
	    LABEL	ObPtrDeco
	    ::	EvalSG: OBPTRDECOMP OBPTRDECOMP_G
	    ;
	    NOT?SEMI			( hxs ob [id] )
	    UNROT2DROP ID>$ CHR_x >H$
	    RDROP
	;

	SETNONEXTERR			( *Undefined Name* )
    ;
    str
    ::	CKRPLInst
	GetRPLTab Entry?
	BuiltIn?
	SETNONEXTERR			( *Undefined Name* )
    ;
;

** xRPLtab ******************************************************************
* Interface :	( --> $ )
* Description : Get a pointer to the RPL reference table
* Uses :	RPL.TAB Ltab? Ltab
* Defines :	GetRPLTab RclID
* Calls :	Error
* Ed. Hist. :
*     1.000	02.09.1991	DM	alpha
*	100	19.10.1991	DM	fix header test
*	200	14.04.1992	DM	add xRPLtab
*****************************************************************************

ASSEMBLE
	XNAME	RPLtab
RPL
::
    CK0 CKRPLInst

    LABEL	GetRPLTab
    ::
	' Ltab? @LAM
	case
	::  Ltab SWAP
	;

	NULL$ FALSE
	' ID RPL.TAB

	LABEL	RclID			( id --> ob t | f )
	::  DUP

	    ERRSET
	    ::	EvalSG:
		    ROMPTR XRCLp*	( *0F0 06A* )
		    ROMPTR XRCLp*_G	( *0F0 08B* )
		TRUE
	    ;
	    ERRTRAP FALSE

	    ?SKIP
	    ::	DUP
		EvalSG: COMPILEID COMPILEID_G
					( id --> id ob t / f )
		?SEMI
		2DROP FALSE RDROP	( *Not found* )
	    ;
					( --> id ob )
	    DEPTH 1LAMBIND
	    EvalSG: NOP ?ACCPTR>	( *!!!* )
	    EVAL
	    DEPTH 1GETABND
	    #<>case
	    ::	MSTKError Error
	    ;

	    SWAPDROP TRUE
	;

	NOT?SEMI			( *Not found* )

	DUPTYPECSTR? NOTcaseDROP	( *No Cstr* )

	DUPONE TWO SUB$ "\00\n" EQUAL
	NOTcaseDROP			( *Invalid header* )

	UNROT2DROP TRUE 		( 0$ f $ --> $ t )
    ;
    DROP
;

** DCObj ********************************************************************
* Interface :	( rs --> rs' $ )
* Description : Decompile object at <rs>, return <rs'> (past obj.) and string
* Uses :	ExRPLTab RPLTab
* Calls :	Obj? Error SrchRTNam #>x$ UseDA?
* Ed. Hist. :
*     1.000	30.08.1991	DM	alpha
*	100	09.10.1991	DM	modify ob DC
*****************************************************************************

LABEL	DCObj
::
    Obj?				( --> rs' #->ob )
    Labled?				( --> rs' #->ob )
    RomWord?				( --> rs' #->ob )
    #>x$				( --> rs' $ )

    LABEL ptr$
	"PTR "
    SWAP&$
;

LABEL	Labled?
::
    ExRPLTab? NOT?SEMI
    @RPLTab SrchRTNam NOT?SEMI
    RDROP
;

LABEL	RomWord?
::
    DUP #>ob
    DUPROM-WORD? NOTcaseDROP		( --> rs' #->ob ob )
    DUP ObPtrDeco NOTcaseDROP		( --> rs' #->ob ob [id t] [f] )

    UNROT2DROP RDROP
    ID>$ CHR_x >H$
;

** Entry? *******************************************************************
* Interface :	( $ $tab t/f --> hxs and abort caller | $ )
* Description : Try to resolve $ as a reference table entry
* Calls :	SrchRTAdr
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

LABEL	Entry?
::
    NOTcaseDROP
    OVERLEN$ FIFTEEN #> caseDROP
    SrchRTAdr NOT?SEMI

    RDROP #>HXS
;

** Symbol? ******************************************************************
* Interface :	( $ --> hxs and abort caller | $ )
* Description : Try to resolve $ from the assembler symbol table
* Calls :	AsSymEVAL AsL$>Lh
* Uses :	AsSymTab
* Ed. Hist. :
*     1.000	13.09.1992	DM	alpha
*****************************************************************************

LABEL Symbol?
::
    DUP AsL$>Lh &HXS @AsSymTab AsSymEVAL NOTcaseDROP

    UNROT2DROP RDROP
    HXS># #>HXS
;

** Bint? ********************************************************************
* Interface :	( $ --> hxs and abort caller | $ )
* Description : Try to resolve $ as build in bint (#12345)
* Calls :	AsSymEVAL AsL$>Lh
* Uses :	AsSymTab
* Ed. Hist. :
*     1.000	13.09.1992	DM	alpha
*****************************************************************************

LABEL Bint?
::
    DUPONE SUB$1# THIRTYFIVE		( --> $ #chr ## )
    #<> ?SEMI

    DUP CDR$ rev$># NOTcaseDROP

    SWAPDROP RDROP

    #>ptr case adr>hxs
    ob>hxs
;

** BuiltIn? *****************************************************************
* Interface :	( $ --> hxs and abort caller | $ )
* Description : Try to resolve $ as a built-in object
* Calls :	adr>hxs
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

LABEL BuiltIn?
::
    DUPONE SUB$1# # 78			( --> $ #chr #x )
    #<> ?SEMI

    DUP CDR$ $>ID			( --> $ id )

    EvalSG: COMPILEID COMPILEID_G
    NOTcaseDROP

    DUPTYPEROMP? case
    ::	SWAPDROP RDROP
	ob>hxs
    ;

    INHARDROM? NOTcaseDROP

    SWAPDROP RDROP
    adr>hxs
;

** UserOb? ******************************************************************
* Interface :	( $ --> hxs and abort caller | $ )
* Description : Let's see what palparse means about $
* Calls :	adr>hxs ob>hxs
* Ed. Hist. :
*     1.000	06.07.1992	DM	alpha
*****************************************************************************

LABEL UserOb?
::
    DUP palparse NOTcase 3DROP
    DUPTYPEIDNT? caseDROP
    DUPTYPECOL? caseDROP
    DUPTYPEREAL? IT
    ::	COERCE #>ptr DROP
    ;
    SWAPDROP RDROP
    INHARDROM? case adr>hxs
    ob>hxs
;

** NextToken/GetToken *******************************************************
* Interface :	( --> $tok )
* Description : Get the next token from the input string
* Modifies :	pos Comm INest str
* Defines :	Cttt GetToken NextToken
* Calls :	Report? XError
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

LABEL	NextToken
::
    GetToken DUPNULL$? NOT?SEMI

    "More Tokens Expected" XError
;

LABEL	GetToken
::
    Cttt @src @pos			( --> .. hxs hxs[ttt] $ #pos )
    GetNextToken
    SWAP !pos UNROT2DROP		( --> .. hxs $t )

    DUPNULL$? case ChkEOS
    Comment? case DoComment

    DUP CAR$ CHR_LeftPar EQUALcase ComStart

    Report? NOT?SEMI
    DUP DispRep
;

LABEL	ChkEOS
::
    @INest				( --> .. hxs $t # )
    DUP#0=csDROP
    #1- !INest				( --> .. $ # hxs )
    DROPSWAP !pos SWAP !src		( --> .. hxs )
    COLA GetToken
;

LABEL	DoComment
::
    DUPLEN$ LAST$ tokrparen
    EQUAL IT CommentOff
    COLA GetToken
;

LABEL	ComStart
::
    DUPLEN$ LAST$ tokrparen
    EQUAL ?SKIP CommentOn
    COLA GetToken
;

LABEL	Cttt
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)	cttt
	NIBHEX	0000000000000000000000000000000101111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
cttt
RPL

** DCActions ****************************************************************
* Interface :	( --> )
* Description : Decompile actions. dcTab is the decompiler dispatch table
* Ed. Hist. :
*     1.000	09.10.1991	DM	alpha version
*	100	09.01.1992	DM	*** marks modifications for compiler
*****************************************************************************

LABEL	dcTab				( *Used by Obj?* )

	DOCOL	SkPTR	dcCOL
	DOLIST	SkPTR	dcLIST
	DOROMP	SkROMP	dcROMP
	DOCODE	SkBODY	dcCODE
	DOCSTR	SkBODY	dcCSTR
	DOBINT	SkBINT	dcBINT
	DOLAM	SkID	dcLAM
	DOIDNT	SkID	dcIDNT
	DOGROB	SkBODY	dcGROB
	DOREAL	SkREAL	dcREAL
	DOCMP	SkCMP	dcCMP
	DOHSTR	SkBODY	dcHSTR
	DOCHAR	SkCHAR	dcCHAR
	DOTAG	SkID	dcTAG
	DOEREL	SkEREL	dcEREL
	DOECMP	SkECMP	dcECMP
	DOARRY	SkBODY	dcARRY
	DOEXT	SkPTR	dcUNIT
	DOSYMB	SkPTR	dcSYMB
	DOBAK	SkBODY	dcBAK
	DOLIB	SkBODY	dcLIB
	DOLNKARRY SkBODY dcLNKARRY
	DOEXT0	SkBODY	dcEXT0
	DOACPTR SkACPTR dcACPTR
	DOEXT2	SkBODY	dcEXT2
	DOEXT3	SkBODY	dcEXT3
	DOEXT4	SkBODY	dcEXT4


LABEL	dcBINT
::
    #>x$ "# " SWAP&$
;

LABEL	dcREAL
::
    a%>$ "% " SWAP&$
;

LABEL	dcEREL
::
    %%>% a%>$ "%% " SWAP&$
;

LABEL	dcCMP
::
    C%>% a%>$ SWAP a%>$
    APPEND_SPACE SWAP&$
    "C% " SWAP&$
;

LABEL	dcECMP
::
    C%%>%% 2%%>% a%>$ SWAP a%>$
    APPEND_SPACE SWAP&$
    "C%% " SWAP&$
;

LABEL	dcCHAR
::
    CHR>$ THREE DOKVIS
    "CHR " SWAP&$
;

LABEL	dcCSTR
::
    STKDC? IT
    ::	ONE DcompWidth@ SUB$
    ;
    THREE DOKVIS
    "$ """ SWAP&$ CHR_DblQuote >T$
;

LABEL	dcHSTR
::
    "HXS "
    LABEL Body>$
    ::
	OVER LENHXS			( --> rs' rs $ # )
	#>x$ APPEND_SPACE &$
	SWAP body>$ !append$
    ;
;

LABEL	dcGROB
::
    "GROB " Body>$
;

LABEL	dcCOL
::
    $_::

    LABEL	dcSTKSEMI
    ::
	SWAPDROP
	@sol APPEND_SPACE !sol
	@semistk CHR_; >H$ !semistk
    ;
;

LABEL	dcLIST
::
    DROP tok{
    @sol APPEND_SPACE !sol
    @semistk CHR_} >H$ !semistk
;

LABEL	dcSEMI				( *Handled specially* )
::
    @semistk DUPNULL$? casedrop ";"
    DUP CDR$ !semistk TWO 1_#1-SUB$
    @sol DUPNULL$? caseDROP		( *!* )
    DUPLEN$ 1_#1-SUB$ !sol		( --> $ $sol rs' $; )
    ROTDROP @sol UNROT
;

LABEL	dcUNIT
::
    "UNIT"
    dcSTKSEMI
;

LABEL	dcSYMB
::
    "SYMBOL"
    dcSTKSEMI
;

LABEL	dcIDNT
::
    "ID " id>$
;

LABEL	dcLAM
::
    "LAM " id>$
;

LABEL	dcTAG
::
    "TAG "
    LABEL	id>$
    ::
	SWAP ID>$ THREE DOKVIS &$
    ;
;

LABEL	dcROMP
::
    DUP ROMPTR># #>x$ SWAP #>x$ APPEND_SPACE SWAP&$
    "ROMPTR " SWAP&$
    SWAP
    EvalSG: ROMPTRDECOMP G_ROMPTRDECOMP
    NOT?SEMI
    ID>$ " (" SWAP&$ CHR_RightPar >T$ &$
;

LABEL	dcCODE
::
    fUseDA TstF NOTcase
    ::	"CODE " Body>$
    ;

    DACode				( --> $ $sol rs' $' )
    "CODE\n" !insert$
    @sol CDR$ "ENDCODE" !append$
    !append$

    DispDC
;

LABEL	dcARRY
::
    "ARRY " Body>$
;

LABEL	dcLNKARRY
::
    "LNKARRY " Body>$
;

LABEL	dcEXT0
::
    "LIBDAT " Body>$
;

LABEL	dcBAK
::
    "BACKUP " Body>$
;

LABEL	dcLIB
::
    "LIBRARY " Body>$
;

LABEL	dcACPTR
::
    IsGX? NOTcase
    LABEL	APError
    ::	"Found ACPTR on SX" XError
    ;

    ob>hxs "ACPTR "
    OVER SIX TEN SUBHXS HXS># #>x$ APPEND_SPACE &$
    SWAP ELEVEN FIFTEEN SUBHXS HXS># #>x$ &$
;

LABEL	dcEXT2
::
    "EXT2 " Body>$
;

LABEL	dcEXT3
::
    "EXT3 " Body>$
;

LABEL	dcEXT4
::
    "EXT4 " Body>$
;

** CActionx *****************************************************************
* Interface :	( --> )
* Description : Compiler control word actions
* Calls :
* Ed. Hist. :
*     1.000	09.01.1992	DM	alpha
*****************************************************************************

ASSEMBLE
*					Used by CtrlWord?
cTok1	CON(1)	6-1
	NIBASC	/;/
	CON(5)	cSEMI
	NIBASC	/{/
	CON(5)	cLIST
	NIBASC	/}/
	CON(5)	cSEMI
	NIBASC	/#/
	CON(5)	cBINT
	NIBASC	/$/
	CON(5)	cCSTR
	NIBASC	/%/
	CON(5)	cREAL

cTok2	CON(1)	4-1
	NIBASC	/::/
	CON(5)	cCOL
	NIBASC	/ID/
	CON(5)	cIDNT
	NIBASC	/%%/
	CON(5)	cEREL
	NIBASC	/C%/
	CON(5)	cCMP

cTok3	CON(1)	6-1
	NIBASC	/PTR/
	CON(5)	cPTR
	NIBASC	/HXS/
	CON(5)	cHSTR
	NIBASC	/LAM/
	CON(5)	cLAM
	NIBASC	/TAG/
	CON(5)	cTAG
	NIBASC	/CHR/
	CON(5)	cCHR
	NIBASC	/C%%/
	CON(5)	cECMP

cTok4	CON(1)	9-1
	NIBASC	/CODE/
	CON(5)	cCODE
	NIBASC	/GROB/
	CON(5)	cGROB
	NIBASC	/UNIT/
	CON(5)	cUNIT
	NIBASC	/ARRY/
	CON(5)	cARRY
	NIBASC	/NIBB/
	CON(5)	cNIBB
	NIBASC	/EXT1/
	CON(5)	cEXT1
	NIBASC	/EXT2/
	CON(5)	cEXT2
	NIBASC	/EXT3/
	CON(5)	cEXT3
	NIBASC	/EXT4/
	CON(5)	cEXT4

cTok5	CON(1)	1-1
	NIBASC	/ACPTR/
	CON(5)	cACPTR

cTok6	CON(1)	5-1
	NIBASC	/ROMPTR/
	CON(5)	cROMP
	NIBASC	/SYMBOL/
	CON(5)	cSYMB
	NIBASC	/LIBDAT/
	CON(5)	cLIBDAT
	NIBASC	/BACKUP/
	CON(5)	cBAK
	NIBASC	/INCLOB/
	CON(5)	cINCLOB

cTok7	CON(1)	3-1
	NIBASC	/INCLUDE/
	CON(5)	cINCLUDE
	NIBASC	/LNKARRY/
	CON(5)	cLNKARRY
	NIBASC	/LIBRARY/
	CON(5)	cLIB

cTok8	CON(1)	1-1
	NIBASC	/ASSEMBLE/
	CON(5)	cASSEMBLE

cToks	CON(5)	cTok1
	CON(5)	cTok2
	CON(5)	cTok3
	CON(5)	cTok4
	CON(5)	cTok5
	CON(5)	cTok6
	CON(5)	cTok7
	CON(5)	cTok8
RPL


LABEL	cSEMI				( *; -> SEMI* )
::
    @comp# DUP#0<>
    case
    ::	#1- !comp# hxsSEMI
    ;
    "Missplaced ; or }" XError
;

LABEL	cLIST				( *{ -> DOLIST* )
::
    @comp# #1+ !comp#
    HXS 5 47A20
;

LABEL	cBINT				( *# -> # bint* )
::
    NextToken
    rev$># case ob>hxs
    toksharp IError
;

LABEL	cCSTR				( *$ -> $ "..."* )
::
    NextToken
    DUP CAR$ CHR_DblQuote
    EQUALcase
    ::	@src
	@pos ROT LEN$ #-		( $t --> $ #start )
	#1+ 2DUP tokquote SWAP POS$	( --> $ #s #e )
	DUP#0=csedrp
	::  """ Expected" XError
	;

	DUP#1+ !pos #1- SUB$		( --> $' )

	LABEL	XLate$
	::
	    THREE F&R\seq		( --> $' $ )
	    NULL$? ?SEMI
	    "Suspect \\" CError
	;

	ob>hxs
    ;
    tok$ IError
;

LABEL	cREAL				( *% -> % real* )
::
    NextToken palparse
    case
    ::	DUPTYPEREAL? case ob>hxs
	"Suspect %" XError
    ;
    2DROP "%" IError
;

LABEL	cCOL				( *:: -> DOCOL* )
::
    @comp# #1+ !comp#
    HXS 5 D9D20
;

LABEL	cIDNT				( *ID -> ID idnt* )
::
    NextToken
    XLate$ $>ID ob>hxs
;

LABEL	cEREL				( *%% -> %% ereal* )
::
    NextToken
    palparse case
    ::	DUPTYPEREAL? case
	::  %>%% ob>hxs
	;
	"Suspect %%" XError
    ;
    2DROP "%%" IError
;

LABEL	cCMP				( *C% -> C% real real* )
::
    HXS 5 77920
    cREAL SIX TWENTYONE SUBHXS &$
    cREAL SIX TWENTYONE SUBHXS &$
;

LABEL	cPTR				( *PTR -> PTR addr* )
::
    NextToken
    rev$># case #>HXS
    "PTR" IError
;

LABEL	cHSTR				( *HXS -> HXS len body* )
::
    [#] DOHSTR
    LABEL	$>Body			( #prol --> hxs[ob] )
    ::
	NextToken
	rev$># case
	LABEL	$>body
	::
	    DUP#0=ITE
	    ::	DROP NULLHXS TOTEMPOB
	    ;
	    ::	NextToken
		DUPLEN$ ROT		( --> #p $ # #l )
		#<>case
		::  "Body Len \8B Datalen" XError
		;
		$>hxs ?SEMI
		SWAPDROP "Body Data" IError
	    ;

	    SWAP ChgType		( #p hxs --> ob )
	    ob>hxs
	;
	SWAPDROP "Body Len" IError
    ;
;

LABEL	cLAM				( *LAM -> LAM idnt* )
::
    NextToken
    XLate$ $>ID ID>LAM ob>hxs
;

LABEL	cTAG				( *TAG -> TAG idnt ob* )
::
    HXS 5 CFA20
    NextToken
    XLate$ $>ID ob>hxs
    SIX MINUSONE SUBHXS &$
    NextToken What? &$
;

LABEL	cCHR				( *CHR -> CHR chr* )
::
    NextToken
    XLate$
    DUPLEN$ #1=case
    ::	CAR$ ob>hxs
    ;
    "CHR" IError
;

LABEL	cECMP				( *C%% -> C%% ereal ereal* )
::
    HXS 5 D9920
    cEREL SIX TWENTYSIX SUBHXS &$
    cEREL SIX TWENTYSIX SUBHXS &$
;

LABEL	cCODE				( *CODE* )
::
    @pos [#] DOCODE
    NextToken
    rev$># case 			( *CODE len body - style* )
    ::	ROTDROP $>body
    ;

    2DROP				( --> .. hxs #pos )

    @src "ENDCODE" 3PICK

    LABEL	Pos$Tok 		( $s $t #start --> #0 / #n )
    ::
	Cttt SWAP 2SWAP 		( --> ttt #n $s $t )
	SKIP

	LABEL	P$TLp
	    SWAP4ROLL			( --> ttt #n $s $t )

	    2DUP5ROLL POS$
	    DUP#0=ITE			( --> ttt $s $t #n )
		FALSE
	    ::	SWAP 4UNROLL #1-
		GetNextToken		( -- > $t ttt $s #n' $t' )
		5PICK EQUALNOT
	    ;
	    ?GOTO P$TLp 		( --> $t ttt $s #n' )

	4UNROLL3DROP			( --> #n )
    ;

    DUP#0<> case
    ::	DUP !pos SEVEN #-

	3PICK LENHXS #10+ !LoC		( *DOCODE, length fields* )

	LABEL	CallAss
	::
	    @src UNROT #1-SUB$		( --> .. hxs $ass )
	    @src SWAP !src
	    @pos ONE !pos
	    @INest ZERO !INest		( --> .. hxs src pos INest )
	    DoAss			( --> .. hxs src pos INest code )
	    4UNROLL			( --> .. hxs hxs src pos INest )
	    !INest !pos !src
	    DispC
	;

	ob>hxs
    ;
    "ENDCODE Expected" XError
;

LABEL	cGROB				( *GROB -> GROB len body* )
::
    [#] DOGROB $>Body
;

LABEL	cUNIT				( *UNIT* )
::
    @comp# #1+ !comp#
    HXS 5 ADA20
;

LABEL	cARRY				( *ARRY -> ARRY len body* )
::
    [#] DOARRY $>Body
;

LABEL	cNIBB				( *NIBB -> NIBB len nibs* )
::
    cHSTR
    ELEVEN MINUSONE SUBHXS
;

LABEL	cEXT1				( *EXT1 -> EXT1 len body* )
::
    IsGX? case
    ::	"EXT1 is a S object" XError
    ;

    [#] DOEXT1 $>Body
;

LABEL	cEXT2				( *EXT2 -> EXT1 len body* )
::
    [#] DOEXT2 $>Body
;

LABEL	cEXT3				( *EXT3 -> EXT1 len body* )
::
    [#] DOEXT3 $>Body
;

LABEL	cEXT4				( *EXT4 -> EXT1 len body* )
::
    [#] DOEXT4 $>Body
;

LABEL	cROMP				( *ROMPTR -> ROMPTR LibId RomWord* )
::
    HXS 5 29E20
    NextToken
    rev$># case
    ::	#FFF OVER#< case
	::  SWAPDROP #>x$ "ROMP LibID >FFF" CError
	;
	#>HXS ONE THREE SUBHXS &$
	NextToken
	rev$># case
	::  #FFF OVER#< case
	    ::	SWAPDROP #>x$ "ROMP RomWd >FFF" CError
	    ;
	    #>HXS ONE THREE SUBHXS &$
	;
	SWAPDROP "RomWd" IError
    ;
    SWAPDROP "LibID" IError
;

LABEL	cSYMB				( *SYMBOL* )
::
    @comp# #1+ !comp#
    HXS 5 8BA20
;

LABEL	cLIBDAT 			( *LIBDAT -> LIBDAT len body* )
::
    [#] DOEXT0 $>Body
;

LABEL	cBAK				( *BACKUP -> BACKUP len body* )
::
    [#] DOBAK $>Body
;

LABEL	cINCLOB 			( *INCLOB -> INCLOB id* )
::
    NextToken
    DUP $>ID SAFE@ NOTcase

  LABEL IncObErr

    ::	"Can't INCLOB" CError
    ;
    SWAPDROP ob>hxs
;

LABEL	cINCLUDE			( *INCLUDE -> INCLUDE id* )
::
    NextToken
    LABEL	DoInclude
    ::
	DUP $>ID SAFE@

      LABEL	End->Include

	NOTcase
	::  "Can't INCLUDE" CError
	;
					( --> hxs $id ob )
	DUPTYPECSTR? NOTcasedrop
	::  "Cont. no $" CError
	;

	SWAPDROP			( --> hxs $ )
	@src UNROT @pos UNROT		( --> $ # hxs $ )
	!src ONE !pos
	@INest #1+ !INest
	NULLHXS 			( --> .. hxs hxs )
    ;
;

LABEL	cLNKARRY			( *LNKARRY -> LNKARRY len body* )
::
    [#] DOLNKARRY $>Body
;

LABEL	cLIB				( *LIBRARY -> LIBRARY len body* )
::
    [#] DOLIB $>Body
;

LABEL	cASSEMBLE			( *ASSEMBLE* )
::
    @pos				( --> #pos )
    @src "RPL" 3PICK Pos$Tok            ( --> #start #stop )
    DUP#0<> case
    ::	DUP !pos #3-
	3PICK LENHXS !LoC		( *Setup location counter* )
	CallAss
	[#] DOHSTR ChgType
    ;
    "RPL Expected" XError
;

LABEL	cACPTR				( *ACPTR -> ACPTR Dataaddr Accaddr* )
::
    IsGX? NOTcase
    ::	"ACPTR is a G object" XError
    ;

    HXS 5 AAB20
    NextToken
    rev$># case
    ::	#>HXS &HXS
	NextToken
	rev$># case
	::  #>HXS &HXS
	;
	SWAPDROP "APaa" IError
    ;
    SWAPDROP "APda" IError
;


*****************************************************************************
*		PRIMITIVE CODE OBJECTS
*****************************************************************************

ASSEMBLE

** #>ptr ********************************************************************
* Interface :	( # --> #' t/f )
* Description : Try to convert # to pointer to existing one
* Calls :	SavPtr Pop# =GPPushFLoop GPOwrAPTLp
* Ed. Hist. :
*     1.000	27.09.1992	DM	alpha
*****************************************************************************

#>ptr
	PCode
* CPU			A	B	C	D	D0	D1

	GOSUB	SavPtr
	GOSUB	Pop#	#

	D0=(5)	(=TYPEREAL)+5				->start
	LC(5)	(=FORTYTHREE)+5 	->last
	GOSUB	Seek#
	GOC	fnd#

	D0=(5)	(=FORTYFOUR)+5				->start
	LC(5)	(=MINUSONE)+5		->last
	GOSUB	Seek#
	GOC	fnd#
	GOVLNG	=GPPushFLoop

fnd#	D0=D0-	5					->#
	AD0EX
	GOTO	GPOwrAPTLp

Seek#	D=C	A				->last
sk#lp	C=DAT0	A			#
	?A=C	A
	RTNYES

	D0=D0+	10					->nxt
	CD0EX
	D0=C
	?C<=D	A
	GOYES	sk#lp

	RTN

** NextNL *******************************************************************
* Interface :	( $ #pos --> $ #pos' )
* Description : Search next NL in $ starting at #pos+1, return #pos'
* Calls :	Pop#SP PA#Loop
* Ed. Hist. :
*     1.000	27.09.1992	DM	alpha
*****************************************************************************

NextNL
	PCode
* CPU			A	B	C	D	D0	D1
	GOSUB	Pop#SP	pos

	A=A+A	A	pos *= 2

	C=DAT1	A			->$
	D0=C						->$
	D0=D0+	5					->len
	C=DAT0	A	len
	D0=D0+	5					->body

	C=C-CON A,5			$len
	B=C	A		$len
	?A>=C	A
	GOYES	FNlEx

	CD0EX				->body
	C=C+A	A			->start
	D0=C						->start
	LC(2)	10	\n
	D=C	B				\n
	GONC	FNlEn	    ** BET

FNlLp	C=DAT0	B
	?C=D	B
	GOYES	FNlEx

FNlEn	D0=D0+	2					->next
	A=A+1	A
	A=A+1	A	nxt pos
	?A<B	A
	GOYES	FNlLp

FNlEx	ASRB.F	A	pos /= 2
	A=A+1	A
	GOTO	P#ALoop

** adr>hxs ******************************************************************
* Interface :	( ob --> hxs )
* Description : Push adr of ob as hxs
* Calls :	PopASP =PUSHhxsLoop
* Defines :	PshHxsLp
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

adr>hxs
	PCode
	GOSUB	PopASP
	P=	4
PshHxsLp
	GOVLNG	=PUSHhxsLoop

** ob># *********************************************************************
* Interface :	( ob --> ob # )
* Description : Push adr of ob as bint
* Calls :	SavPtr
* Defines :	P#ALoop
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

ob>#
	PCode			( --> .. f c #&c )
* CPU				A
	GOSUB	SavPtr
	A=DAT1	A		&ob
P#ALoop GOVLNG	=PUSH#ALOOP

** #>ob *********************************************************************
* Interface :	( # --> ob )
* Description : Generate a pointer to the adr specified by the val of #
* Defines :	OwALoop loop
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

#>ob
	PCode
*  CPU			A	C	D1
	C=DAT1	A		&#	->Stk
	CD1EX			->Stk	->#
	D1=D1+	5			->adr
	A=DAT1	A	->ob

OwALoop D1=C				->Stk
	DAT1=A	A			*Stk = ->ob
loop	LOOP

** rev#>ob ******************************************************************
* Interface :	( # --> ob )
* Description : Generate a pointer to the address specified by the reversed
*		value of #
* Calls :	OwALoop
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

rev#>ob
	PCode
* CPU			A	C	D1
	C=DAT1	A		&#
	CD1EX			&stk	&#
	D1=D1+	5			&val
	P=	16-5
	A=0	A
rLoop	ASL	A	<< 4
	A=DAT1	1
	D1=D1+	1
	P=P+1
	GONC	rLoop
	GOC	OwALoop     ** BET

** hxs>ob *******************************************************************
* Interface :	( hxs --> ob )
* Description : Copy the body of the hxs into a new referenced mem block
* Calls :	SavPtr =CREATETEMP =MOVEUP =GPOverWrALp GetPtr =Garbage?Err
* Ed. Hist. :
*     1.000 13.02.1992 DM	alpha
*	001 04.07.1992 DM	only the pointer to hxs is inc by 10..
*****************************************************************************

hxs>ob
	PCode
* CPU			A	C	D0	D1
	C=DAT1	A
	C=C+CON A,10
	DAT1=C	A
	GOTO	loop

** ob>hxs *******************************************************************
* Interface :	( ob --> hxs )
* Description : Move ob into body of a hxs
* Calls :	SavPtr Skipob Mk$n =MOVEDOWN =GPOverWrR0Lp
* Defines :	GpOwR0Lp
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*	001	18.04.1992	DM	rewritten
*****************************************************************************

ob>hxs
	PCode
* CPU			A	C	D0	D1	R0	R1
	GOSUB	SavPtr
	A=DAT1	A	->ob
	R1=A							->ob
	D0=A				->ob
	GOSUB	Skipob	xx	xx	->past ob
	CD0EX			->past ob
	A=R1		->ob
	C=C-A	A			len ob
	GOSUB	Mk$n	len val ->stk	->body	->stk	->$
	D0=D0-	10			->$
	LC(5)	=DOHSTR 	hxs
	DAT0=C	A	    We want HXS !
	D0=D0+	10			->body
	AD0EX		->body		len val
	D1=A					->body
	D0=D0-	5			len
	CD0EX			len
	A=R1		->ob
	D0=A				->ob
	GOSBVL	=MOVEDOWN
GpOwR0Lp
	GOVLNG	=GPOverWrR0Lp

** ptr>$ ********************************************************************
* Interface :	( ptr(ob) --> $ )
* Description : Convert a pointer-object into a 5 char hex-$
* Calls :	SavPtr Mk$n >$Entry
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

ptr>$
	PCode
* CPU			A	B	C	D	D0	D1	R0
	GOSUB	SavPtr
	LC(5)	10			nibs
	GOSUB	Mk$n	len	xxx	->stk	xxx	->b$'   ->stk   ->$'
	LC(5)	5			size
	GOTO	>$Entry     *** BET

** ob>$ *********************************************************************
* Interface :	( ob --> $ )
* Description : Convert an object into a hex-$
* Calls :	SavPtr Skipob >$Entry
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

ob>$
	PCode
*  CPU			A	B	C	D	D0	D1	R0
	GOSUB	SavPtr
	C=DAT1	A			->ob
	B=C	A		->ob
	D0=C						->ob
	GOSUB	Skipob	xxx		xxx		->past
	CD0EX				->past
	C=C-B	A			size
	R4=C.F	A
	C=C+C	A			chrs
	GOSUB	Mk$n	len	xxx	->stk	xxx	->b$'   ->stk   ->$'
	C=DAT1	A			->ob
	D1=C						->to	->from
	C=R4.F	A			size
	GOTO	>$Entry

** body>$ *******************************************************************
* Interface :	( hxs|code|grog|arry|lnkarr|ext0-4 --> $' )
* Description : Copy converted body of hcgale into $
* Uses :	=SysNib5
* Calls :	SavPtr GpOwR0Lp
* Defines :	>$Entry
* Ed. Hist. :
*     1.000 13.02.1992 DM	alpha
*	001 21.01.1993 DM	add STKDC flag support
*****************************************************************************

body>$
	PCode
*  CPU			A	B	C	D	D0	D1	R0
	GOSUB	SavPtr
	A=DAT1	A	->x
	D1=A							->x
	D1=D1+	5						->xl
	A=DAT1	A	xl
	A=A-CON A,5	bxl
	?A#0	A
	GOYES	NoNull$     *** Bodylength <> 0

	LC(5)	=NULL$			->0$
	R0=C								->0$
	GOTO	GpOwR0Lp

NoNull$ GOSUBL	D0=RAM
	CON(5)	=SysNib5_G
	CON(5)	=SysNib5

	C=DAT0	B
	?CBIT=0 3	    *** StkDC clear ?
	GOYES	NoStkDc

	GOSUBL	D0=RAM
	CON(5)	=DcompWidth_G
	CON(5)	=DcompWidth

	C=0	A
	C=DAT0	B
	?A<=C	A
	GOYES	NoStkDc
	A=C	A

NoStkDc R4=A.F	A
	C=A	A
	C=C+A	A			chrs
	GOSUB	Mk$n	len	xxx	->stk	xxx	->b$'   ->stk   ->$'
	C=DAT1	A			->x
	D1=C							->x
	D1=D1+	10					->to	->from
	C=R4.F	A			size

* CPU			xxx	xxx	size	xxx	->to	->from	->$

>$Entry C=C-1	A			cnt
	B=C	A		cnt
	LC(2)	9			9
	D=C	B				9
	LA(2)	#30	'0'
*  CPU			'0'     Len-1   xxx     9       ->b$    ->bx
h>$Loop C=0	B			0
	C=DAT1	1			nib
	D1=D1+	1						->NxtNib
	?C<=D	B
	GOYES	h>$Add
	C=C+CON B,7			+= 7
h>$Add	C=C+A	B			+= '0'
	DAT0=C	B
	D0=D0+	2					->NxtChr
	B=B-1	A		--cnt
	GONC	h>$Loop

	GOTO	GpOwR0Lp

** rev$># *******************************************************************
* Interface :	( $ --> # t / $ f )
* Description : Try to convert given hex-$ into bint, reverses value
* Calls :	SavPtr GPPshFLp GPDrpPshA#TLp
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

rev$>#
	PCode
* CPU			A	B	C	D	D0	D1
	GOSUB	SavPtr
	C=DAT1	A			&$
	D0=C						&$
	D0=D0+	5					&len
	A=DAT0	A	len
	A=A-CON A,5	len(n)
	LC(5)	10			10
	?A>C	A	    *** len($) > 5 chrs ?
	GOYES	snInv$
	D0=D0+	5					&chrs
	D1=A							cnt
	D1=D1-	2						--cnt
	A=0	A	0
	LC(2)	#30			'0'
	D=C	B				'0'
	GONC	snEntry     *** BET

snInv$	GOTO	GPPshFLp
* CPU			#	xxx	xxx	'0'     &chr    cnt

snLoop	ASL	A	#<<4
	D0=D0+	2					&nxt

snEntry C=DAT0	B			chr

	C=C-D	B			chr-'0'
	GOC	snInv$	    *** < '0'

	B=C	B		chr-'0'
	LC(2)	#0A			10
	?B<C	B
	GOYES	snNoSub     *** <= 9

	LC(1)	7			7
	B=B-C	B		chr-'7'

	LC(1)	#A			10
	?B<C	B
	GOYES	snInv$	    *** < A
	LC(1)	#F
	?B>C	B
	GOYES	snInv$	    *** > F

snNoSub A=A!B	B
	D1=D1-	2
	GONC	snLoop

	GOTO	GPDrpPshA#TLp

** $>hxs ********************************************************************
* Interface :	( $ --> hxs t / $ f )
* Description : Try to convert given x-$ into hxs
* Calls :	PopASP GPPshFLp GPOWrR0PTLp
* Defines :	$>hxsEntr f$>hR
* Ed. Hist. :
*     1.000 13.02.1992 DM	alpha
*	001 30.01.1993 DM	add f$>hR
*****************************************************************************

f$>hR	EQU	5

$>hxs
	PCode
* CPU			A	B	C	D	D0	D1	R0
	ST=0	f$>hR
$>hxsEntr
	GOSUB	SavPtr
	A=DAT1	A	->$
	D1=A							->$
	D1=D1+	5						->$l
	C=DAT1	A			len
	C=C-CON A,5			blen

	CSRB.F	A			/= 2
	GOSUB	Mk$n	lenf	xxx	->stk	xxx	->b$'   ->stk   ->$'

	D0=D0-	10					->$'
	LC(5)	=DOHSTR 		hxs-prol
	DAT0=C	A	    *** We want hxs
	D0=D0+	10					->hxs

	A=A-CON A,6	len-1

	?ST=0	f$>hR
	GOYES	shFwd
	CD0EX				->hxs		xxx
	C=C+A	A
	D0=C

shFwd	C=DAT1	A			->$
	D1=C							->$
	D1=D1+	10						->b$

	C=A	A			len-1
	B=C	A		cnt

	LC(2)	#30			'0'
	D=C	B				'0'
	GOTO	shEntry

shInv$	GOTO	GPPshFLp
* CPU			xxx	cnt	xxx	'0'     ->nib   ->chr

shLoop	?ST=1	f$>hR
	GOYES	shRev
	D0=D0+	2
shRev	D0=D0-	1					&nxtn
	D1=D1+	2						&nxtc

shEntry C=DAT1	B		chr

	C=C-D	B			chr-'0'
	GOC	shInv$	    *** < '0'

	LA(2)	#0A			10
	?C<A	B
	GOYES	shNoSub     *** <= 9

	LA(1)	7			7
	C=C-A	B		chr-'7'

	LA(1)	#A			10
	?C<A	B
	GOYES	shInv$	    *** < A
	LA(1)	#F			15
	?C>A	B
	GOYES	shInv$	    *** > F

shNoSub DAT0=C	1
	B=B-1	A			--cnt
	GONC	shLoop

	GOTO	GPOWrR0PTLp

** #>x$ *********************************************************************
* Interface :	( # --> $ )
* Calls :	SavPtr Mk$n GpOwR0Lp
* Ed. Hist. :
*     1.000	04.06.1992	DM	alpha
*****************************************************************************

#>x$
	PCode
* CPU			A	B	C	D	D0	D1	x
	GOSUB	SavPtr
	C=DAT1	A			->#
	D0=C						->#
	D0=D0+	5					->val
	A=DAT0	A	val
	LC(5)	3			3
	P=	4

#>CLp	?A#0	P
	GOYES	#>CEd
	P=P-1
	C=C-1	A
	GONC	#>CLp

#>CEd	C=C+1	A
	RSTK=C
	C=C+1	A			cnt+=2
	C=C+C	A			nibs
	GOSUB	Mk$n	len	xxx	->stk	xxx	->b$'   ->stk   ->$'

	C=RSTK				cnt
	B=C	A		cnt

	C=DAT1	A			->#
	C=C+B	A
	D1=C
	D1=D1+	5						->lst

	LC(2)	9			9
	D=C	B				9
	LA(2)	#30	'0'

*  CPU			'0'     Len-1   xxx     9       ->b$    ->bx

#>$Loop C=0	B			0
	C=DAT1	1			nib
	D1=D1-	1						->NxtNib
	?C<=D	B
	GOYES	#>$Add
	C=C+CON B,7			+= 7
#>$Add	C=C+A	B			+= '0'
	DAT0=C	B
	D0=D0+	2					->NxtChr
	B=B-1	A		--cnt
	GONC	#>$Loop

	GOTO	GpOwR0Lp

*****************************************************************************
*		Dispatcher
*****************************************************************************

Mk$n	GOVLNG	=MAKE$N
PopSP	GOVLNG	=PopSavptr
PopASP	GOVLNG	=PopASavptr
Pop#	GOVLNG	=POP#
Skipob	GOVLNG	=SKIPOB
Pop#SP	GOSBVL	=POP#
SavPtr	GOVLNG	=SAVPTR
GetPtr	GOVLNG	=GETPTR

** SrchRTAdr ****************************************************************
* Interface :	( $Sym $Tab --> #adr TRUE )
*		( $Sym $Tab --> $Sym FALSE )
* Description : Search in the reference table <Tab> for <Sym>
* Calls :	PopASP P0GPPshFLp GetPtr =PUSH# PTLoop
* Defines :	GPDrpPshA#TLp
* Ed. Hist. :
*     1.000	19.10.1991	DM	alpha
*****************************************************************************

SrchRTAdr
	PCode
*  CPU			A	B	C	D	D0	D1	Rx
	GOSUB	PopASP	->tab

	D0=A

	C=DAT1	A			->$Sym
	D1=C							->$Sym
	D1=D1+	5						->$len
	C=DAT1	A
	C=C-CON A,5			$len
	CSRB.F	A			Slen
	D=C	A				Slen
	D1=D1+	5						->Sym
	A=0	A	0
	A=DAT1	B	1.ch
	CD1EX				->Sym
	R0=C					    R0[A] ->searched symbol
*			    *** Skip prol, len, tab header
	D0=D0+	14					->hash

	LC(2)	#20			' '
	A=A-C	B	idx
	C=A	A			idx
	A=A+A	A	* 2
	A=A+A	A	* 4
	A=A+C	A	* 5
	CD0EX				->hash
	C=C+A	A			->hentr
	D1=C							->hentr
	A=DAT1	A	offs
	?A=0	A
	GOYES	ANoFnd

	C=C+A	A			->start
	D0=C						->start

FndStop D1=D1+	5						->nxt hentr
	A=DAT1	A	offs
	?A=0	A
	GOYES	FndStop

	CD1EX				->hentr
	C=C+A	A			->stop
	B=C	A		->stop

	GONC	AEntry	    *** BET

*  CPU			xxx	->stop	xxx	Slen	->start xxx
*		R0[A]	->Sym

ANoFnd	GOTO	P0GPPshFLp

* CPU			xxx	->stop	xxx	Slen	xxx	xxx
*		R0[A] ->Sym
*		R1[A] ->sym

ASkip	C=R1.F	A			->sym
	D0=C						->sym
	C=D	A			Slen

* CPU			xxx	->stop	slen	Slen	->sym	xxx
*		R0[A] ->Sym

ALoop	C=C+C	A
	AD0EX		->sym
	A=A+C	A	->NxtAdr
	?A>=B	A
	GOYES	ANoFnd
	D0=A						->NxtAdr

* CPU			xxx	->stop	xxx	Slen	->adr	xxx
*		R0[A] ->Sym
*		R1[A] ->sym

AEntry	D0=D0+	5					->slen
	C=0	A			0
	C=DAT0	1			slen
	D0=D0+	1					->sym
	?C#D	B
	GOYES	ALoop

	AD0EX		->sym
	D0=A						->sym
	R1=A.F	A				    R1[A] = ->symbol

* CPU			xxx	->stop	slen	Slen	->sym	xxx
*		R0[A] ->Sym
*		R1[A] ->sym

	C=-C	B			-slen
	P=C	0
	C=R0.F	A			->Sym
	D1=C							->Sym

ACmp	A=DAT0	B	symCh
	C=DAT1	B			SymCh
	D0=D0+	2
	D1=D1+	2
	?A#C	B
	GOYES	ASkip
	P=P+1
	GONC	ACmp

* CPU			xxx	->stop	xxx	Slen	xxx	xxx
*		R0[A] ->Sym
*		R1[A] ->sym

	A=R1		->sym
	D0=A						->sym
	D0=D0-	6					->adr
	A=DAT0	A	adr

**	GOSUB	Resto?

GPDrpPshA#TLp
	R0=A		    *** For PUSH#
	GOSUB	GetPtr
	GOSUB	PopSP	    *** Drop $Sym, RPL ptr in RAM
Psh#TLp GOSBVL	=PUSH#
	GOTO	PTLoop

** SrchRTNam ****************************************************************
* Interface :	( #adr $Tab --> $".." TRUE )
*		( #adr $Tab --> #adr FALSE )
* Description : Search in the reference table <Tab> for <adr>
* Calls :	PopASP =GPPushFalse =MAKE$ GetPtr =PushTLoop
* Defines :	P0GPPshFLp GPPshFLp GPOWrR0PTLp PTLoop GPOwrAPTLp
* Ed. Hist. :
*     1.000	31.08.1991	DM	alpha
*     2.000	19.10.1991	DM	rewritten
*****************************************************************************

SrchRTNam
	PCode
*  CPU			A	B	C	D	D0	D1
	GOSUB	PopASP	->tab

	D0=A

	A=DAT1	A	->#adr
	D1=A							->#adr
	D1=D1+	5						->adr
	C=DAT1	A			adr
	D=C	A				adr

	D0=D0+	5					->TabLen
	C=DAT0	A			TabLen
	B=C	A		TabLen
	CD0EX				->TabLen
	B=B+C	A		->Stop
	LA(5)	9+(96*5)    *** Skip len, tab header, hash
	C=C+A	A
	D0=C						->Tab

	GONC	NEntry

P0GPPshFLp
	P=	0
GPPshFLp
	GOVLNG	=GPPushFalse *** Get RPL regs, push FALSE, dispatch

*  CPU			xxx	&TabEnd xxx	adr	&Tab	xxx

NLoop	P=C	5	** get size
	D0=D0+	4
	CD0EX
	C+P+1
	C+P+1

	?C>=B	A	    *** &NxtVal >= &TabEnd ?
	GOYES	P0GPPshFLp  *** Yes, adr not in Tab

	D0=C						&NxtVal
NEntry	C=DAT0	6

	?D#C	B
	GOYES	NLoop

	?C#D	A	    *** val != adr ?
	GOYES	NLoop	    *** Yes, no match

	P=	0
	D0=D0+	5

	C=0	A			0
	C=DAT0	1			SymLen
	AD0EX		&SymLen
	R1=A		    *** R1[A]=&SymLen

	GOSBVL	=MAKE$

* CPU			xxx	xxx	xxx	xxx	&Body	xxx
*		R0[A] &$
*		R1[A] &SymLen

	C=R1				&SymLen
	D1=C							&SymLen
	C=DAT1	B			Len
	C=-C	B			-Len
	P=C	0
	D1=D1+	1						&Sym

NCpy	C=DAT1	B			chr
	DAT0=C	B	    *** Write chr into $
	D0=D0+	2					&DstNxtChr
	D1=D1+	2						&SrcNxtChr
	P=P+1
	GONC	NCpy

GPOWrR0PTLp
	A=R0		&$
GPOwrAPTLp
	GOSUB	GetPtr
	DAT1=A	A	    *** Overwrite # with $
PTLoop	GOVLNG	=PushTLoop  *** Push TRUE, dispatch

** Obj? *********************************************************************
* Interface :	( rs --> rs' #->ob )    pointer object
*		( rs --> rs' rs )       direct case, cola
* Description : Inner decompile dispatcher.
* Detail :	1) Check for direct/indirect/SEMI object
*		2) If not direct, return rs+5 and #->ob to caller
*		3) Search dcTab for DC routine and cola it, passing rs'
*		   (past ob) and rs.
* Calls :	SavPtr GetPtr =PUSH#LOOP
* Defines :	Psh#Lp ColaA Sk...
* Uses :	dcTab
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

Obj?
	PCode		( rs #offset --> ? )
* CPU			A	B	C	D	D0	D1	x
	GOSUB	SavPtr
	A=DAT1	A	->rs
	D0=A						->rs
	B=A	A		->rs
	A=DAT0	A	[rs] (->ob|prlg)

	D0=A						->ob|prlg
	LC(5)	=PRLG			PRLG
	D=C	A				PRLG
	C=DAT0	A			[->ob|prlg]
	?C=D	A
	GOYES	Direct	    ** Direct

	LC(5)	=SEMI
	?A=C	A
	GOYES	IsSemi	    ** SEMI

	LC(5)	5			5
	C=C+B	A			->rs'
	R0=A.F	A						    0:->ob
	A=C	A	->rs'
	GOSUB	GetPtr
	DAT1=A	A	    ** Indirect, write ->rs'

Psh#Lp	GOVLNG	=PUSH#LOOP  ** and return #->ob (in R0)

IsSemi	LC(5)	5			5
	C=C+B	A			->rs'
	DAT1=C	A	    ** Write rs'
	LC(5)	dcSEMI			->dcSEMI
	A=C	A
	GOSUB	GetPtr
	D=D+1	A	    ** eg. ColaA
	GONC	ColaA	    ** BET, cola ; handler

* CPU			->prlg	->ob/rs xxx	xxx	->prlg	->stk

Direct	D0=(5)	dcTab					->dcTab

ObLp	C=DAT0	A			->prlg'
	?A=C	A
	GOYES	ObFnd
	D0=D0+	15					->nxt
	GONC	ObLp	    ** BET

ObFnd	D0=D0+	5					->sk
	AD0EX		->sk
	GOSUB	GetPtr	->sk	R	*	M	I	D
	C=A	A			->sk

	A=DAT1	A	->ob|rs
	D1=D1-	5	->ob	R	->sk	M	I	D
	DAT1=A	A	    ** Write rs
	CD0EX		->ob	R	I	M	->sk	D
	AD0EX		->sk	R	I	M	->ob	D
	D0=D0+	5	    ** Skip prolog
	PC=(A)		    ** Call skip code (CC)

ObSked	AD0EX		->ob'   R       I       M       ->sk    D
	D1=D1+	5	->ob'   R       I       M       ->sk    ->rs
	DAT1=A	A	    ** Write rs'
	D1=D1-	5	*	R	I	M	->sk	D

	D0=D0+	5	*	R	I	M	->->dc	D
	A=DAT0	A	->dc	R	I	M	->->dc	D
	D0=C		->dc	R	*	M	I	D

ColaA	ABEX	A	R	O	*	M	I	D
	AD0EX		*	O	*	M	R	D
	D0=D0-	5	*	O	*	M	R-DELTA D

	C=DAT0	A	*	O	[R]	M	R	D

	CD0EX		*	O	R	M	I=[R]	D
	CBEX	A	*	R	O	M	I	D
**	D=D+1	A	*	R	O	M+1	I	D

	A=C	A	O	R	*	M	I	D
	PC=(A)		PC = [O]

*****************************************************************
*	Skipcodes
*****************************************************************

*****************************************************************
*	Skip code for binary integer, real, extended real,
*	complex, extended complex, ROM Pointer objects
*	and for secondaries, lists, symbolics, externals
*****************************************************************

SkCMP	D0=D0+	16	complex:		32
SkREAL	D0=D0+	6	real:			16
SkACPTR D0=D0+	10	acptr:			10
SkPTR	GONC	ObSked	seco,list,symb,unit:	0

SkECMP	D0=D0+	16	extended complex:	42
	D0=D0+	5
SkEREL	D0=D0+	16	extended real:		21
SkBINT	D0=D0+	5	binary integer: 	5
	GONC	ObSked

SkROMP	D0=D0+	6	ROM Pointer:		6
	GONC	ObSked

*****************************************************************
** Skip code for code, character string, hex string, array,
** linked array, extended, graphic, library, backup objects.
*****************************************************************

SkBODY	RSTK=C
	C=DAT0	A
	AD0EX
	A=A+C	A	D0=D0+<body length>
	AD0EX
	C=RSTK
	GONC	ObSked

*****************************************************************
** Skip code for identifier and temporary identifier
** and character objects.
*****************************************************************

SkID	RSTK=C
	C=0	A
	C=DAT0	B
	C=C+C	A	D0=D0+2+2*(#characters)
	AD0EX
	A=A+C	A
	AD0EX
	C=RSTK
SkCHAR	D0=D0+	2	char:			2
	GONC	ObSked

** CtrlWord? ****************************************************************
* Interface :	( $ --> hxs cancel caller | $ )
* Description :
* Calls :	SavPtr GetPtr =GETPTRLOOP ColaA
* Defines :	GPLoop
* Uses :	cToks
* Ed. Hist. :
*     1.000	05.07.1992	DM	alpha
*****************************************************************************

CtrlWord?
	PCode
* CPU			A	B	C	D	D0	D1	x
	GOSUB	SavPtr

	C=DAT1	A			->$
	D1=C							->$
	D1=D1+	5						->len

	C=DAT1	A			len
	C=C-CON A,5
	CSRB.F	A			chrs
	C=C-1	A			- 1
	GOC	GPLoop	    ** Null $ ?

	A=C	A	chrs-1
	LC(5)	7

	?A>C	A	    ** chrs > 8 ?
	GOYES	GPLoop

	B=A	B		chrs-1

	C=A	B			chrs-1
	A=A+A	A	* 2
	A=A+A	A	* 4
	A=A+C	A	* 5
	LC(5)	cToks			->cToks
	C=C+A	A			->->cTok
	D0=C						->->cTok
	C=DAT0	A			->cTok
	D0=C						->cTok

	C=0	A			0
	C=DAT0	1			cnt
	D0=D0+	1					->Tok

	D=C	B				cnt
	C=B	B			chrs-1
	C=C+C	B			* 2
	P=C	0
	P=P+1								P:n-1

	D1=D1+	5						->b$
	A=DAT1	WP	stmt
	CD0EX				->tok

StmtLp	D0=C
	C=DAT0	WP			tok
	?A=C	WP	    ** Stmt found ?
	GOYES	StmtFnd
	D0=D0+	5	    ** skip handler
	CD0EX
	C+P+1				->tok'
	D=D-1	B
	GONC	StmtLp

	P=	0

GPLoop	GOVLNG	=GETPTRLOOP

StmtFnd CD0EX				->tok
	C+P+1				->->handler
	D0=C						->->handl
	A=DAT0	A	->handl
	P=	0
=execrpltok
	GOSUB	GetPtr
	D1=D1+	5	    ** Drop $
	D=D+1	A
	D=D+1	A	    ** eg. ColaA
	GOTO	ColaA

** InTemp? ******************************************************************
* Interface :	( ob --> ob t/f )
* Description : Push TRUE if ob resides in TEMPOB area, else FALSE
* Calls :	SavPtr GPPshFLp =GETPTRTRUE
* Defines :	GPTLp
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

InTemp?
	PCode
* CPU			A	C	D0
	GOSUB	SavPtr	    *** Save RPL variables
	A=DAT1	A	&ob

	GOSUBL	D0=RAM
	CON(5)	=TEMPOB_G
	CON(5)	=TEMPOB

	C=DAT0	A		[TEMPOB]

	?A>=C	A	    *** &ob >= [TEMPOB] ?
	GOYES	ChkTop	    *** Yes - maybe in TEMPOB

NoTemp	GOTO	GPPshFLp

ChkTop	D0=(5)	(=addrTEMPTOP)+2
	C=DAT0	A
	D0=C

	C=DAT0	A		[TEMPTOP]
	?A>=C	A	    *** &ob >= [TEMPTOP]?
	GOYES	NoTemp	    *** Yes - not in TEMPOB

GPTLp	GOVLNG	=GETPTRTRUE

** Patch$ *******************************************************************
* Interface :	( $1 $2 #pos --> $' )
* Description : Patch $2 into $1 starting at pos
* Calls :	Pop# PopASP GPLoop
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*****************************************************************************

Patch$
	PCode
* CPU			A	C	D0	D1
	GOSUB	Pop#	pos

	A=A+A	A	(pos-1)*2
	C=A	A		offs
	RSTK=C
	GOSUB	PopASP	&src
	D0=A				&src
	A=DAT1	A	&dst
	C=RSTK			offs
	A=A+C	A
	D1=A
	D1=D1+	10				&to
	D0=D0+	5			&len[src]
	A=DAT0	A	len
	D0=D0+	5			&from
	A=A-CON A,5
	ASRB.F	A	cnt
	GONC	PaEntry     *** BET

PaLoop	C=DAT0	B
	DAT1=C	B
	D0=D0+	2
	D1=D1+	2
PaEntry A=A-1	A
	GONC	PaLoop
	GOTO	GPLoop

** Make$n *******************************************************************
* Interface :	( #n --> $ )
* Description : Make a string of length n-nibs
* Calls :	SavPtr Pop# Mk$n GpOwR0Lp
* Ed. Hist. :
*     1.000	18.02.1992	DM	alpha
*****************************************************************************

Make$n
	PCode
* CPU			A	C
	GOSUB	SavPtr
	GOSUB	Pop#	nibs
	C=A	A		nibs
	GOSUB	Mk$n
	GOTO	GpOwR0Lp

** IsObPCO? *****************************************************************
* Interface :	( ob --> ob t/f )
* Description : Return TRUE if ob is PCO, else FALSE
* Calls :	SavPtr =GPPushT/FLp
* Defines :	GpPshT/FLp
* Ed. Hist. :
*     1.000	18.02.1992	DM	alpha
*****************************************************************************

IsObPCO?
	PCode
* CPU			A	C	D1
	GOSUB	SavPtr
	A=DAT1	A	->ob
	D1=A				->ob
	C=DAT1	A		[ob]
	C=C-CON A,5
	?A=C	A
	GOYES	GpPshT/FLp
GpPshT/FLp
	GOVLNG	=GPPushT/FLp

** rs- **********************************************************************
* Interface :	( rs1 rs2 --> #rs1-rs2 )
* Calls :	SavPtr P#ALoop
* Ed. Hist. :
*     1.000	05.07.1992	DM	alpha
*****************************************************************************

rs-
	PCode
* CPU			A	C	D	D1
	C=DAT1	A		rs2
	D1=D1+	5				D'
	A=DAT1	A	rs1
	D1=D1+	5				D'
	D=D+1	A			M'
	D=D+1	A			M'
	A=A-C	A
	GOSUB	SavPtr
	GOLONG	P#ALoop
RPL

*****************************************************************************
*			ASSEMBLER
*****************************************************************************

** x->COD *******************************************************************
* Interface :	( $src --> code libdat )
* Description : Assemble a code object from given $
*	Type	Symb	Explane 	Example
*	----	----	------- 	-------
*	0	no	No Parameter	PC=(A), [ELSE] - ENDIF
*	1	no	fs/A Parameter	A=A+B	A, ASRB.F   WP, ?A#C   XS
*	1	no	logic w/  fs/A	A=A&C	A
*	2	yes	n - Parameter	P=	pRETRY	;  ABIT=0   bBIT
*	3	yes			GOVLNG	=SAVPTR ;  D0=(4)   Label1
*	4	yes	LA(n)/LC(n)	LC(5)	=VDISP
*	5	yes	REL(n) expr	REL(4)	label2
*	6	yes	CON(n) expr	CON(4)	=VDISP1
*	7	yes	REL GO label	GONC	laber1
*	8	no	LA/LC/NIB  ASC	LCASC	\LABER\
*	9	no	LA/LC/NIB  HEX	LCHEX	ABC
*     * B	yes	Reserved for std macros
*     * C	yes	IF expr
*	D	no	Predefined Macros : LOOP  ** MOVED TO TYPE 0 **
*	E	yes	EQU  expr	Label	EQU   =ADISP
*	F	yes	GOYES/RTNYES
* Modifies :
* Uses :
* Defines :
* Calls :	Report?: RepLine RepLine# RepPLines
* Ed. Hist. :
*     0.000 12.07.1992	RH	Included : types 0 ; 1 ; 4 ; 6 ; 8 ; 9.
*	    15.07.1992	RH	Included : types A ; B .
*	    16.07.1992	RH	Start	 : type  5 . Fix types 4 ; 6 . Pack
*	    18.07.1992	RH	Reorder code . Fix 1,4,6 ; Doc "asOPC&Par"
*	    21.07.1992	RH	ALL NON-SYMB Opcodes with  fs/A/B/d  Par run
*				 through here ! So types 4 and 6 are obsolete
*	    24.07.1992	RH	SYMBOLIC Checking routine
*	    25.07.1992	RH	Include SYMBOLIC Parser
*	    26.07.1992	RH	Running offset ; Automatic Update of SYMB$
*	    28.07.1992	RH	Type  7 ; Fixes
*	    30.07.1992	RH	Types  2 ; 3 ; 4 ; Fix	asGThxs
*	    31.07.1992	RH	GOYES/RTNYES ; Reverse write order in $>hxs
*     1.000 01.08.1992	RH	Assembler works fine
*	100 14.08.1992	RH	NOW it works FINE !
*	200 27.08.1992	DM	Changed a lot...
*****************************************************************************

DEFINE	@AsPass 	INDEX@

ASSEMBLE

** Assembler CPU flags **

GETEQU	EQU	2
OUTRNG	EQU	3
asSVAL	EQU	4

	XNAME	COD
RPL
::
    CK1 CKRPLInst
    NStrCseErr

    LABEL	GenLAM
    ::
	1LAMBIND
					( *Assembler vars* )
	ZEROZERO			( *LoC, AsLin#* )
	HXS 5 0 TOTEMPOB		( *AsSymTab* )
	ZEROZERO			( *AsLabVal, AsLoC* )

	FALSE ZERO			( *AsTmp,comp#* )
	#ZERO#ONE			( *INest,pos* )
	1GETABND			( *src* )
	GetRPLTab			( *RPLTab,ExRPLTab* )

	' NULLLAM ASLAMS NDUPN DOBIND
    ;

    ExecExt: DoAss

	RomID @AsSymTab ABND
	TWO P{}N			( --> code {labs} )
	DUP OSIZE #5-			( --> code {} #sz )
	{}#>Ld				( --> code LibDat )
;


LABEL	DoAss
::
    NULLHXS TOTEMPOB			( --> hxs )

    TWO
    #1+_ONE_DO (DO)
	"Assembler Pass " @AsPass #>$ &$
	@AsPass #2= ITE
	::  @AsLin# SWAP RepPLines
	    DROP
	;
	    RepLine

	ZEROZERO !AsLin# !AsLabVal
	@LoC !AsLoC

	IgnoreOff
	fCJump fLabel fIF
	THREE
	ZERO_DO (DO)
	    ClrF
	LOOP

	LABEL	DoAssLp
	    ?ATTNQUIT
	    AsDoLine
	?GOTO DoAssLp
					( --> .. hxs )
	fCJump TstF case AsMRGErr

	IF? ?SKIP SKIP2 "ENDIF Expected" XError

	@AsPass #1= IT
	::  ONE !pos			( *reset pos* )
	    @LoC @AsLoC
	    #=case ExitAtLOOP		( *no code assembled, all done* )
	;
    LOOP

    [#] DOCODE ChgType			( --> code )
;


LABEL	AsDoLine
::
    NextLine NOTcaseFALSE

    AsAssLine

    DUP LENHXS @AsLoC #+ !AsLoC 	( *Correct location counter* )

    @AsPass #1= ITE_DROP !append$	( *Ignore pass 1 result* )

    TRUE				( *Signal continue* )

    fLabel TstF NOT?SEMI
				( *Append new value for symbol to AsSymTab* )
    fLabel ClrF

    @AsSymTab				( --> .. hxs F hxsSt )
    @AsLabVal				( --> .. hxs F hxsSt hxsV )
    DUP LENHXS #>Hxs[1]-1		( --> .. hxs F hxsSt hxsV hxsL-1 )
    SWAP&$ &$ !AsSymTab
;


LABEL	AsAssLine
::					( --> hxs {} # )
    @AsLin# #1+
    Report?: RepLine#
    !AsLin#

    #1= IT AsDoLab			( *Line starts with text* )

    DUPNULLCOMP? casedrop NULLHXS	( *No mnemo/param* )

    DUP CARCOMP 			( --> .. {} $mnem )

    DUPONE SUB$1# FORTYTWO #=case	( *Comment* )
    ::	2DROP NULLHXS
    ;

    aOpcodes case AsIMnErr
					( --> .. {} hxsOpc #typ )
    Ignore? case AsDoIgn

    fCJump TstF case AsTyF		( *Last mnemo ?xxxx,* )

    DUP#0=csedrp AsTy0

    ELEVEN #=casedrop AsTyB

    ROT TWO NTHELCOMP			( --> .. hxsOpc #typ $para )
    NOTcase AsMPaErr

    {	AsTy1 AsTy2 AsTy3 AsTy4 AsTy5
	AsTy6 AsTy7 AsTy8 AsTy9 AsTyA
	AsTyC AsTyE
    }
    {	ONE TWO THREE FOUR FIVE
	SIX SEVEN EIGHT NINE TEN
	TWELVE FOURTEEN
    }

    4ROLL				( --> .. hxsOpc $para {} {} #typ )
    ' #= POSCOMP NTHELCOMP

    NOTcase
    LABEL	AsIMnErr
    ::
	"Inv. Mnemonic" AError
    ;

    EVAL ?SEMI

    "Inv. Parameter"

    LABEL	AError
    ::
	CHR_: >T$ APPEND_SPACE
	@AsTmp !append$ XError
    ;
;


LABEL	AsDoLab
::
    @AsPass #2=
    Ignore? ORcase CDRCOMP		( *Ign. labs in pass 2 or IF* )

    @AsSymTab OVER CARCOMP		( --> .. {} st $ )

    AsL$>Lh &HXS			( --> .. {} st hxsLabLen )

    OVER AsInSym$? ?SKIP SKIP2		( --> .. {} st hxsEQU )
    "Duplicate Label" AError

    !append$ AsSym1+			( --> .. {} st' )
    !AsSymTab				( --> .. {} )

    @AsLoC #>HXS !AsLabVal
    fLabel SetF

    CDRCOMP				( --> .. {}' )
;


LABEL	AsTyF				( *want Type F: GOYES/RTNYES* )
::
    fCJump ClrF

    FIFTEEN #<>case			( *Actual isn't G/R* )
    LABEL	AsMRGErr
    ::
	"GOYES/RTNYES Expected" AError
    ;
					( --> .. {} hxsOpc )
    HXS># #0= casedrop HXS 2 00 	( *Is RTNYES* )
					( --> .. {} )
    TWO NTHELCOMP NOTcase
    LABEL	AsMPaErr
    ::
	"Parameter Expected" AError
    ;
					( --> .. $para )
    ASParse @AsLoC AsGY/RY ?SEMI

    "GOYES out of Range" AError
;


LABEL	AsDoIgn 		( *IF, just looking for ELSE/ENDIF* )
::
    ROTDROP NULLHXS UNROT		( --> .. hxs hxsOpc #typ )

    #0<> caseDROP			( *Can't be E/E* )

    HXS>#
    FIFTEEN #=casedrop			( *ENDIF* )
    ::
	IgnoreOff
	fIF ClrF
    ;

    NINE #=casedrop IgnoreOff		( *ELSE* )

    DROP				( --> .. hxs )
;


LABEL	AsTy0			( *Type 0: no parameter & predef. macro's* )
::
    SWAPDROPDUP HXS>#			( --> .. hxsOpc #opc )

    FIFTEEN #=casedrop AsEndif
    NINE #=casedrop AsElse

    DROP				( --> .. hxsOpc )
;


LABEL	AsEndif
::
    IF? IT SKIP2 "ENDIF w/o IF" XError

    DROP IgnoreOff
    fIF ClrF
    NULLHXS
;


LABEL	AsElse
::
    IF? IT SKIP2 "ELSE w/o IF" XError

    DROP NULLHXS

    Ignore? case IgnoreOff
    IgnoreOn
;


LABEL	AsTyB			( *Type B: ?MP=0, ?SB=0, ?SR=0, ?XM=0* )
::
    SWAPDROP				( --> .. hxsOpc )
    fCJump SetF
;

** NextLine *****************************************************************
* Interface :	( --> #type {} T )
*		( --> F )
* Description : #type : 1 Line starts with text
*			0 Line starts with whitespace
* Uses :	src pos
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsChkEOS
::
    @INest				( --> .. hxs $t # )
    DUP#0=csedrp DROPFALSE
    #1- !INest				( --> .. $ # hxs $t )
    DROPSWAP !pos SWAP !src		( --> .. hxs )
    COLA NextLine
;


LABEL	NextLine
::
  LABEL NxtLin

    ALttt @src @pos GetNextToken	( --> .. hxs hxs[ttt] $ #pos' $t )
    SWAP !pos UNROT2DROP		( --> .. hxs $t )

    DUPNULL$? case AsChkEOS

    DUPONE SUB$1# FORTYTWO #=		( *Comment* )
    casedrop NextLine

    Report?:
    LABEL	Dsp$TRep
    ::	DUP DispTRep
    ;

    DUP !AsTmp				( *Used by AsTy8* )
    DUP asType SWAP			( --> .. hxs # $t )

    AsSplit				( --> .. hxs # $t1 .. $tn #n )

    DUP#0<> ?GOTO NlGo1 		( *Line Empty* )
	2DROP GOTO NxtLin		( --> .. hxs )

    LABEL	NlGo1

    {}N SWAPTRUE			( --> .. hxs #t {} #t T )
;


LABEL	AsSplit 			( $ --> $t1 .. $tn #n )
::
    ZEROSWAP Cttt SWAPONE		( --> .. hxs # #0 ttt $t #1 )

    LABEL	AsSLp
	GetNextToken
	DUPNULL$? ?GOTO AsSEx		( --> .. #n ttt $t #' $wd )
	5UNROLL 4R#1+4UNR
	GOTO AsSLp

    LABEL	AsSEx

    4DROP				( --> .. hxs # $t1 .. $tn #n )
;


LABEL	    ALttt
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)	alttt
	NIBHEX	1111111111011011111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
alttt
RPL


LABEL	asType
ASSEMBLE
	PCode

	GOSUBL	PopASpRd$

	A=DAT1	B

	LCASC	\ \
	?A=C	B
	GOYES	asIsSpc

	LCHEX	09
	?A=C	B
	GOYES	asIsSpc

	A=0	A
	A=A+1	A
	GONC	asP#AL

asIsSpc A=0	A
asP#AL	GOLONG	P#ALoop
RPL

** #>Hxs[1]-1 ***************************************************************
* Interface :	( # --> hxs[1]-1 )
* Calls :	Pop#SP PshHxsLp
* Ed. Hist. :
*     0.000 28.08.1992	DM
*****************************************************************************

LABEL	#>Hxs[1]-1
ASSEMBLE
	PCode
	GOSUBL	Pop#SP
	A=A-1	P
	GOLONG	PshHxsLp
RPL

** {}>Ld ********************************************************************
* Interface :	( {} #sz --> LibDat )
* Calls :	Pop# loop
* Ed. Hist. :
*     0.000 28.08.1992	DM
*****************************************************************************

LABEL	{}#>Ld				( {} #sz --> LibDat )
ASSEMBLE
	PCode
* CPU			A	C	D1
	GOSUBL	Pop#	sz		->stk
	C=A	A		sz
	RSTK=C		** Save size
	A=DAT1	A	->{}
	AD1EX		->stk		->{}
	LC(5)	=DOEXT0 	LD
	DAT1=C	A	** {}prlg becomes LDprlg
	D1=D1+	5			->#prlg
	C=RSTK			sz
	DAT1=C	A	** #prlg becomes length
	D1=A				->stk
	GOLONG	loop
RPL

*** ASParse *****************************************************************
* Interface :	( $ --> hxs | error out )
* Description : Assembler parser entry
* Calls :	APterm
* Ed. Hist. :
*     1.000	27.01.1993	DM	alpha
*****************************************************************************

LABEL	ASParse
::
    ZEROSWAP solverTTT SWAPONE		( --> #0 ttt $ #1 )
    GetNextToken			( --> #0 ttt $ #n $t )

    ::	APterm !*triand 		( --> [] ttt $ #n $t )
	RDROP 4DROP
	::NEVAL 			( --> hxs )
    ;

    4DROP 1LAMBIND
    DROPNDROP
    1GETABND
					( tokIVLSYMB )
    "Expr" IError
;

*** APterm ******************************************************************
* Interface :	[]  ttt $ #n -->
*		[]  ttt $ #n  $  FALSE
*		[]' ttt $ #n' $' TRUE FALSE
*		[]' ttt $ #n' $' TRUE TRUE
* Description : Term parser
* Calls :	APfact
* Ed. Hist. :
*     1.000	27.01.1993	DM	alpha
*****************************************************************************

LABEL	APterm
::
    APfact !*triand

  LABEL APcknul

    nultrior completed

    tok/ tok8trior			( divide )
    ::	APfact !*triand APapndit: bit/
    ;
    tok: tok8trior			( modulo )
    ::	APfact !*triand APapndit:
	::  2DUP bit/ bit* bit-
	;
    ;
    tok* tok8trior			( multiply )
    ::	APfact !*triand APapndit: bit*
    ;

    tok+ tok8trior			( add )
    ::	APterm !*triopt APapndit: bit+
    ;
    tok- tok8trior			( subtract )
    ::	APterm !*triopt APapndit: bit-
    ;
    "!" tok8trior                       ( and )
    ::	APterm !*triopt APapndit: bitAND
    ;
    "|" tok8trior                       ( or )
    ::	APterm !*triopt APapndit: bitOR
    ;
    tok^ tok8trior			( xor )
    ::	APterm !*triopt APapndit: bitXOR
    ;

    FALSE
;

*** APapndit: ***************************************************************
* Interface :	[] ttt $ #n $  --> []' ttt $ #n $
* Description : Quote and drop R, append the object and check for next op
* Ed. Hist. :
*     1.000	27.01.1993	DM	alpha
*****************************************************************************

LABEL	APapndit:
::
    'RRDROP apndit GOTO APcknul
;

*** APfact ******************************************************************
* Interface :	[]  ttt $ #n -->
*		[]  ttt $ #n  $  FALSE
*		[]' ttt $ #n' $' TRUE FALSE
*		[]' ttt $ #n' $' TRUE TRUE
* Description : Factor parser
* Defines :	APNoSym
* Calls :	APexpr APlabel APgetlabel AsL$>Lh AsSymEVAL
* Uses :	AsSymTab
* Ed. Hist. :
*     1.000	27.01.1993	DM	alpha
*****************************************************************************

LABEL	APfact
::
    toksharp tok8cktrior
	Bitstream

    realPA !*trior			( --> [o] [v]' ttt $ #n' $' )
    ::	6ROLL %># 6UNROLL
	completed
    ;

    tok= tok8trior APlabel

    toklparen tok8trior
    ::	APterm !*triopt
	tokrparen COLA !*Tok
    ;

    tok- tok8trior
    ::	APfact !*triand
	'Rapndit bitneg
	completed
    ;

    tokquote tok8trior
    ::	APfact !*triand
	'Rapndit bitNOT
	completed
    ;

    APgetlabel

    DUP AsL$>Lh &HXS @AsSymTab
    AsSymEVAL NOTcasedrop
    ::	@AsPass #1=case
	::  DROPZERO #>HXS apndit
	    completed
	;

	LABEL	APNoSym
	::
	    "Unknown Symbol" CError
	;
    ;

    UNROT2DROP apndit
    completed
;

*** APlabel *****************************************************************
* Interface :	[]  ttt $ #n  $  -->
*		[]' ttt $ #n' $' TRUE TRUE
* Description : Label parser
* Defines :	APgetlabel
* Calls :	Entry? Builtin? APNoSym
* Uses :	RPLtab ExRPLTab APttt
* Ed. Hist. :
*     1.000	27.01.1993	DM	alpha
*****************************************************************************

LABEL	APlabel
::
    LABEL	APgetlabel
    ::
	APttt swapoutTTT
	DUP1LAMBIND
	solverTTT swapinTTT
	1GETABND
    ;

    ::	@RPLTab ExRPLTab? Entry?
	BuiltIn?
	APNoSym
    ;

    apndit				( --> [v]' ttt $ #n' $' )
    completed
;

LABEL	APttt
ASSEMBLE
	CON(5)	=DOHSTR
	REL(5)	apttt
	NIBHEX	0000000000000000000000000000000101111111341111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
	NIBHEX	1111111111111111111111111111111111111111111111111111111111111111
apttt
RPL

** AsL$>Lh ******************************************************************
* Interface :	( $Label --> hxsLEN hxsLABEL )
* Description : Max: 8 Nibs + Count
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsL$>Lh
ASSEMBLE
	PCode

	GOSUBL	PopASpRd$
	LCHEX	8
	?A>C	P
	GOYES	as$OoR
	C=A	P
as$OoR	C=C+C	P
	C=C-1	P
	RSTK=C
	P=C	0
	A=DAT1	WP
	R2=A
	P=	0
	A=C	P
	GOSUB	PshHxs
	GOSUBL	SavPtr
	A=R2
	C=RSTK
	P=C	0
	GOLONG	PshHxsLp
RPL

** AsInSym$? ****************************************************************
* Interface :	( hxsLab hxsSymT --> hxsLab T/F )	 ST1=0
*		( hxsLab hxsSymT --> hxsLab hxsEQU T/F ) ST1=1
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsInSym$?
ASSEMBLE
	PCode

	ST=0	GETEQU		Flag RETURN EQUATE
	GOTO	AsInSym

AsSymEVAL
	PCode

	ST=1	GETEQU
AsInSym CD1EX
	D1=C
	RSTK=C			** Save DSKTOP **
	GOSUBL	PopASpRd$	** D1= &LenNib **
	C=RSTK
	D0=C
	D0=D0+	5		** D0= &Level2 **
	A=DAT0	A
	D0=A			** D0= &Ob2 **
	D0=D0+	10		** SKIP HEAD & Len **
	C=DAT0	1		** Len Nib **
	D0=D0+	1		** SKIP **
	B=0	A
	B=C	P		** Len Nib **
	P=C	0
	A=DAT0	WP		** HXS DATA **
	C=DAT1	A
	D=C	A
	D=D-1	A
	GOC	asNOTinS	** NO Entries ? **
	D1=D1+	5		** Skip #Entries field , move to 1st DATA **

asSYMLP1
	C=0	A
	C=DAT1	1		** Get SYMBLen **
	D1=D1+	1		** D1= &SYMB$ **
	P=C	0		** P= Nibs to read **
	?B#C	B
	GOYES	asNXTE0 	** Go to Next Entry **
*				** Same Len **
	C=DAT1	WP
	?A#C	WP		** NOT Same word ? **
	GOYES	asNXTE0

	CD1EX
	C+P+1
	D1=C			** D1= &EQUATE Len Nib **

	C=DAT1	1
	D1=D1+	1
	?ST=0	GETEQU
	GOYES	asGOTNM
	GOTO	asGOTIT

asNXTE1 P=C	0
	CD1EX
	C+P+1
	D1=C
	D=D-1	A		** Entries count **
	GONC	asSYMLP1

asNOTinS
P0gpPshFLp
	P=	0
	GOVLNG	=GPPushFalse *** Get RPL regs, push FALSE, dispatch

asNXTE0 CD1EX
	C+P+1
	D1=C			** D1= &EQUATE Len Nib **
	C=DAT1	1
	D1=D1+	1
	GONC	asNXTE1

asGOTIT
	P=C	0
	A=DAT1	WP
	GOSUB	PshHxs
	GOSUBL	SavPtr
asGOTNM P=	0
	GOLONG	GPTLp

PshHxs	GOVLNG	=PUSHhxs
RPL

** AsSym1+ *******************************************************************
* Calls :	loop
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsSym1+
ASSEMBLE
	PCode

asINC1	C=DAT1	A
	CD1EX
	D1=D1+	10
	A=DAT1	A
	A=A+1	A
	DAT1=A	A
	D1=C
	GOLONG	loop
RPL

** AsTy1 ********************************************************************
* Interface :	( hxsOpc $par --> hxsOpc' T | F )
* Description :
*	Type 1: MNEMO'S WITH  fs/A  Parameter  Aa0-FF. Opcodes from 8A0-8Bf;
*		9A0-9BF fall through here too and, additionally set flag to
*		mark next step to be a GOYES/RTNYES
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy1
ASSEMBLE
	PCode
*				A	B	C	D	D1
*			SWAP
	A=DAT1	A
	D1=D1+	5
	C=DAT1	A
	DAT1=A	A
	D1=D1-	5
	DAT1=C	A

	GOSUBL	asOPC&Par	len	0	1  R2=_xC (or _xD or _xE or _xF)
	A=R2
	P=	0
	LCHEX	A8		** Tests **
	GONC	astst818
	GOTO	asOKTp1 	** Parameter in range **

************************************************
* Entry for : 158x - 15Fx	DATd
*	      818frn		r=r+CON fs,n
*
************************************************
astst818
	P=	1
	LCHEX	81
	P=	2
	?A=C	WP		** Test for nrf818 **
	GOYES	asrd1
	P=	0
	LCHEX	1
	?A=C	P
	GOYES	asDATd
	GONC	asf1		** NOT 818 , push FALSE **

************************************************
* DATd
************************************************
asDATd	?ST=1	2
	GOYES	asa_f
	A=DAT1	B
	GOSUBL	as1_9
	GOC	as1_Fxt
	GONC	asf1		** Alias for asFout **

asa_f	GOSUBL	asA_F
	GONC	asf1

as1_Fxt A=R2
	ABIT=1	11
	GOTO	asDATn

************************************************
* r=r+CON  fs,n
************************************************
asrd1	D1=D1-	10		** Maybe , test parameters .. fs,n **
	AD1EX
	GOSUBL	Read$	len	len	?		&$Chr1
	C=0	A
	LCHEX	6				6
	?A<C	A
	GOYES	as?818
asf1	GONC	asF1		** Parameter length out of range **

as?818	LCHEX	3				3
	?A<C	P
	GOYES	asF1		** Same as above **
	C=A	P				len
	D=C	A		** Save len **
	C=C+C	P				len*2
	C=C-1	P				(len*2)-1
	P=C	0
	A=DAT1	WP		** Read complete parameter $ **
	ST=0	1		**\
	P=	0		** > Prepare for fs check **
	B=0	A		**/
	GOSUBL	asAPar? 	** Routine runs through asXPar **
	GONC	asF1		** NOT found **
	P=	0
	ASRC			**
	ASRC			** Shift away fs Char **
	LCASC	\,\				__2C
	?A#C	B		** IFF NOT \,\ **
	GOYES	asF1		** THEN push FALSE **
	ASRC
	ASRC
	D=D-CON A,4					len-4
	GONC	as?A_F		** len = 4 : n>9 **
	GOSUBL	as1_9
	GOC	asOK818

asF1	GOTO	asFout

as?A_F	D1=D1+	4						D1:&$n
	GOSUBL	asA_F
	GONC	asF1

asOK818 A=R2
	?ST=0	1
	GOYES	as818A		** "A" Par **
	P=	0
	?B=0	P		** "P" Par ? **
	GOYES	asF1
	LCHEX	4
	?B=C	P		** "S" Par ? **
	GOYES	asF1
	C=B	P
	P=C	0
	C=P	3
	P=	3
	A=C	P		** fs Nib : A[3]:= B[0] **

as818A	BSLC
	BSLC
	P=	5
	A=B	P		** n Nib : A[5]:= B[3] **
	GOTO	asPNout

************************************************
* Entry for : 0Ea0 - 0EFF	r=r&s	fs
*	      140 - 157a	DATfs
*	      819fr		rSRB.F	fs
*	      81Afrn		ss=r.F	fs
*	      8A0yy-8BFyy	?r=s	A
*	      9a0yy-9bFyy	?r=s	fs
*	      Aa0 - FF		Arithmetic
*
************************************************
asOKTp1 ?A=C	P		** _8 ? **
	GOYES	asis8X		** Any __8 Opcode **
	GONC	asisN8		** Normal NOT __8 **

asis8X	P=	1		**  **
	?A=C	WP		** = _A8 ? **
	GOYES	asis?8
	C=C+1	P
	?A#C	WP		** # _B8 ? **
	GOYES	astst81

asis?8	?ST=1	1
	GOYES	as8fs
	GONC	asa3

as8fs	BSLC
	?ABIT=0 4
	GOYES	asis_a		** a group **
	LCHEX	8
	B=B+C	P

asis_a	A=B	P
	P=	2
	A=A+1	A		** __8 --> __9 **

asa3	GOSUB	asGOYF		** Set User flag 1  , CC **
	GONC	asA3

astst81 LCHEX	F81		** _818 **
	P=	3
	?A#C	WP		** IF it's NOT a 818frn **
	GOYES	asN818		** THEN GO further testing .. **
	GOTO	asFout		** ELSE it is a WRONG Arg count ! **

************************************************
* rSRB.F fs  ;	ss=r.F fs  (and vice versa)
************************************************
asN818	BSLC
	BSLC
	BSLC
	A=B	P
	P=	2
	C=C+1	P		** 918 **
	?A=C	P
	GOYES	as819_A
	P=	5
	GONC	as81A_A
as819_A P=	4
as81A_A ?ST=0	1		** \A\ Par ? **
	GOYES	asAN		** Take std value **
	GONC	asPNout 	** B.E.T. ; Take new value **

************************************************
* A=A&B fs  ;  A=A!B fs
************************************************
asisN8	?A#0	P		** NOT a Logical (0Ean) ? **
	GOYES	asisN0
	?ST=0	1		** Logical **
	GOYES	asA4
	P=	2
	BSLC
	BSLC
	A=B	P
asA4	P=	3
aspnout GOTO	asPNout 	** BET **

asisN0	LCHEX	1
	?A=C	P
	GOYES	asDATfs 	R2=_x41
	GONC	asisN1

************************************************
* DATfs
************************************************
asDATfs ?ST=1	1
	GOYES	aststB

asA3	P=	2		** BET **
	GOTO	asPNout

aststB	P=	0
	LCHEX	6
	?B#C	P		** No \B\ Parameter ? **
	GOYES	aststFS
	ABIT=1	11
	GONC	asA3
aststFS BSLC
	BSLC
	BSLC
	A=R2		x41
asDATn	P=	1	x51	n
	A=A+1	P
	P=	3
	A=B	P	nx51
	GONC	asPNout 	** BET **

************************************************
* General output point
************************************************
asA2	P=	1
asAN	A=R2

asPNout GOSUB	PshHxs
	GOLONG	PTLoop

asFout	GOLONG	P0gpPshFLp

asGThSP GOSUB	asGThxs
	GOLONG	SavPtr

************************************************
* Bit 5 determines A or B opcode
* Bit 4 determines a or b group
*
* fs	A	7x54xxx0
*-----------------------
* Aa0	C0	xx00xxxx
* AaF	CF	xx00xxxx
* Ab0	D0	xx01xxxx
* AbF	DF	xx01xxxx
* Ba0	E0	xx10xxxx
* BaF	EF	xx10xxxx
* Bb0	F0	xx11xxxx
* BbF	FF	xx11xxxx
************************************************
asisN1	?ST=0	1	** \A\ Parameter ? **
	GOYES	asA2
	ASLC		XX_
	P=	0
	LAHEX	A	XXA
	?ABIT=0 5
	GOYES	as#A
as#B	A=A+1	P
as#A	P=	1
	?ABIT=0 4
	GOYES	asaPar
asbPar	LAHEX	8
	GONC	asParOK

asGOYF	GOSUBL	D0=RAM
	CON(5)	(=UserFlags_G)+14
	CON(5)	(=UserFlags)+14

	C=DAT0	B
	CBIT=1	1
	DAT0=C	B		** Set flag 58 **
	RTNCC

asaPar	A=0	P

asParOK BSLC
asPar+	A=A+B	P
	GOTO	asA3
RPL

** AsTy2 ********************************************************************
* Description : Type 2: rBIT=x	WITH  n  (SYMB) Parameter
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy2
::
    ASParse asTy2
;


** ( hxsOPC hxsSYMB --> hxsOPC' T )
** ( hxsOPC hxsSYMB --> F )

LABEL	asTy2
ASSEMBLE
	PCode
*				A	B	C	D	D1
	ST=0	OUTRNG
	P=	4
	GOSUB	asGThxs 	valSYMB
	R0=A
	GOSUB	asGThSP 	hxsOPC
	C=R0
	B=C	A			valSYMB
	C=0	A
	P=	0
	LCHEX	1
	?A#C	P
	GOYES	as2?
	B=B-1	A
	GONC	astst1n

astst1n LCHEX	F
	?B<=C	A
	GOYES	asOOnXT
	ST=1	OUTRNG

asOOnXT P=	2
asOOOnX BSLC
as2XT	BSLC
	A=B	P
	GOTO	asJMPOUT

as2?	LCHEX	F
	?B<=C	B
	GOYES	as2??
	ST=1	OUTRNG

as2??	LCHEX	2
	?A#C	P
	GOYES	asOOn??
	P=	1
	GOTO	as2XT

asOOn?? LCHEX	68				68
	?A<C	B
	GOYES	as83??
as8?n	GOSUB	asGOYF
	GOTO	asOOnXT
as83??	P=	1
	?A=0	P
	GOYES	as80n?
	LCHEX	3
	?A>C	B
	GOYES	asOOnXT
	?A=C	B				38
	GOYES	as8?n
	GONC	asOOnXT 	** Can only be	82n (CLRHSN n) **

as80n?	P=	2
	LCHEX	8
	?A=C	P
	GOYES	as808xn
	P=	3
asOOOOn BSLC
	GOTO	asOOOnX

as808xn ?ABIT=0 13
	GOYES	as808!
	GOSUB	asGOYF
as808!	P=	4
	BSLC
	GOTO	asOOOOn
RPL

** AsTy3 ********************************************************************
* Description : Type 3: ABS	GO     WITH  SYMB Parameter
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy3
::
    ASParse asTy3
;


** ( hxsOPC hxsSYMB --> hxsOPC' T )
** ( hxsOPC hxsSYMB --> F )

LABEL	asTy3
ASSEMBLE
	PCode
*				A	B	C	D	D1
	P=	4
	GOSUB	asGThxs 	valSYMB
	R0=A
	GOSUB	asGThSP 	hxsOPC
	ST=0	OUTRNG
	C=R0
	B=C	W			valSYMB
	P=	0
	?ABIT=1 0
	GOYES	asDn=x
asDn=5	P=	6
asDn<5	BSLC
	BSLC
	B=A	B
	GOTO	asmkOPC

asDn=x	?ABIT=0 4
	GOYES	asDn=4
	?ABIT=1 5
	GOYES	asDn=5
	P=	3
	GOTO	asDn<5
asDn=4	P=	5
	GOTO	asDn<5
RPL

** AsTy4 ********************************************************************
* Description : Type 4: LA(n)/LC(n)	SYMB
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy4
::
    ASParse asTy4
    &HXS TRUE
;


** ( hxsOPC hxsSYMB --> hxsOPC' T )
** ( hxsOPC hxsSYMB --> F )

LABEL	asTy4
ASSEMBLE
	PCode
*				A	B	C	D	D1
	P=	15
	GOSUB	asGThxs 	valSYMB
	R0=A
	P=	4
	GOSUB	asGThxs 	hxsOPC
	D1=D1-	5
	D=D-1	A
	GOSUBL	SavPtr
	C=R0
	B=C	W			valSYMB
	C=A	A
	?CBIT=0 1
	GOYES	asLAn
	P=C	1
	GOTO	asLA!C
asLAn	P=C	4
asLA!C	A=B	WP
	GOLONG	PshHxsLp
RPL

** AsTy5 ********************************************************************
* Description : Type 5: REL(n)	 WITH  SYMB Parameter
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy5
::
    ASParse SWAP @AsLoC asTy5
;


**  STACK : hxsVALUE(SYMB)  hxsLENSYMB	#CURR.Offset --> hxsOPCD' T  / F **

LABEL	asTy5
ASSEMBLE
	PCode
*				A	B	C	D	D1
	GOSUBL	Pop#		C.Ofs				&NEW_L1
	R0=A
	P=	0
	GOSUB	asGThxs 	lenSYMB
	R1=A
	A=DAT1	A
	AD1EX
	D1=D1+	5
	C=DAT1	A
	D1=D1+	5
	C=C-CON A,6
	P=C	0
	C=0	W
	C=DAT1	WP
	D1=A
	A=C	WP
	D1=D1+	5
	D=D+1	A
	GOSUBL	SavPtr
	B=A	A			valSYMB
	C=R1
	P=C	0
	C=R0
	D=C	A					Curr_Ofs
	D=D-1	A

asJMPOPC
	GOSUB	asJMP+-
	BSRC
	GOTO	asmkOPC
RPL

** AsTy6 ********************************************************************
* Description : Type 6: CON(n)	 WITH  SYMB Parameter
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy6
::
    ASParse asTy6 TRUE
;


** ( hxsOPC hxsSYMB --> hxsOPC' T )
** ( hxsOPC hxsSYMB --> F )

LABEL	asTy6
ASSEMBLE
	PCode
*				A	B	C	D	D1
	P=	7
	GOSUB	asGThxs 	valSYMB
	R0=A
	GOSUB	asGThSP 	hxsOPC
	C=R0
	ACEX	WP			 valSYMB
	P=C	0
	GOLONG	PshHxsLp
RPL

** AsTy7 ********************************************************************
* Description : Type 7: REL	GO     WITH  SYMB Parameter
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy7
::
    ASParse @AsLoC asTy7
;


**  STACK : hxsOPCD  hxsVALUE(SYMB)  #CURR.Offset --> hxsOPCD' T  / F **

LABEL	asTy7
ASSEMBLE
	PCode
*				A	B	C	D	D1
	GOSUBL	Pop#		C.Ofs				&NEW_L1
	ST=0	OUTRNG
	R0=A
	P=	4
	GOSUB	asGThxs 	valSYMB
	R1=A
	P=	0
	LAHEX	4
	?C>=A	P
	GOYES	asinR1
	ST=1	OUTRNG

asinR1	P=	1
	GOSUB	asGThSP

asinR2	C=R1
	B=C	A			valSYMB
	C=R0
	D=C	A					Curr_Ofs
	C=0	A
	P=	0
	LCHEX	6
	?A<C	P
	GOYES	as45
	?A>C	P
	GOYES	as7?
	GONC	as67		** BET **
as45	P=	1
	GOTO	asGO456 	** BET **

as7?	C=C+1	P
	?A#C	P
	GOYES	as8C!E?
	D=D+CON A,3
as67	P=	2

** 4hh , 5hh , 6hhh and 7hhh  are treated the same way **

asGO456 GOSUB	asJMP+-
	P=	0
	B=A	P
	P=	2
	?ABIT=0 1		** #Opcd < 6 ? **
	GOYES	asmkOPC
	P=	3
asmkOPC A=B	WP

asJMPOUT
	GOSUBL	PshHxs

** INDEX@ !!!!
	GOSUB	asindex

	A=A-1	A
	A=A-1	A	SET CARRY IFF IT WAS #1
	GOC	asRGok

	?ST=0	OUTRNG
	GOYES	asRGok
asRGok	GOLONG	PshTFL

as8C!E? P=	3
	?ABIT=0 5		** LONG RELATIVE JUMPS **
	GOYES	as8C
as8E	D=D+CON A,4

as8C	D=D+1	A		** Adjust ofs to 3rd nib **
	GOSUB	asJMP+-
	BSLC
	P=	1
	B=A	WP
	P=	5
	GOTO	asmkOPC

**************************
* The jump offset maker  *
**************************
* CPU			A	B	C	D	P
*				dst	curr	curr-1	len-1

asJMP+- ST=0	OUTRNG
	CDEX	A				curr-1
	C=C+1	A			curr
	?B>C	A	    ** dst > curr
	GOYES	asJMP+

	B=C-B	A		curr-dst
	C=B	A			offs
	D=C	A				offs
	B=-B	A		-offs

	C=0	A			0
	LCHEX	8			8..0

	?D<=C	A	    ** offs < max
	GOYES	asJMPok
	ST=1	OUTRNG

asJMP+	B=B-C	A
	C=0	A
	LCHEX	8
	?B<C	A
	GOYES	asJMPok
	ST=1	OUTRNG

asJMPok BSLC
	RTNCC

asGThxs A=0	W
	C=DAT1	A				&hxsVAL
	CD1EX					&NEW_L1 	&hxsVAL
	RSTK=C		** Save D1 **
	D1=D1+	5						&hxsLEN
	C=DAT1	A				hxsLEN
	D1=D1+	5						&hxsDATA
	A=DAT1	WP		hxsDATA
	C=RSTK
	D1=C
	D1=D1+	5	* POP ITEM *				&NEW_L1
	D=D+1	A	* ADJUST M *			MEM+1
	RTNCC

** INDEX@ !!!!
** --> A[A]: index
** Uses : C[A] ; D1 ; RSTK

asindex CD0EX
	RSTK=C

	GOSUBL	D0=RAM
	CON(5)	=DOLPENV_G
	CON(5)	=DOLPENV

	C=DAT0	A
	D0=C
	D0=D0+	10
	A=DAT0	A
	C=RSTK
	CD0EX
	RTNCC
RPL

** AsTy8 ********************************************************************
* Description : Type 8: LAASC/LCASC	and  NIBASC
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy8
::
    @AsTmp
    SWAP 2DUP				( --> hxsOpc $ $para $ $para )
    DUPLEN$ THREE #< casedrop ASCError
    ONE POS$ #1+			( --> hxsOpc $ $p #start )
    SWAP CAR$				( --> hxs $ #st chr )
    3PICKSWAP 3PICK			( --> hxs $ #st $ chr #st )
    POSCHR				( --> hxs $ #st #stop )

    DUP#0=csedrp
    LABEL	ASCError
    ::	DROP tok$ IError
    ;

    #1-SUB$				( --> hxs $' )
    XLate$

    DUPLEN$ #0=case
    ::	ZERO ASCError
    ;

    rev$

    [#] DOHSTR ChgType

    SWAP				( --> hxs$ hxsO )
    asTy8A caseTRUE

    OVER LENHXS asTy8B

    &HXS SWAP&$ TRUE
;


ASSEMBLE

* CPU			A	B	C	D	D0	D1	xx

rev$
	PCode

	GOSUBL	SavPtr
	C=DAT1	A			->$
	D0=C						->$
	D0=D0+	5					->l
	C=DAT0	A			l
	D0=D0+	3					->s
	AD0EX		->s
	D0=A						->s
	D0=D0+	2
	C=C-CON A,5			len
	A=A+C	A	->e
	D1=A							->e
	CSRB.F	A			len/2
	CSRB.F	A			chrs/2
	B=C	A		cnt

r$lp	B=B-1	A		--cnt
	GOC	r$ex

	A=DAT0	B	[s]
	C=DAT1	B			[e]
	DAT0=C	B
	DAT1=A	B
	D0=D0+	2					->s'
	D1=D1-	2						->e'
	GONC	r$lp	** BET

r$ex	GOLONG	GPLoop

asTy8A
	PCode

	GOSUB	asGThxs
	?A=0	P
	GOYES	asNULLA
	D1=D1-	5
	D=D-1	A
asNULLA P=	0
	GOLONG	PshTFL

asTy8B
	PCode

	GOSUBL	Pop#SP
	A=A-1	A
	C=0	A
	LCHEX	F
	?A<=C	A
	GOYES	asPhL
	A=C	A
asPhL	GOLONG	PshHxsLp
RPL

** AsTy9 ********************************************************************
* Description : Type 9: LAHEX/LCHEX	and  NIBHEX
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTy9
::
					( --> hxs[opc] $param )
    OVER

    LABEL	NULL1HXS
	HXS 1 0

    EQUALcase
    ::	SWAPDROP $>hxs NOTcsdrpfls
	TRUE
    ;
		( *Check parameter of LAHEX/LCHEX [NOT symbolic !]* )
    $>hxsR NOTcsdrpfls

    DUP LENHXS #>Hxs[1]-1 SWAP&$ &$
    TRUE
;

** $>hxsR ***************************************
* Interface :	( $ --> hxs t / $ f )
* Description : Try to convert given x-$ into hxs
* Calls :	$>hxsEntr
* Defines :
* Ed. Hist. :
*     1.000	13.02.1992	DM	alpha
*************************************************

ASSEMBLE

$>hxsR
	PCode

	ST=1	f$>hR
	GOLONG	$>hxsEntr

PopASpRd$
	GOSUBL	PopASP
Read$	P=	0
	GOVLNG	=READ$

************************************************
* Subs to generate fs/A/B/d Opcode Nibs
* CARRY SET = Success
* The caller is responsible for Opc-len checking
************************************************

************************************************
* This routine is the workhorse
* for NON-SYMB fs/A Parameters
* Reads 2 args from data stk  ( $Par hxsOpcd -> )
* R2=#Opcd
*
* Tries to determine parameter opcode nib of
* Par :  A,P,WP,XS,X,S,M,B,W
* B[0]:  n 0 1	2  3 4 5 6 7   (n = Not changed)
* Exit : A[A]: $Par ; B[0]: ParNib ; C[A]: Trash
* D1:&ParChar1 , P= ?
* S1=1 : \A\ Par	    S2=1 : TWO Digit Par
* CARRY SET = Success
************************************************
asOPC&Par
	A=DAT1	A			&Ob1		1:&DSKTOP
	AD1EX				1:&DSKTOP	1:&Ob1
	D1=D1+	5					1:&Ob1_Len
	C=DAT1	A
	C=C-CON A,6
	P=C	0
	D1=D1+	5					1:&Ob1_Data
	C=0	W
	C=DAT1	WP			#Opcd
	D1=A						1:&DSKTOP
	D1=D1+	5	*\
	D=D+1	A	*/ DROP 1 Stk Level
	R2=C
	GOSUB	PopASpRd$	len
	B=0	W
	C=0	A
	C=C+1	A		len	1
	ST=0	1	** Flag \A\ Par **
	ST=0	2	** Flag TWO Digit Par **
	?A=C	B	len	0	1	R2:#Opcd
	GOYES	asAPar?

************************************************
* Encode Parameter  WP,XS  into B[0] !!!
************************************************
asWPXS	ST=1	1
	C=C+1	A	len	0	1
	?A=C	A
	GOYES	asWPXS2
	RTNCC

asWPXS2 ST=1	2
	B=B+1	A		1
	P=	3
	A=DAT1	WP
	P=	0
	LCASC	\PW\	Char	1	\PW\
	P=	3
	?A=C	WP
	RTNYES
	B=B+1	A		2
	P=	0
	LCASC	\SX\
	P=	3
	?A=C	WP
	RTNYES
	RTNCC

asAPar? LCASC	\A\				\A\
	A=DAT1	B
	?A=C	B
	RTNYES

************************************************
* Encode Parameter  P,X,S,M,B,W  into B[0] !!!
************************************************
asXPar	ST=1	1
	P=	0
	LCASC	\P\	Char	0	\P\
	?A=C	B
	RTNYES
	B=B+1	A		1
	B=B+1	A		2
	B=B+1	A		3
	LCASC	\WBMSX\
	P=	11
asParLP ?A=C	B
	RTNYES
	B=B+1	B
	CSR	W
	CSR	W
	P=P+1
	GONC	asParLP
rtncc	RTNCC

************************************************
* Encode Parameter  "1" - "9"  into B[3]
************************************************
as1_9	P=	0
	LCASC	\1\			31
	C=A-C	B
	GOC	rtncc
	LAHEX	08			08
	?A<C	B
	GOYES	rtncc
	P=C	0
	C=P	3
	P=	3
	B=C	P		x___
	RTNSC

************************************************
* Encode Parameter  "10" - "16"  into B[3]
************************************************
asA_F	P=	0
	LCASC	\1\			31
	P=	3
	LCHEX	9			9_31
	B=C	P
	A=DAT1	WP
	C=A-C	B
	?C#0	B
	GOYES	rtncc
	P=	2
	LCASC	\6\			37__
	?A>C	P
	GOYES	rtncc
	P=	3
	?A#C	P
	GOYES	rtncc
	ASLC
	B=B+A	P		x___
	RTNSC
RPL

** AsTyA ********************************************************************
* Interface :	( hxsOpc $param --> NULLHXS TRUE )
* Description : Type A: INCLUDE <var>
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTyA
::
    SWAPDROP DoInclude TRUE
;

** AsTyC ********************************************************************
* Description : Type C: IF (IF**)    CONDITONAL ASSEMBLY
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTyC
::
    IF? ?SKIP SKIP2 "No IF nesting yet" AError
					( --> hxsTyp $ )
    ASParse				( --> hxsTyp hxsVal )

*    SigIF				( *IF mode* )
    fIF SetF

    NULL1HXS UNROTSWAP HXS>#		( --> hxs0 hxsVal #Typ )
					( *#0 ? val* )
    {	HXS#HXS 			( *IF* )
	HXS==HXS			( *IFEQ* )
	HXS<=HXS			( *IFGE* )
	HXS<HXS 			( *IFGT* )
	HXS>=HXS			( *IFLE* )
	HXS>HXS 			( *IFLT* )
	HXS#HXS 			( *IFNE* )
    }

    SWAP NTHCOMPDROP EVAL

    NULLHXS TRUE ROT			( --> hxs T % )

    %0<> ?SEMI

    IgnoreOn				( *Search for ELSE/ENDIF only* )
;

** AsTyE ********************************************************************
* Description : Type E: EQU
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsTyE
::
    SWAPDROP ASParse !AsLabVal
    NULLHXS TRUE
;

** AsGY/RY ******************************************************************
* Interface :	( hxsOPCD hxsVALUE(SYMB) #CURR.Offset --> hxsOPCD' T / F )
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	AsGY/RY
ASSEMBLE
*				A	B	C	D	D1
	PCode

	GOSUBL	Pop#		C.Ofs				&NEW_L1
	R0=A
	P=	4
	GOSUBL	 asGThSP	valSYMB
	B=A	A
	C=R0
	D=C	A					Curr_Ofs
	D=D-1	A
	P=	1
	GOTO	asJMPOPC
RPL

** xSYM-> *******************************************************************
* Uses :	RomID
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

ASSEMBLE
	XNAME	SYM
RPL
::
    CK1&Dispatch
    # AF
    ::	CKRPLInst
	TOTEMPOB Ld>{}			( --> { # .. } )
	INNERCOMP #2<> caseSIZEERR	( --> # hxs )

	SWAP RomID #= NcaseTYPEERR

	1LAMBIND NULL$ MINUSONE 	( --> $ # )

	ZERO_DO (DO)
	::  1GETLAM TOTEMPOB INDEX@	( --> $ hxs # )
	    SymTabA NOTcase ExitAtLOOP

	    1GETLAM INDEX@ SymTabB

	    DROP HXS>$ DUPLEN$ 1_#1-SUB$ AsSplit DROP !append$
	    SWAPDROPSWAP 14SPACES$ &$ ELEVEN 1_#1-SUB$
	    "EQU " &$ !insert$ NEWLINE$&$ &$
	;
	LOOP

	ABND DROP
    ;
;

** Ld>{} ********************************************************************
* Interface :	( LibDat --> {} )
* Calls:	loop
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	Ld>{}
ASSEMBLE
	PCode

	A=DAT1	A
	AD1EX
	LC(5)	=DOLIST
	DAT1=C	A
	D1=D1+	5
	LC(5)	=DOBINT
	DAT1=C	A
	D1=A
	GOLONG	loop
RPL

** SymTab *******************************************************************
* Interface :	( ? --> ? )
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

ASSEMBLE
*				A	B	C	D	D0	D1   P

SymTabA
	PCode

	ST=0	asSVAL
	GOTO	asSMVAL

SymTabB
	PCode

	ST=1	asSVAL

asSMVAL GOSUBL	Pop#SP
	R2=A
	A=DAT1	A

	GOSUBL	Read$

	C=R2
	A=DAT1	A		cnt
	?A>C	A
	GOYES	asINR
	GOLONG	GPPshFLp

asINR	D=C	A					#n
	D1=D1+	5							&1.LENnib
	A=0	A
	?ST=0	asSVAL
	GOYES	asSKPe
	B=0	A
	GONC	asSKPE

asSKPLp B=0	A
	B=B+1	A

asSKPE	C=DAT1	1
	P=C	0
	CD1EX
	C+P+1
	C=C+1	A
	D1=C
	B=B-1	A
	GONC	asSKPE

asSKPe	D=D-1	A
	GONC	asSKPLp

	C=DAT1	1							&LENnib
	D1=D1+	1
	P=C	0
	A=DAT1	WP
	?ST=0	asSVAL
	GOYES	asSYM2$
	GOSUBL	PshHxs
	GOTO	asSYMEX

asSYM2$ RSTK=C
	R3=A
	C=0	A
	C+P+1
	GOSUBL	Mk$n
	C=RSTK
	P=C	0
	C=R3
	DAT0=C	WP
	P=	0
	GOSUBL	GetPtr
	A=R0
	DAT1=A	A

asSYMEX GOLONG	PTLoop
RPL

** aOpcodes *****************************************************************
* Interface :	( $ --> HXS(Opcode) #Parameter Type FALSE )
*		( $ --> $ TRUE )
* Description : !! INVERSE ExitFlag sense !!
* Uses :	A,B,C,D,D0,D1,P,R0
* Calls :	GETPTR,GPPushTLoop,PUSHhxs,READ$,SAVPTR,SPPush#FLoop
* Stack Levels: 4
* Ed. Hist. :
*     0.000 12.07.1992	RH
*****************************************************************************

LABEL	aOpcodes
ASSEMBLE
	PCode

	GOSUBL	SavPtr
	A=DAT1	A
	GOSUBL	Read$
	C=A	A
	RSTK=C
	C=C+C	A
	P=C	0
	C=0	WP
	C=DAT1	WP	       *  Get $
	D=C	WP	       *  D = $
	C=0	A
	P=	0
	LCHEX	58	       *  \X\
	?D<=C	B
	GOYES	amaybe
aisnot	GOTO	aisNOT
amaybe	LCHEX	3F	       *  \?\
	?C>D	B
	GOYES	aisnot
	A=C	A	       *  A = \?\
	C=D	B	       *  C = Char1
	ACEX	A	       *  A = Char1 ; C = \?\
	A=A-C	A	       *  A = 0...24
	A=A+A	A
	A=A+A	A
	GOSUB	axSEARCH

******** Offset table start ********
	REL(4)	ais??A		*  ?
	CON(4)	0		*  @
	REL(4)	aisA?A		*  A
	REL(4)	aisB?A
	REL(4)	aisC?A
	REL(4)	aisD?A
	REL(4)	aisE?A
	CON(4)	0		*  F
	REL(4)	aisG?A
	REL(4)	aisH?A
	REL(4)	aisI?A
	CON(4)	0		*  J
	CON(4)	0		*  K
	REL(4)	aisL?A
	REL(4)	aisM?A
	REL(4)	aisN?A
	REL(4)	aisO?A
	REL(4)	aisP?A
	CON(4)	0		*  Q
	REL(4)	aisR?A
	REL(4)	aisS?A
	CON(4)	0		*  T
	REL(4)	aisU?A
	CON(4)	0		*  V
	CON(4)	0		*  W
	REL(4)	aisX?A
	REL(4)	aisX?E
******** Offset table end ********

axSEARCH
	C=RSTK			*  XQ>GO
	C=C+A	A		*  Adr + Ofs = Adr into Table
	D1=C
	A=0	A
	A=DAT1	4		*  REL
	?A=0	A
	GOYES	aisNOT
	C=C+A	A
	D0=C		       *  D0 -> Start Adr
	B=C	A
	P=	13

aLP10	D1=D1+	4		*  Next REL
	A=0	A
	A=DAT1	4		*  Get END Adr
	?A#0	A
	GOYES	aOK
	P=P-1
	GONC	aLP10

aOK	P=	0
	CD1EX
	C=C+A	A		*  END Adr
	BCEX	A
	B=B-C	A		*  Calc Loop Counter

**********************************************************
* D[13:0]= $ ; B[A]= Loop Count ; D0= -> Start Adr

asrcLp	C=RSTK
	RSTK=C
	A=0	A
	A=DAT0	1
	?C=A	B
	GOYES	asameln
	A=A+A	A
	A=A+1	A
	B=B-A	A
	GOC	aisNOT
	CD0EX
	C=C+A	A

ashare	D0=C
	A=DAT0	1
	A=A+1	A
	C=C+A	A
	D0=C
	B=B-A	A
	GONC	asrcLp

aisNOT	C=RSTK
	P=	0
	GOLONG	GPTLp

asameln A=A+A	A
	C=A	A
	A=A+1	A
	B=B-A	A
	GOC	aisNOT
	C=C-1	A
	P=C	0
	D0=D0+	1
	C=DAT0	WP
	?D=C	WP
	GOYES	afound
	CD0EX
	C+P+1
	GONC	ashare

afound	CD0EX
	C+P+1
	D0=C
	C=DAT0	B
	P=C	0
	CSRC
	CSRC
	A=C	S
	D0=D0+	2
	P=P-1
	P=P-1
	A=DAT0	WP
	GOSUBL	PshHxs
	A=DAT1	A
	D1=D1+	5
	D=D+1	A
	DAT1=A	A
	A=0	A
	ASLC
	R0=A
	C=RSTK

aSPP#FL
	GOVLNG	=SPPush#FLoop

******** End of axSEARCH ********

******** Start of data ********

ais??A	NIBHEX	4
	NIBASC	\?A#0\
	NIBHEX	41	      *  Type 4 : 4 Nibs to read
	NIBHEX	8AC	      *  First with 'A'-Field Modifier , then fs
	NIBHEX	4
	NIBASC	\?A#B\
	NIBHEX	418A4
	NIBHEX	4
	NIBASC	\?A#C\
	NIBHEX	418A6
	NIBHEX	5
	NIBASC	\?A<=B\
	NIBHEX	418BC
	NIBHEX	5
	NIBASC	\?A<=C\
	NIBHEX	418BA
	NIBHEX	4
	NIBASC	\?A<B\
	NIBHEX	418B4
	NIBHEX	4
	NIBASC	\?A<C\
	NIBHEX	418B2
	NIBHEX	4
	NIBASC	\?A=0\
	NIBHEX	418A8
	NIBHEX	4
	NIBASC	\?A=B\
	NIBHEX	418A0
	NIBHEX	4
	NIBASC	\?A=C\
	NIBHEX	418A2
	NIBHEX	5
	NIBASC	\?A>=B\
	NIBHEX	418B8
	NIBHEX	5
	NIBASC	\?A>=C\
	NIBHEX	418BE
	NIBHEX	4
	NIBASC	\?A>B\
	NIBHEX	418B0
	NIBHEX	4
	NIBASC	\?A>C\
	NIBHEX	418B6
	NIBHEX	7
	NIBASC	\?ABIT=0\
	NIBHEX	528086
	NIBHEX	7
	NIBASC	\?ABIT=1\
	NIBHEX	528087
	NIBHEX	4
	NIBASC	\?B#0\
	NIBHEX	418AD
	NIBHEX	4
	NIBASC	\?B#A\
	NIBHEX	418A4
	NIBHEX	4
	NIBASC	\?B#C\
	NIBHEX	418A5
	NIBHEX	5
	NIBASC	\?B<=A\
	NIBHEX	418B8
	NIBHEX	5
	NIBASC	\?B<=C\
	NIBHEX	418BD
	NIBHEX	4
	NIBASC	\?B<A\
	NIBHEX	418B0
	NIBHEX	4
	NIBASC	\?B<C\
	NIBHEX	418B5
	NIBHEX	4
	NIBASC	\?B=0\
	NIBHEX	418A9
	NIBHEX	4
	NIBASC	\?B=A\
	NIBHEX	418A0
	NIBHEX	4
	NIBASC	\?B=C\
	NIBHEX	418A1
	NIBHEX	5
	NIBASC	\?B>=A\
	NIBHEX	418BC
	NIBHEX	5
	NIBASC	\?B>=C\
	NIBHEX	418B9
	NIBHEX	4
	NIBASC	\?B>A\
	NIBHEX	418B4
	NIBHEX	4
	NIBASC	\?B>C\
	NIBHEX	418B1
	NIBHEX	4
	NIBASC	\?C#0\
	NIBHEX	418AE
	NIBHEX	4
	NIBASC	\?C#A\
	NIBHEX	418A6
	NIBHEX	4
	NIBASC	\?C#B\
	NIBHEX	418A5
	NIBHEX	4
	NIBASC	\?C#D\
	NIBHEX	418A7
	NIBHEX	5
	NIBASC	\?C<=A\
	NIBHEX	418BE
	NIBHEX	5
	NIBASC	\?C<=B\
	NIBHEX	418B9
	NIBHEX	5
	NIBASC	\?C<=D\
	NIBHEX	418BB
	NIBHEX	4
	NIBASC	\?C<A\
	NIBHEX	418B6
	NIBHEX	4
	NIBASC	\?C<B\
	NIBHEX	418B1
	NIBHEX	4
	NIBASC	\?C<D\
	NIBHEX	418B3
	NIBHEX	4
	NIBASC	\?C=0\
	NIBHEX	418AA
	NIBHEX	4
	NIBASC	\?C=A\
	NIBHEX	418A2
	NIBHEX	4
	NIBASC	\?C=B\
	NIBHEX	418A1
	NIBHEX	4
	NIBASC	\?C=D\
	NIBHEX	418A3
	NIBHEX	5
	NIBASC	\?C>=A\
	NIBHEX	418BA
	NIBHEX	5
	NIBASC	\?C>=B\
	NIBHEX	418BD
	NIBHEX	5
	NIBASC	\?C>=D\
	NIBHEX	418BF
	NIBHEX	4
	NIBASC	\?C>A\
	NIBHEX	418B2
	NIBHEX	4
	NIBASC	\?C>B\
	NIBHEX	418B5
	NIBHEX	4
	NIBASC	\?C>D\
	NIBHEX	418B7
	NIBHEX	7
	NIBASC	\?CBIT=0\
	NIBHEX	52808A
	NIBHEX	7
	NIBASC	\?CBIT=1\
	NIBHEX	52808B
	NIBHEX	4
	NIBASC	\?D#0\
	NIBHEX	418AF
	NIBHEX	4
	NIBASC	\?D#C\
	NIBHEX	418A7
	NIBHEX	5
	NIBASC	\?D<=C\
	NIBHEX	418BF
	NIBHEX	4
	NIBASC	\?D<C\
	NIBHEX	418B7
	NIBHEX	4
	NIBASC	\?D=0\
	NIBHEX	418AB
	NIBHEX	4
	NIBASC	\?D=C\
	NIBHEX	418A3
	NIBHEX	5
	NIBASC	\?D>=C\
	NIBHEX	418BB
	NIBHEX	4
	NIBASC	\?D>C\
	NIBHEX	418B3
	NIBHEX	5
	NIBASC	\?HS=0\
	NIBHEX	3283
	NIBHEX	5
	NIBASC	\?MP=0\
	NIBHEX	4B838
	NIBHEX	3
	NIBASC	\?P#\
	NIBHEX	3288
	NIBHEX	3
	NIBASC	\?P=\
	NIBHEX	3289
	NIBHEX	5
	NIBASC	\?SB=0\
	NIBHEX	4B832
	NIBHEX	5
	NIBASC	\?SR=0\
	NIBHEX	4B834
	NIBHEX	5
	NIBASC	\?ST=0\
	NIBHEX	3286
	NIBHEX	5
	NIBASC	\?ST=1\
	NIBHEX	3287
	NIBHEX	5
	NIBASC	\?XM=0\
	NIBHEX	4B831
ais??E


aisA?A	NIBHEX	4
	NIBASC	\A=-A\
	NIBHEX	31F8
	NIBHEX	6
	NIBASC	\A=-A-1\
	NIBHEX	31FC
	NIBHEX	3
	NIBASC	\A=0\
	NIBHEX	31D0
	NIBHEX	5
	NIBASC	\A=A!B\
	NIBHEX	510EF8
	NIBHEX	5
	NIBASC	\A=A!C\
	NIBHEX	510EFE
	NIBHEX	5
	NIBASC	\A=A&B\
	NIBHEX	410EF
	NIBHEX	5
	NIBASC	\A=A&C\
	NIBHEX	510EF6
	NIBHEX	5
	NIBASC	\A=A+1\
	NIBHEX	31E4
	NIBHEX	5
	NIBASC	\A=A+A\
	NIBHEX	31C4
	NIBHEX	5
	NIBASC	\A=A+B\
	NIBHEX	31C0
	NIBHEX	5
	NIBASC	\A=A+C\
	NIBHEX	31CA
	NIBHEX	7
	NIBASC	\A=A+CON\
	NIBHEX	51818F
	NIBHEX	5
	NIBASC	\A=A-1\
	NIBHEX	31CC
	NIBHEX	5
	NIBASC	\A=A-B\
	NIBHEX	31E0
	NIBHEX	5
	NIBASC	\A=A-C\
	NIBHEX	31EA
	NIBHEX	7
	NIBASC	\A=A-CON\
	NIBHEX	61818F8
	NIBHEX	3
	NIBASC	\A=B\
	NIBHEX	31D4
	NIBHEX	5
	NIBASC	\A=B!A\
	NIBHEX	510EF8
	NIBHEX	5
	NIBASC	\A=B&A\
	NIBHEX	510EF0
	NIBHEX	5
	NIBASC	\A=B+A\
	NIBHEX	31C0
	NIBHEX	5
	NIBASC	\A=B-A\
	NIBHEX	31EC
	NIBHEX	3
	NIBASC	\A=C\
	NIBHEX	31DA
	NIBHEX	5
	NIBASC	\A=C!A\
	NIBHEX	510EFE
	NIBHEX	5
	NIBASC	\A=C&A\
	NIBHEX	510EF6
	NIBHEX	5
	NIBASC	\A=C+A\
	NIBHEX	31CA
	NIBHEX	6
	NIBASC	\A=DAT0\
	NIBHEX	41142
	NIBHEX	6
	NIBASC	\A=DAT1\
	NIBHEX	41143
	NIBHEX	4
	NIBASC	\A=IN\
	NIBHEX	40802
	NIBHEX	4
	NIBASC	\A=PC\
	NIBHEX	5081B4
	NIBHEX	4
	NIBASC	\A=R0\
	NIBHEX	40110
	NIBHEX	6
	NIBASC	\A=R0.F\
	NIBHEX	6181AF1
	NIBHEX	4
	NIBASC	\A=R1\
	NIBHEX	40111
	NIBHEX	6
	NIBASC	\A=R1.F\
	NIBHEX	7181AF11
	NIBHEX	4
	NIBASC	\A=R2\
	NIBHEX	40112
	NIBHEX	6
	NIBASC	\A=R2.F\
	NIBHEX	7181AF12
	NIBHEX	4
	NIBASC	\A=R3\
	NIBHEX	40113
	NIBHEX	6
	NIBASC	\A=R3.F\
	NIBHEX	7181AF13
	NIBHEX	4
	NIBASC	\A=R4\
	NIBHEX	40114
	NIBHEX	6
	NIBASC	\A=R4.F\
	NIBHEX	7181AF14
	NIBHEX	4
	NIBASC	\ABEX\
	NIBHEX	31DC
	NIBHEX	6
	NIBASC	\ABIT=0\
	NIBHEX	528084
	NIBHEX	6
	NIBASC	\ABIT=1\
	NIBHEX	528085
	NIBHEX	4
	NIBASC	\ACEX\
	NIBHEX	31DE
	NIBHEX	5
	NIBASC	\AD0EX\
	NIBHEX	40132
	NIBHEX	5
	NIBASC	\AD0XS\
	NIBHEX	4013A
	NIBHEX	5
	NIBASC	\AD1EX\
	NIBHEX	40133
	NIBHEX	5
	NIBASC	\AD1XS\
	NIBHEX	4013B
	NIBHEX	5
	NIBASC	\APCEX\
	NIBHEX	5081B6
	NIBHEX	5
	NIBASC	\AR0EX\
	NIBHEX	40120
	NIBHEX	7
	NIBASC	\AR0EX.F\
	NIBHEX	7181A020
	NIBHEX	5
	NIBASC	\AR1EX\
	NIBHEX	40121
	NIBHEX	7
	NIBASC	\AR1EX.F\
	NIBHEX	7181A021
	NIBHEX	5
	NIBASC	\AR2EX\
	NIBHEX	40122
	NIBHEX	7
	NIBASC	\AR2EX.F\
	NIBHEX	7181A022
	NIBHEX	5
	NIBASC	\AR3EX\
	NIBHEX	40123
	NIBHEX	7
	NIBASC	\AR3EX.F\
	NIBHEX	7181A023
	NIBHEX	5
	NIBASC	\AR4EX\
	NIBHEX	40124
	NIBHEX	7
	NIBASC	\AR4EX.F\
	NIBHEX	7181A024
	NIBHEX	3
	NIBASC	\ASL\
	NIBHEX	31F0
	NIBHEX	4
	NIBASC	\ASLC\
	NIBHEX	40810
	NIBHEX	3
	NIBASC	\ASR\
	NIBHEX	31F4
	NIBHEX	4
	NIBASC	\ASRB\
	NIBHEX	4081C
	NIBHEX	6
	NIBASC	\ASRB.F\
	NIBHEX	51819F
	NIBHEX	4
	NIBASC	\ASRC\
	NIBHEX	40814
aisA?E


aisB?A	NIBHEX	4
	NIBASC	\B=-B\
	NIBHEX	31F9
	NIBHEX	6
	NIBASC	\B=-B-1\
	NIBHEX	31FD
	NIBHEX	3
	NIBASC	\B=0\
	NIBHEX	31D1
	NIBHEX	3
	NIBASC	\B=A\
	NIBHEX	31D8
	NIBHEX	5
	NIBASC	\B=A!B\
	NIBHEX	510EFC
	NIBHEX	5
	NIBASC	\B=A&B\
	NIBHEX	510EF4
	NIBHEX	5
	NIBASC	\B=A+B\
	NIBHEX	31C8
	NIBHEX	5
	NIBASC	\B=B!A\
	NIBHEX	510EFC
	NIBHEX	5
	NIBASC	\B=B!C\
	NIBHEX	510EF9
	NIBHEX	5
	NIBASC	\B=B&A\
	NIBHEX	510EF4
	NIBHEX	5
	NIBASC	\B=B&C\
	NIBHEX	510EF1
	NIBHEX	5
	NIBASC	\B=B+1\
	NIBHEX	31E5
	NIBHEX	5
	NIBASC	\B=B+A\
	NIBHEX	31C8
	NIBHEX	5
	NIBASC	\B=B+B\
	NIBHEX	31C5
	NIBHEX	5
	NIBASC	\B=B+C\
	NIBHEX	31C1
	NIBHEX	7
	NIBASC	\B=B+CON\
	NIBHEX	61818F1
	NIBHEX	5
	NIBASC	\B=B-1\
	NIBHEX	31CD
	NIBHEX	5
	NIBASC	\B=B-A\
	NIBHEX	31E8
	NIBHEX	5
	NIBASC	\B=B-C\
	NIBHEX	31E1
	NIBHEX	7
	NIBASC	\B=B-CON\
	NIBHEX	61818F9
	NIBHEX	3
	NIBASC	\B=C\
	NIBHEX	31D5
	NIBHEX	5
	NIBASC	\B=C!B\
	NIBHEX	510EF9
	NIBHEX	5
	NIBASC	\B=C&B\
	NIBHEX	510EF1
	NIBHEX	5
	NIBASC	\B=C+B\
	NIBHEX	31C1
	NIBHEX	5
	NIBASC	\B=C-B\
	NIBHEX	31ED
	NIBHEX	4
	NIBASC	\BAEX\
	NIBHEX	31DC
	NIBHEX	4
	NIBASC	\BCEX\
	NIBHEX	31DD
	NIBHEX	3
	NIBASC	\BSL\
	NIBHEX	31F1
	NIBHEX	4
	NIBASC	\BSLC\
	NIBHEX	40811
	NIBHEX	3
	NIBASC	\BSR\
	NIBHEX	31F5
	NIBHEX	4
	NIBASC	\BSRB\
	NIBHEX	4081D
	NIBHEX	6
	NIBASC	\BSRB.F\
	NIBHEX	61819F1
	NIBHEX	4
	NIBASC	\BSRC\
	NIBHEX	40815
	NIBHEX	5
	NIBASC	\BUSCB\
	NIBHEX	508083
	NIBHEX	5
	NIBASC	\BUSCC\
	NIBHEX	4080B
	NIBHEX	5
	NIBASC	\BUSCD\
	NIBHEX	50808D
aisB?E



aisC?A	NIBHEX	5
	NIBASC	\C+P+1\
	NIBHEX	40809
	NIBHEX	4
	NIBASC	\C=-C\
	NIBHEX	31FA
	NIBHEX	6
	NIBASC	\C=-C-1\
	NIBHEX	31FE
	NIBHEX	3
	NIBASC	\C=0\
	NIBHEX	31D2
	NIBHEX	3
	NIBASC	\C=A\
	NIBHEX	31D6
	NIBHEX	5
	NIBASC	\C=A!C\
	NIBHEX	510EFA
	NIBHEX	5
	NIBASC	\C=A&C\
	NIBHEX	510EF2
	NIBHEX	5
	NIBASC	\C=A+C\
	NIBHEX	31C2
	NIBHEX	5
	NIBASC	\C=A-C\
	NIBHEX	31EE
	NIBHEX	3
	NIBASC	\C=B\
	NIBHEX	31D9
	NIBHEX	5
	NIBASC	\C=B!C\
	NIBHEX	510EFD
	NIBHEX	5
	NIBASC	\C=B&C\
	NIBHEX	510EF5
	NIBHEX	5
	NIBASC	\C=B+C\
	NIBHEX	31C9
	NIBHEX	5
	NIBASC	\C=C!A\
	NIBHEX	510EFA
	NIBHEX	5
	NIBASC	\C=C!B\
	NIBHEX	510EFD
	NIBHEX	5
	NIBASC	\C=C!D\
	NIBHEX	510EFF
	NIBHEX	5
	NIBASC	\C=C&A\
	NIBHEX	510EF2
	NIBHEX	5
	NIBASC	\C=C&B\
	NIBHEX	510EF5
	NIBHEX	5
	NIBASC	\C=C&D\
	NIBHEX	510EF7
	NIBHEX	5
	NIBASC	\C=C+1\
	NIBHEX	31E6
	NIBHEX	5
	NIBASC	\C=C+A\
	NIBHEX	31C2
	NIBHEX	5
	NIBASC	\C=C+B\
	NIBHEX	31C9
	NIBHEX	5
	NIBASC	\C=C+C\
	NIBHEX	31C6
	NIBHEX	7
	NIBASC	\C=C+CON\
	NIBHEX	61818F2
	NIBHEX	5
	NIBASC	\C=C+D\
	NIBHEX	31CB
	NIBHEX	7
	NIBASC	\C=C+P+1\
	NIBHEX	40809
	NIBHEX	5
	NIBASC	\C=C-1\
	NIBHEX	31CE
	NIBHEX	5
	NIBASC	\C=C-A\
	NIBHEX	31E2
	NIBHEX	5
	NIBASC	\C=C-B\
	NIBHEX	31E9
	NIBHEX	7
	NIBASC	\C=C-CON\
	NIBHEX	61818FA
	NIBHEX	5
	NIBASC	\C=C-D\
	NIBHEX	31EB
	NIBHEX	3
	NIBASC	\C=D\
	NIBHEX	31DB
	NIBHEX	5
	NIBASC	\C=D!C\
	NIBHEX	510EFF
	NIBHEX	5
	NIBASC	\C=D&C\
	NIBHEX	510EF7
	NIBHEX	5
	NIBASC	\C=D+C\
	NIBHEX	31CB
	NIBHEX	6
	NIBASC	\C=DAT0\
	NIBHEX	41146
	NIBHEX	6
	NIBASC	\C=DAT1\
	NIBHEX	41147
	NIBHEX	4
	NIBASC	\C=ID\
	NIBHEX	40806
	NIBHEX	4
	NIBASC	\C=IN\
	NIBHEX	40803
	NIBHEX	3
	NIBASC	\C=P\
	NIBHEX	4280C
	NIBHEX	4
	NIBASC	\C=PC\
	NIBHEX	5081B5
	NIBHEX	4
	NIBASC	\C=R0\
	NIBHEX	40118
	NIBHEX	6
	NIBASC	\C=R0.F\
	NIBHEX	7181AF18
	NIBHEX	4
	NIBASC	\C=R1\
	NIBHEX	40119
	NIBHEX	6
	NIBASC	\C=R1.F\
	NIBHEX	7181AF19
	NIBHEX	4
	NIBASC	\C=R2\
	NIBHEX	4011A
	NIBHEX	6
	NIBASC	\C=R2.F\
	NIBHEX	7181AF1A
	NIBHEX	4
	NIBASC	\C=R3\
	NIBHEX	4011B
	NIBHEX	6
	NIBASC	\C=R3.F\
	NIBHEX	7181AF1B
	NIBHEX	4
	NIBASC	\C=R4\
	NIBHEX	4011C
	NIBHEX	6
	NIBASC	\C=R4.F\
	NIBHEX	7181AF1C
	NIBHEX	6
	NIBASC	\C=RSTK\
	NIBHEX	3007
	NIBHEX	4
	NIBASC	\C=ST\
	NIBHEX	3009
	NIBHEX	4
	NIBASC	\CAEX\
	NIBHEX	31DE
	NIBHEX	4
	NIBASC	\CBEX\
	NIBHEX	31DD
	NIBHEX	6
	NIBASC	\CBIT=0\
	NIBHEX	528088
	NIBHEX	6
	NIBASC	\CBIT=1\
	NIBHEX	528089
	NIBHEX	5
	NIBASC	\CD0EX\
	NIBHEX	40136
	NIBHEX	5
	NIBASC	\CD0XS\
	NIBHEX	4013E
	NIBHEX	5
	NIBASC	\CD1EX\
	NIBHEX	40137
	NIBHEX	5
	NIBASC	\CD1XS\
	NIBHEX	4013F
	NIBHEX	4
	NIBASC	\CDEX\
	NIBHEX	31DF
	NIBHEX	6
	NIBASC	\CLRHSN\
	NIBHEX	3282
	NIBHEX	6
	NIBASC	\CLRHST\
	NIBHEX	4082F
	NIBHEX	5
	NIBASC	\CLRST\
	NIBHEX	3008
	NIBHEX	6
	NIBASC	\CON(1)\
	NIBHEX	260
	NIBHEX	6
	NIBASC	\CON(2)\
	NIBHEX	261
	NIBHEX	6
	NIBASC	\CON(3)\
	NIBHEX	262
	NIBHEX	6
	NIBASC	\CON(4)\
	NIBHEX	263
	NIBHEX	6
	NIBASC	\CON(5)\
	NIBHEX	264
	NIBHEX	6
	NIBASC	\CON(6)\
	NIBHEX	265
	NIBHEX	6
	NIBASC	\CON(7)\
	NIBHEX	266
	NIBHEX	6
	NIBASC	\CON(8)\
	NIBHEX	267
	NIBHEX	6
	NIBASC	\CONFIG\
	NIBHEX	40805
	NIBHEX	5
	NIBASC	\CPCEX\
	NIBHEX	5081B7
	NIBHEX	4
	NIBASC	\CPEX\
	NIBHEX	4280F
	NIBHEX	5
	NIBASC	\CR0EX\
	NIBHEX	40128
	NIBHEX	7
	NIBASC	\CR0EX.F\
	NIBHEX	7181A028
	NIBHEX	5
	NIBASC	\CR1EX\
	NIBHEX	40129
	NIBHEX	7
	NIBASC	\CR1EX.F\
	NIBHEX	7181A029
	NIBHEX	5
	NIBASC	\CR2EX\
	NIBHEX	4012A
	NIBHEX	7
	NIBASC	\CR2EX.F\
	NIBHEX	7181A02A
	NIBHEX	5
	NIBASC	\CR3EX\
	NIBHEX	4012B
	NIBHEX	7
	NIBASC	\CR3EX.F\
	NIBHEX	7181A02B
	NIBHEX	5
	NIBASC	\CR4EX\
	NIBHEX	4012C
	NIBHEX	7
	NIBASC	\CR4EX.F\
	NIBHEX	7181A02C
	NIBHEX	3
	NIBASC	\CSL\
	NIBHEX	31F2
	NIBHEX	4
	NIBASC	\CSLC\
	NIBHEX	40812
	NIBHEX	3
	NIBASC	\CSR\
	NIBHEX	31F6
	NIBHEX	4
	NIBASC	\CSRB\
	NIBHEX	4081E
	NIBHEX	6
	NIBASC	\CSRB.F\
	NIBHEX	61819F2
	NIBHEX	4
	NIBASC	\CSRC\
	NIBHEX	40816
	NIBHEX	5
	NIBASC	\CSTEX\
	NIBHEX	300B
aisC?E


aisD?A	NIBHEX	6
	NIBASC	\D0=(2)\
	NIBHEX	3319
	NIBHEX	6
	NIBASC	\D0=(4)\
	NIBHEX	331A
	NIBHEX	6
	NIBASC	\D0=(5)\
	NIBHEX	331B
	NIBHEX	4
	NIBASC	\D0=A\
	NIBHEX	40130
	NIBHEX	5
	NIBASC	\D0=AS\
	NIBHEX	40138
	NIBHEX	4
	NIBASC	\D0=C\
	NIBHEX	40134
	NIBHEX	5
	NIBASC	\D0=CS\
	NIBHEX	4013C
	NIBHEX	6
	NIBASC	\D0=D0+\
	NIBHEX	3216
	NIBHEX	6
	NIBASC	\D0=D0-\
	NIBHEX	3218
*	D0=HEX	hh	19hh
*	D0=HEX	hhhh	1Ahhhh
*	D0=HEX	hhhhh	1Bhhhhh
	NIBHEX	6
	NIBASC	\D1=(2)\
	NIBHEX	331D
	NIBHEX	6
	NIBASC	\D1=(4)\
	NIBHEX	331E
	NIBHEX	6
	NIBASC	\D1=(5)\
	NIBHEX	331F
	NIBHEX	4
	NIBASC	\D1=A\
	NIBHEX	40131
	NIBHEX	5
	NIBASC	\D1=AS\
	NIBHEX	40139
	NIBHEX	4
	NIBASC	\D1=C\
	NIBHEX	40135
	NIBHEX	5
	NIBASC	\D1=CS\
	NIBHEX	4013D
	NIBHEX	6
	NIBASC	\D1=D1+\
	NIBHEX	3217
	NIBHEX	6
	NIBASC	\D1=D1-\
	NIBHEX	321C
*	D1=HEX	hh	1Dhh
*	D1=HEX	hhhh	1Ehhhh
*	D1=HEX	hhhhh	1Fhhhhh
	NIBHEX	4
	NIBASC	\D=-D\
	NIBHEX	31FB
	NIBHEX	6
	NIBASC	\D=-D-1\
	NIBHEX	31FF
	NIBHEX	3
	NIBASC	\D=0\
	NIBHEX	31D3
	NIBHEX	3
	NIBASC	\D=C\
	NIBHEX	31D7
	NIBHEX	5
	NIBASC	\D=C!D\
	NIBHEX	510EFB
	NIBHEX	5
	NIBASC	\D=C&D\
	NIBHEX	510EF3
	NIBHEX	5
	NIBASC	\D=C+D\
	NIBHEX	31C3
	NIBHEX	5
	NIBASC	\D=C-D\
	NIBHEX	31EF
	NIBHEX	5
	NIBASC	\D=D!C\
	NIBHEX	510EFB
	NIBHEX	5
	NIBASC	\D=D&C\
	NIBHEX	510EF3
	NIBHEX	5
	NIBASC	\D=D+1\
	NIBHEX	31E7
	NIBHEX	5
	NIBASC	\D=D+C\
	NIBHEX	31C3
	NIBHEX	7
	NIBASC	\D=D+CON\
	NIBHEX	61818F3
	NIBHEX	5
	NIBASC	\D=D+D\
	NIBHEX	31C7
	NIBHEX	5
	NIBASC	\D=D-1\
	NIBHEX	31CF
	NIBHEX	5
	NIBASC	\D=D-C\
	NIBHEX	31E3
	NIBHEX	7
	NIBASC	\D=D-CON\
	NIBHEX	61818FB
	NIBHEX	6
	NIBASC	\DAT0=A\
	NIBHEX	3114
	NIBHEX	6
	NIBASC	\DAT0=C\
	NIBHEX	41144
	NIBHEX	6
	NIBASC	\DAT1=A\
	NIBHEX	41141
	NIBHEX	6
	NIBASC	\DAT1=C\
	NIBHEX	41145
	NIBHEX	4
	NIBASC	\DCEX\
	NIBHEX	31DF
	NIBHEX	3
	NIBASC	\DSL\
	NIBHEX	31F3
	NIBHEX	4
	NIBASC	\DSLC\
	NIBHEX	40813
	NIBHEX	3
	NIBASC	\DSR\
	NIBHEX	31F7
	NIBHEX	4
	NIBASC	\DSRB\
	NIBHEX	4081F
	NIBHEX	6
	NIBASC	\DSRB.F\
	NIBHEX	61819F3
	NIBHEX	4
	NIBASC	\DSRC\
	NIBHEX	40817
aisD?E

aisE?A
	NIBHEX	5
	NIBASC	\ENDIF\
	NIBHEX	20F

	NIBHEX	3
	NIBASC	\EQU\
	NIBHEX	2E0

	NIBHEX	4
	NIBASC	\ELSE\
	NIBHEX	209
aisE?E

aisG?A	NIBHEX	3
	NIBASC	\GOC\
	NIBHEX	274
	NIBHEX	6
	NIBASC	\GOLONG\
	NIBHEX	378C
	NIBHEX	4
	NIBASC	\GONC\
	NIBHEX	275
	NIBHEX	6
	NIBASC	\GOSBVL\
	NIBHEX	338F
	NIBHEX	5
	NIBASC	\GOSUB\
	NIBHEX	277
	NIBHEX	6
	NIBASC	\GOSUBL\
	NIBHEX	378E
	NIBHEX	4
	NIBASC	\GOTO\
	NIBHEX	276
	NIBHEX	6
	NIBASC	\GOVLNG\
	NIBHEX	338D
	NIBHEX	5
	NIBASC	\GOYES\
	NIBHEX	2F1
aisG?E


aisH?A	NIBHEX	4
	NIBASC	\HS=0\
	NIBHEX	3282
aisH?E


aisI?A
** MACRO **
	NIBHEX	2
	NIBASC	\IF\
	NIBHEX	2C1
	NIBHEX	4
	NIBASC	\IFEQ\
	NIBHEX	2C2
	NIBHEX	4
	NIBASC	\IFGE\
	NIBHEX	2C3
	NIBHEX	4
	NIBASC	\IFGT\
	NIBHEX	2C4
	NIBHEX	4
	NIBASC	\IFLE\
	NIBHEX	2C5
	NIBHEX	4
	NIBASC	\IFLT\
	NIBHEX	2C6
	NIBHEX	4
	NIBASC	\IFNE\
	NIBHEX	2C7

	NIBHEX	5
	NIBASC	\IFNEG\ ** Same as IFLT **
	NIBHEX	2C6
	NIBHEX	4
	NIBASC	\IFNZ\	** Same as IFNE **
	NIBHEX	2C7
	NIBHEX	5
	NIBASC	\IFPOS\ ** Same as IFGT **
	NIBHEX	2C4
	NIBHEX	5
	NIBASC	\IFZER\ ** Same as IFEQ **
	NIBHEX	2C2

	NIBHEX	6
	NIBASC	\INTOFF\
	NIBHEX	50808F
	NIBHEX	5
	NIBASC	\INTON\
	NIBHEX	508080

	NIBHEX	7
	NIBASC	\INCLUDE\
	NIBHEX	2A0
aisI?E


aisL?A	NIBHEX	5
	NIBASC	\LAASC\
	NIBHEX	588082
	NIBHEX	5
	NIBASC	\LAHEX\
	NIBHEX	598082
	NIBHEX	5
	NIBASC	\LA(1)\
	NIBHEX	6480820
	NIBHEX	5
	NIBASC	\LA(2)\
	NIBHEX	6480821
	NIBHEX	5
	NIBASC	\LA(3)\
	NIBHEX	6480822
	NIBHEX	5
	NIBASC	\LA(4)\
	NIBHEX	6480823
	NIBHEX	5
	NIBASC	\LA(5)\
	NIBHEX	6480824
	NIBHEX	5
	NIBASC	\LA(6)\
	NIBHEX	6480825
	NIBHEX	5
	NIBASC	\LA(7)\
	NIBHEX	6480826
	NIBHEX	5
	NIBASC	\LA(8)\
	NIBHEX	6480827
	NIBHEX	5
	NIBASC	\LCASC\
	NIBHEX	283
	NIBHEX	5
	NIBASC	\LCHEX\
	NIBHEX	293
	NIBHEX	5
	NIBASC	\LC(1)\
	NIBHEX	3430
	NIBHEX	5
	NIBASC	\LC(2)\
	NIBHEX	3431
	NIBHEX	5
	NIBASC	\LC(3)\
	NIBHEX	3432
	NIBHEX	5
	NIBASC	\LC(4)\
	NIBHEX	3433
	NIBHEX	5
	NIBASC	\LC(5)\
	NIBHEX	3434
	NIBHEX	5
	NIBASC	\LC(6)\
	NIBHEX	3435
	NIBHEX	5
	NIBASC	\LC(7)\
	NIBHEX	3436
	NIBHEX	5
	NIBASC	\LC(8)\
	NIBHEX	3437

	NIBHEX	4
	NIBASC	\LOOP\
	CON(1)	(aisM1E)-(aisM1A)+1
	NIBHEX	0
aisM1A	GOVLNG	=Loop
aisM1E

aisL?E

aisM?A	NIBHEX	4
	NIBASC	\MP=0\
	NIBHEX	40828
aisM?E


aisN?A	NIBHEX	6
	NIBASC	\NIBASC\
	NIBHEX	280
	NIBHEX	6
	NIBASC	\NIBHEX\
	NIBHEX	290
	NIBHEX	4
	NIBASC	\NOP3\
	NIBHEX	40420
	NIBHEX	4
	NIBASC	\NOP4\
	NIBHEX	506300
	NIBHEX	4
	NIBASC	\NOP5\
	NIBHEX	6064000
aisN?E


aisO?A	NIBHEX	5
	NIBASC	\OUT=C\
	NIBHEX	40801
	NIBHEX	6
	NIBASC	\OUT=CS\
	NIBHEX	40800
aisO?E


aisP?A	NIBHEX	2
	NIBASC	\P=\
	NIBHEX	222
	NIBHEX	3
	NIBASC	\P=C\
	NIBHEX	4280D
	NIBHEX	5
	NIBASC	\P=P+1\
	NIBHEX	300C
	NIBHEX	5
	NIBASC	\P=P-1\
	NIBHEX	300D
	NIBHEX	6
	NIBASC	\PC=(A)\
	NIBHEX	50808C
	NIBHEX	6
	NIBASC	\PC=(C)\
	NIBHEX	50808E
	NIBHEX	4
	NIBASC	\PC=A\
	NIBHEX	5081B2
	NIBHEX	4
	NIBASC	\PC=C\
	NIBHEX	5081B3
aisP?E


aisR?A	NIBHEX	4
	NIBASC	\R0=A\
	NIBHEX	40100
	NIBHEX	6
	NIBASC	\R0=A.F\
	NIBHEX	5181AF
	NIBHEX	4
	NIBASC	\R0=C\
	NIBHEX	40108
	NIBHEX	6
	NIBASC	\R0=C.F\
	NIBHEX	7181AF08
	NIBHEX	4
	NIBASC	\R1=A\
	NIBHEX	40101
	NIBHEX	6
	NIBASC	\R1=A.F\
	NIBHEX	7181AF01
	NIBHEX	4
	NIBASC	\R1=C\
	NIBHEX	40109
	NIBHEX	6
	NIBASC	\R1=C.F\
	NIBHEX	7181AF09
	NIBHEX	4
	NIBASC	\R2=A\
	NIBHEX	40102
	NIBHEX	6
	NIBASC	\R2=A.F\
	NIBHEX	7181AF02
	NIBHEX	4
	NIBASC	\R2=C\
	NIBHEX	4010A
	NIBHEX	6
	NIBASC	\R2=C.F\
	NIBHEX	7181AF0A
	NIBHEX	4
	NIBASC	\R3=A\
	NIBHEX	40103
	NIBHEX	6
	NIBASC	\R3=A.F\
	NIBHEX	7181AF03
	NIBHEX	4
	NIBASC	\R3=C\
	NIBHEX	4010B
	NIBHEX	6
	NIBASC	\R3=C.F\
	NIBHEX	7181AF0B
	NIBHEX	4
	NIBASC	\R4=A\
	NIBHEX	40104
	NIBHEX	6
	NIBASC	\R4=A.F\
	NIBHEX	7181AF04
	NIBHEX	4
	NIBASC	\R4=C\
	NIBHEX	4010C
	NIBHEX	6
	NIBASC	\R4=C.F\
	NIBHEX	7181AF0C
	NIBHEX	6
	NIBASC	\REL(1)\
	NIBHEX	250
	NIBHEX	6
	NIBASC	\REL(2)\
	NIBHEX	251
	NIBHEX	6
	NIBASC	\REL(3)\
	NIBHEX	252
	NIBHEX	6
	NIBASC	\REL(4)\
	NIBHEX	253
	NIBHEX	6
	NIBASC	\REL(5)\
	NIBHEX	254
	NIBHEX	6
	NIBASC	\REL(6)\
	NIBHEX	255
	NIBHEX	6
	NIBASC	\REL(7)\
	NIBHEX	256
	NIBHEX	6
	NIBASC	\REL(8)\
	NIBHEX	257
	NIBHEX	5
	NIBASC	\RESET\
	NIBHEX	4080A
	NIBHEX	3
	NIBASC	\RSI\
	NIBHEX	6080810
	NIBHEX	6
	NIBASC	\RSTK=C\
	NIBHEX	3006
	NIBHEX	3
	NIBASC	\RTI\
	NIBHEX	300F
	NIBHEX	3
	NIBASC	\RTN\
	NIBHEX	3001
	NIBHEX	4
	NIBASC	\RTNC\
	NIBHEX	40400
	NIBHEX	5
	NIBASC	\RTNCC\
	NIBHEX	3003
	NIBHEX	5
	NIBASC	\RTNNC\
	NIBHEX	40500
	NIBHEX	5
	NIBASC	\RTNSC\
	NIBHEX	3002
	NIBHEX	6
	NIBASC	\RTNSXM\
	NIBHEX	3000
	NIBHEX	6
	NIBASC	\RTNYES\
	NIBHEX	2F0
aisR?E


aisS?A	NIBHEX	4
	NIBASC	\SB=0\
	NIBHEX	40822
	NIBHEX	6
	NIBASC	\SETDEC\
	NIBHEX	3005
	NIBHEX	6
	NIBASC	\SETHEX\
	NIBHEX	3004
	NIBHEX	6
	NIBASC	\SHUTDN\
	NIBHEX	40807
	NIBHEX	4
	NIBASC	\SR=0\
	NIBHEX	40824
	NIBHEX	5
	NIBASC	\SREQ?\
	NIBHEX	4080E
	NIBHEX	4
	NIBASC	\ST=0\
	NIBHEX	3284
	NIBHEX	4
	NIBASC	\ST=1\
	NIBHEX	3285
	NIBHEX	4
	NIBASC	\ST=C\
	NIBHEX	300A
	NIBHEX	6
	NIBASC	\STRING\
	NIBHEX	2A0
aisS?E


aisU?A	NIBHEX	6
	NIBASC	\UNCNFG\
	NIBHEX	40804
aisU?E


aisX?A	NIBHEX	4
	NIBASC	\XM=0\
	NIBHEX	40821	       *  4 Nibs to read ; 0 = No Parameter ; 821 = Opc.
aisX?E
******** End of data ********
RPL

*****************************************************************************
*			DISASSEMBLER
*****************************************************************************

** DoDisAss *****************************************************************
* Interface :	( $[32] # --> $[32]' #' )
* Description :	Disassemble one mnemonic from adr represented by the val of
*		#, force # to the next adr.
* Calls :	Pop# SavPtr P#ALoop
*
* Note:		No argument checks are made. This is up to the caller...
*		Mnemo field now starts at 9th char position !
*
* ToDo:		Pack this code (target: ~2K ;-)
*
*
*
* Ed. Hist. :
*     1.000	13.02.1992	RH	alpha
*     1.000	31.10.1992	RH	beta	Rem. unused P= 0
*						Ch. DispatchTables to REL(3)
*		21.04.1995	RH	review	Rem 'Label option'; Fix xx16
*					pack xF (save 40 bytes!), x130
*		22.04.1995	RH	move x3,
*					Change GTGO to allow backward jumps
*					Chg. User flag 8 -> 7 !!!
*					Some reordering, some code change
*					Mnemo field is now at 9th $ pos'n !!!
*		17.05.1995	RH	Rewrite xx16, lh5h
*		14.07.1998	RH	Recompiled
*		15.07.1998	RH	Chg. interface: Create $ from inside
*					#  --> $ #'
*****************************************************************************

LABEL	DoDisAss
ASSEMBLE
	PCode

* Status bits

sTEMP		EQU	0	* Temporary multi-purpose flag
sEXT.F		EQU	1	* Current extension is .F (ASRB.F fs)
sCON		EQU	2	* Used for r=r+CON fs,n etc.
sPAR_N		EQU	3	* Allow 'n' parameter
sGOYES		EQU	4	* Current opc MUST be a GOYES/RTNYES
sRTN		EQU	5	* Current opc is a RTNxx
sREL_GO		EQU	6	* Relative GO/GSB
sGSB		EQU	7	* Current opc is a GOSUB
sABS_GO		EQU	8	* Absolute GO/GSB
sPC		EQU	9	* PC manipulation
sGOVLNG		EQU	10	* GOVLNG/Dn=(5). Allow for external name


	GOSUBL	Pop#	&DIS
	GOSUBL	SavPtr

	R4=A

	INTOFF

	C=DAT1	A
	D0=C

	D0=D0+	10

	C=0	A
	LCHEX	20

	D=C	A	** Loop Count
	D=D-1	A

	AD0EX
	D0=A

nxspc	DAT0=C	B	** The space loop...
	D0=D0+	2
	D=D-1	A
	GONC	nxspc

	C=R4
	D1=C		&DIS				1:&DIS


** Here : The $ , now in Level 1 , is full of Spaces instead of Zeroes !
*CPU			A	B	C	D	D0	D1	P
*			&$Data	&DIS	20	&DIS	&$End+1	&DIS	0

	GOSUBL	D0=ramL

	C=0	W
	C=DAT0	B	** ____87654321		USERFLAGS

	D0=A		D0:&$Data			&$Data1	&DIS

	CSLC		** 876543210000		FLAGS

*			** BA9876543210		STATUS BITS
*			** 0000000x0000

	LAHEX	010	Mask out  sRTN, sREL_GO, sGSB, sABS_GO, sPC, sGOVLNG
	C=C&A	X	Leave sGOYES in its state at entry
	ST=C

	LCASC	\ A\
	D=C	W	** Standard Parameter

lbl	GOSUB	albl	** Push 'L' in front of $ ; increment D0

*CPU			A	B	C	D	D0	D1	P
*			chr		&$Data1		&$Data3	&DIS	2
	CD1EX
	D1=C

donec	GOSUBL	lh5hC
	D0=D0+	4	** Go to Mnemonic Field - New format !!!

	?ST=0	sGOYES	** Guess what !
	GOYES	xMAIN

	GOLONG	xGOYES

xMAIN	GOTO	MAIN
*****************************************************
xD	GOSUBL	P7Out
	NIBASC	\A=0 B=0 C=0 D=0 \
	NIBASC	\A=B B=C C=A D=C \
	NIBASC	\B=A C=B A=C C=D \
	NIBASC	\ABEXBCEXACEXCDEX\

*****************************************************
xA	GOSUB	AFS	** Adjusts carry !
	GOC	xC
	GOTO	xD
*	GONC	xD	** B.E.T.

*****************************************************
xC	GOSUBL	P9Out
	NIBASC	\A=A+BB=B+CC=C+AD=D+C\
	NIBASC	\A=A+AB=B+BC=C+CD=D+D\
	NIBASC	\B=B+AC=C+BA=A+CC=C+D\
	NIBASC	\A=A-1B=B-1C=C-1D=D-1\
*****************************************************
x0	A=C	S	Nib2
	LCHEX	E			E
	P=	15
	?A#C	S
	GOYES	L0

	GOTO	x0E	** It's a Logical

L0	P=	15
	LCHEX	3			3
	?C<A	S
	GOYES	L00

	ST=1	sRTN
	GONC	OUT0	** B.E.T.

L00	C=C+C	S			6
	?C<A	S
	GOYES	L000

	ST=1	sPC	** It's a RSTK=C
	GONC	OUT0	** B.E.T.

L000	C=C+1	S			7
	?C<A	S
	GOYES	OUT0	** It's anything else

	ST=1	sPC	** It's a C=RSTK

OUT0	D=0	A	** No parameter
	C=A	S

	GOSUBL	P11Out

	NIBASC	\RTNSXMRTN   RTNSC RTNCC \
	NIBASC	\SETHEXSETDECRSTK=CC=RSTK\
	NIBASC	\CLRST C=ST  ST=C  CSTEX \
	NIBASC	\P=P+1 P=P-1       RTI   \

*			[S]Nib2
x0E	GOSUB	GTNA	Nib3
	C=C+1	S			F
	B=C	S		F
	GOSUB	GETNC	[S]Nib3	F	[S]Nib4
	?A=B	S
	GOYES	isA

	C=A	S
	GOSUB	AFS_D1-	** Adjusts carry !

isA	B=C	S		Nib4	Nib4
	P=	15		Nib4
	LCHEX	8		Nib4	8
	?B<C	S
	GOYES	isAND

	ST=1	sTEMP
	B=B-C	S		Nib4-8

isAND	C=B	S			Nib4-8
	GOSUB	P9Out

	NIBASC	\A=A&BB=B&CC=C&AD=C&D\
	NIBASC	\B=B&AC=C&BA=A&CC=C&D\

*****************************************************
sub?1	GOSUB	mkofs
	GOSUB	getit
	NIBASC	\ABBCCADC\
	NIBASC	\ABBCCADC\
*****************************************************
x9	GOSUB	AFS	** Adjusts carry !
	GONC	X8B

X8A	GOSUB	a??
	GOTO	sub?

X8B	GOSUB	a??
	ST=1	sTEMP

*			A	B	C	D	D0	D1	P
sub?	C=D	A			"fs"	"fs"
	B=C	A		"fs"	"fs"
	A=C	S	Nib3
	D=C	S				Nib3
	LCHEX	8
	?A<C	S
	GOYES	low

	A=A-C	S

low	P=	3							3
	GOSUB	sub?1		"fs"		"AB"			3

	C=D	S			Nib3
	GOSUB	DAsub01	Nib3
	C=0	W
	P=	3
	C=B	WP			"fs"	"BA"
	CDEX	WP			"BA"	"fs"
	B=0	W
	B=C	WP	Nib3	"->BA"	"->BA"	"fs"
	P=	6
	LCASC	\ \
	BSR	A
	BSR	A		"B"
	P=	2							2
	?ST=1	sTEMP	** Is it a GROUP-B opcode ?
	GOYES	Btype

	?ABIT=1	2	** Is it a '#' ?
	GOYES	isDCR

	LCASC	\=\							4
	GONC	nxt?	** B.E.T.

isDCR	LCASC	\#\

nxt?	?ABIT=0	3	** Is it a 'r=0' ?
	GOYES	ok89

	P=	4
	A=0	W
	LAASC	\0\
	GONC	noshift

Btype	?ABIT=1	2
	GOYES	is<

	LCASC	\>\
	GONC	nxt=

is<	LCASC	\<\

nxt=	?ABIT=0	3
	GOYES	ok89

	P=	4
	LCHEX	003D
	BSL	A
	BSL	W

ok89	ST=0	sTEMP
	A=B	W		"AB"	"AB"
	GOSBVL	=ASLW4

noshift	GOTO	out81n

** AFS **********************************************
* IN   : C[S] NxtNib
* OUT  : A[S] Nib ; D1+1
* USES : A[S] ; A[A] ; B[S] ; C[S] ; P ; Carry
* CALLS: FSTAB(1) ; (GETNC) ; (mkofs) ; (getit)
*****************************************************
AFS_D1-	D1=D1-	1

AFS	B=C	S		&Nib2
	A=C	S	Nib2
	GOSUB	GETNC			Nib3
	P=	3

* IN   : A[S] Nib from GTNA ; P= Offset
* OUT  : A[S] #F ; A[A] calculated Offset ; P= Offset

	GOSUB	FSTAB

	A=B	S	Nib2
	B=C	S		Nib3
	P=	15
	LCHEX	8
	BCEX	S	Nib2	8	Nib3
	?A<B	S	** \a\ Type Parameter ?
	RTNYES

	RTNCC

** FSTAB ********************************************
* IN   : C[S] NxtNib
* OUT  : C[S] NxtNib ; D[A] &Par
* USES : A[S]
* CALLS: GETNC(1) ; mkofs(1) ; getit(1)
*****************************************************
FSTAB
	GOSUB	mkofs	[A]ofs
	P=	0

fstab
	GOSUB	getit
* Offset	 0 4 8 C 1014181C
	NIBASC	\P WPXSX S M B W \
	NIBASC	\P WPXSX S M B W \

*				 1	     1
*		 0123456789ABCDEF0123456789ABCDEF
*		\PP  WWPPXXSSXX  SS  MM  BB  WW  \

getit   C=RSTK		** Get Adress of List Start
	A=A+C	A	** Add Offset
	AD0EX		**
	C=DAT0	4	** Get item
	D0=A
	D=C	A	** Now in D : chosen Item
	RTNCC

*****************************************************
** Load up to 16 Hex-Digits into $
** IN   : C[S]=#Nibs ; D0=&Mnemo_Field ; D1=&Data_Start
** OUT  :	       D0=&Mnemo_Field ; D1=&Data_End+1
** D[S]=Loop Counter .
** Remember that this Nib came from Setup !
LH	CD0EX
	D0=C
	RSTK=C		** Save $Ptr
	D0=D0+	16	** Go to Parameter Field
	D=C	S			#Nibs	#Nibs
	P=C	15
	C=DAT1	WP
	GOTO	cshl1?	** MAYBE GONC WOULD DO...

cshl1	CSL	W
cshl1?	P=P+1
	GONC    cshl1

	P=	1	** Data is left-justified

lhlop	R1=C		** Save in R1
	D1=D1+	1	** Update &DIS ; &DIS is not used in this loop !
	A=C	S	** Prepare Nib
	GOSUB	mkofs	ofs
	GOSUB	x02F	** See above !
	C=R1
	CSL	W	** Shift left one Nib
	D=D-1	S
	GONC	lhlop

	C=RSTK		** Get original $Ptr
	D0=C		** Put it back
	RTNCC

*****************************************************
** Main Hash Table
MAIN	GOSUB	GTGO

	REL(3)	x0	** Special mnemos & logical
	REL(3)	x1	** Pointer arithmetic
	REL(3)	x2	** P=      n
	REL(3)	x3	** LCHEX   h..h
	REL(3)	x4      ** GOC     #hhhhh
	REL(3)	x5	** GONC    #hhhhh
	REL(3)	x6	** GOTO    #hhhhh
	REL(3)	x7	** GOSUB   #hhhhh
	REL(3)	x8	** Special mnemos & fs field tests
	REL(3)	x9	** A field tests
	REL(3)	xA	** fs field arithmetic
	REL(3)	xB	** fs field arithmetic
	REL(3)	xC	** fs field arithmetic
	REL(3)	xD	** A field arithmetic
	REL(3)	xE	** A field arithmetic
	REL(3)	xF	** A field arithmetic

x3	GOSUB	LH	** Get hex. parameter
	D1=D1+	1
	GOSUB	out_5
	NIBASC	\LCHEX\

** xF ***********************************************
*
*	mnemo	bit	value
*		3210
*	-----------------------
*	 ABCD	--xx	0,1,2,3
*	 SL	00
*	 SR	01
*	 -_	10
*	 -_-1	11
*****************************************************
xF
*Here: A[A] Trash (New PC) ; C[S] NxtNib ; D[S] 0 ; P= 15

	ST=0	sTEMP
	GOSUB	DAsub01

	LCASC	\A\	** Preload

	P=	2	** Preset P
	?ABIT=1	3	** 8-F ?
	GOYES	xf_8_F

	LCASC	\LS\	** Preload
	?ABIT=0	2
	GOYES	xf_com1

	P=	4
	LCASC	\R\

xf_com1	P=	5
	ABIT=0	2
	ABIT=0	3
	C=C+A	A	** Calculate reg name
	?ST=0	sTEMP
	GOYES	xf_done

**			BA9876543210
**			11--rr--==rr
	P=C	0
	C=P	6
	P=C	1
	C=P	7	** Copied reg name from C[B] to C[7:6] ; P invalid
	P=	11

xf_done	GOTO	outrss

xf_8_F	ST=1	sTEMP
	LCASC	\   -=\	** Preload
	P=	6
	?ABIT=0	2
	GOYES	xf_com1

	P=	8
	LCASC	\1-\
	GONC	xf_com1	** B.E.T.


** mkofs ********************************************
* IN   : A[S] Nib from GTNA ; P= Offset
* OUT  : A[S] #F ; A[A] calculated Offset ; P= Offset
* USES : A[S];A[A];(P)
*****************************************************
mkofs	ACEX	A
	C=0	A
	GOTO	nxofs0	** If nib is 0, offset is 0, too...

nxofs	C+P+1
nxofs0	A=A-1	S
	GONC	nxofs

	ACEX	A
	RTNCC
*****************************************************
xB	GOSUB	AFS	** Adjusts carry !
	GOC	xE
	GOTO	xF
*	GONC	xF

*****************************************************
xE	GOSUB	P9Out
	NIBASC	\A=A-BB=B-CC=C-AD=D-C\
	NIBASC	\A=A+1B=B+1C=C+1D=D+1\
	NIBASC	\B=B-AC=C-BA=A-CC=C-D\
	NIBASC	\A=B-AB=C-BC=A-CD=C-D\
*****************************************************
* 100 - 1Fhhhhh
x1	D1=D1-	1
	GOSUB	GTGO
*CPU			A	B	C	D	D0	D1	P
*[S]			#F	?	Nib3	?	&$Mnemo	&Nib4	15
*[A]			ofs	?	PC	"A "	&$Mnemo	&Nib4	15
	REL(3)	x100
	REL(3)	x110
	REL(3)	x120
	REL(3)	x130	** Dn=r, r=Dn, rDnEX
	REL(3)	x140	** DATn
	REL(3)	x150	** DATn
	REL(3)	x160	** D0=D0+ n
	REL(3)	x170	** D1=D1+ n
	REL(3)	x180	** D0=D0- n
	REL(3)	x190	** D0=(2) hh
	REL(3)	x1A0	** D0=(4) hhhh
	REL(3)	x1B0	** D0=(5) hhhhh
	REL(3)	x1C0	** D1=D1- n
	REL(3)	x1D0	** D1=(2) hh
	REL(3)	x1E0	** D1=(4) hhhh
	REL(3)	x1F0	** D1=(5) hhhhh

*****************************************************
x1F0	GOSUB	v5
	NIBASC	\D1=(5)\

x1E0	GOSUB	v4
	NIBASC	\D1=(4)\

x1D0	GOSUB	v2
	NIBASC	\D1=(2)\

x190	GOSUB	v2
	NIBASC	\D0=(2)\

x1A0	GOSUB	v4
	NIBASC	\D0=(4)\

x1B0	GOSUB	v5
	NIBASC	\D0=(5)\

v2	LCHEX	1
	GONC	vOUT	** B.E.T.

v4	LCHEX	3
	GONC	vOUT	** B.E.T.

v5	ST=1	sGOVLNG	***  Maps to USER Flag 7
	LCHEX	4

vOUT	D0=D0+	16	** Parameter Field
	GOSUB	across	** Push '#' into $
	D0=D0-	16	** Mnemo Field + 2
	D1=D1-	1
	GOSUB	LH	** See description there
	D0=D0-	2	** Adjust mnemo field
	D=0	A	** No parameter

P11nof	C=0	S	** No offset
	GOTO	P11Out
*****************************************************
**
vn	GOSUB	xx16
	GOTO	P11nof

x1C0	GOSUB	vn
	NIBASC	\D1=D1-\

x180	GOSUB	vn
	NIBASC	\D0=D0-\

x170	GOSUB	vn
	NIBASC	\D1=D1+\

x160	GOSUB	vn
	NIBASC	\D0=D0+\
*****************************************************
*---------- field -----------
* A	 B	 fs	 d
*----------------------------
*140	148	150a	158x	DAT0=A field
*141	149	151a	159x	DAT1=A field
*142	14A	152a	15Ax	A=DAT0 field
*143	14B	153a	15Bx	A=DAT1 field
*144	14C	154a	15Cx	DAT0=C field
*145	14D	155a	15Dx	DAT1=C field
*146	14E	156a	15Ex	C=DAT0 field
*147	14F	157a	15Fx	C=DAT1 field


x140	LAHEX	8	** Remember that P was 15 !
	?A>C	S	** Parameter 'A' ?
	GOYES	out14_5

	C=C-A	S	** Make C[S] suitable for P11Out
	P=	0
	D=D+1	P	** Transform given 'A' to 'B'

out14_5 GOSUB	P11Out
	NIBASC	\DAT0=ADAT1=AA=DAT0A=DAT1\
	NIBASC	\DAT0=CDAT1=CC=DAT0C=DAT1\

*****************************************************
albl	GOSUB	chr	** albl moved to here as a pack
	NIBASC	\L\
*****************************************************
x150	D=C	S			Nib3	Nib3
	LCHEX	8			8
	?D<C	S
	GOYES	is15fs

	D=D+C	S
	GOSUB	xx16C	** CC
	GONC	out145s	** B.E.T.

is15fs	GOSUB	GETNC
	GOSUB	AFS_D1-	** Adjusts carry !

out145s	C=D	S
	GOTO	out14_5

** GTNA *********************************************
* IN   : D1
* OUT  : A[S] Nib ; D1+1
* USES : A[S]
*****************************************************
GTNA	A=DAT1	S
	D1=D1+	1	** Increment
	RTNCC
*****************************************************
GETNC	C=DAT1	S
	D1=D1+	1
	RTNCC
*****************************************************
x100
x110
x120	D=0	A	** No parameter

sb100	D1=D1-	2

	GOSUB	GTNA	Nib2		Nib3	0
	D1=D1+	1
	GOSUB	DAsub01	Nib2;Nib3

	LCASC	\A\
	B=C	A

	LCASC	\0\

	?ABIT=0	3
	GOYES	regA

	B=B+1	B
	B=B+1	B

regA	ABIT=0	3
	C=C+A	B
	CSLC
	CSLC
	LCASC	\R\

	A=A-1	S
	GOC	ss=r

	CSLC
	CSLC
	A=A-1	S
	GOC	r=ss

	P=	6
	LCASC	\XE\
	C=C+B	B

outrss9	P=	9
	GOTO	outrss

r=ss	CSLC
	CSLC
	P=	2
	LCASC	\=\
	C=C+B	B

outrss7	P=	7
	GOTO	outrss

ss=r	P=	4
	LCASC	\=\
	A=B	A
	GOSBVL	=ASLW5
	ASL	W

out81n	P=	7
	C=C+A	WP

outrss	AD1EX
	GOTO	OUTrss
*****************************************************

** x130 *********************************************
*
*	mnemo	bit	value
*		3210
*	-----------------------
*	AC	-x--	0,1
*	Dn	---x	0,1
*	rDnEX	--x-	0,1
*	____S	1---	0,1
*****************************************************
x130	D=0	A	** No parameter

	GOSUB	DAsub01
*							9876543210
	LCASC	\XE0DA\					XXEE00DDAA|	AD0EX
*								 ^
	?ABIT=1	1	** EX type ?
	GOYES	x130_EX	** P=0 !

	LCASC	\ A=0D\					__AA==00DD|	D0=A
	P=	6	** Set P for r (A or C)		   ^

x130_EX	?ABIT=0	2	** register A ?
	GOYES	x130_rA

	C=C+1	P
	C=C+1	P	** Make a 'C' from the given 'A'  CC or CC

x130_rA	?ABIT=0	0	** D0 ?				__CC==00DD|	D0=C
	GOYES	x130_D0

**Here:	__rr==00DD	P=6	P should go to 2
** or	XXEE00DDrr	P=0	P should go to 4


	?P=	0	** Was Dn=r ?
	GOYES	x130_Px					9876543210
*							XXEE00DDAA|	AD0EX
	P=	2					       ^
	GONC	x130_Pz

x130_Px	P=	4

x130_Pz	C=C+1	P	** D1 instead of D0		XXEE11DDAA|	AD1EX

x130_D0	?ABIT=0	3
	GOYES	x130out					XXEE11DDAA|	AD1EX

	P=	8					 ^
	LCASC	\S\					SS
	?ABIT=0	1
	GOYES	x130out

	P=	6					   ^
	LCASC	\X\					SSXX

x130out
	GOTO	outrss9


** GTGO *********************************************
* IN  :
* OUT : A[A] New PC ; C[S] NxtNib ; D[S] 0 ; P= 15
*****************************************************
GTGO	GOSUB	GTNA	[S] Nib1				&Nib2
	P=	2
	GOSUB	mkofs	[A] ofs
	GOSUB	GETNC	[A] ofs 	[S] Nib2		&Nib3
	P=	15	** Preset
	C=RSTK
	C=C+A	A			ofs into REL table
	CD0EX
	A=0	A
	A=DAT0	3	REL
	CD0EX

	?ABIT=0	11
	GOYES	gtgoOK	** Positive offset

	A=-A	X
	C=C-A	A
	PC=C

gtgoOK	C=C+A	A			REL+ofs
	PC=C		** Go for it !


*****************************************************
aplus	GOSUB	chr
	NIBASC	\+\

aminus	GOSUB	chr
	NIBASC	\-\

across	GOSUB	chr
	NIBASC	\#\

a??	ST=1	sGOYES	** Mark next step is GOYES/RTNYES
	GOSUB	chr
	NIBASC	\?\

chr	C=RSTK		** XEQ>GO **	Rstk
wrti	CD0EX				&$Data			&chr=Rstk
	A=DAT0	B	chr
	D0=C							&$Data1
	DAT0=A	B	** Write Char to $
	D0=D0+	2	** and increment			&$Data3
	RTNCC
*****************************************************
x8A	GOTO	X8A
x8B	GOTO	X8B
*****************************************************

x4	D1=D1-	1	&Nib2
	A=0	A
	A=DAT1	B
	D1=D1+	3
	?A#0	B
	GOYES	xgo1

	ST=1	sRTN
	GOSUB	out_4
	NIBASC	\RTNC\

xgo1	P=	0
	LCHEX	02
	?A#C	B
	GOYES	nonop3

	GOSUB	out_4
	NIBASC	\NOP3\

nonop3	D1=D1-	3
	GOSUB	s8CE_P1
	NIBASC	\GOC   \

xGOYES	ST=0	sGOYES
	A=0	A
	A=DAT1	B
	?A#0	B
	GOYES	goyes

rtnyes	D1=D1+	3
	GOSUB	out_6
	NIBASC	\RTNYES\

goyes	P=	1
	GOSUB	s8CE_CD
	NIBASC	\GOYES \

*****************************************************
DAsub01	C=0	A

DAsub02
	P=C	15
	CPEX	0
	A=C	A	Nib3

	RTNCC

*****************************************************
x5	D1=D1-	1	D1 &Nib2
	A=0	A
	A=DAT1	B
	?A#0	B
	GOYES	gonc

	ST=1	sRTN
	D1=D1+	3
	GOSUB	out_5
	NIBASC	\RTNNC\

gonc	GOSUB	s8CE_P1
	NIBASC	\GONC  \

*****************************************************
x6	D1=D1-	1					D1 &Nib2
	A=0	A
	C=0	A
	A=DAT1	3
	P=	0
	LCHEX	3
	?A#C	A
	GOYES	nonop4
	GOSUB	outNOP
	NIBASC	\NOP4\

nonop4	C=C+1	A
	?A#C	A
	GOYES	nonop5

	D1=D1+	1
	GOSUB	outNOP
	NIBASC	\NOP5\

nonop5	P=	2
	GOSUB	s8CE_S6
	NIBASC	\GOTO  \

outNOP	D1=D1+	4
	GOTO	out_4
*****************************************************
x7	P=	2
	ST=1	sGSB	** rel. GSB
	D1=D1-	1
	CD1EX
	D1=C
	D1=D1+	3
	CD1EX
	GOSUB	s8CE
	NIBASC	\GOSUB \


*************************************************************************
**
**	 OOOO	U    U	TTTTTTT
**	O    O	U    U	   T
**	O    O	U    U	   T
**	O    O	U    U	   T
**       OOOO	 UUUU	   T
**
*************************************************************************
**  OUTOUTOUTOUTOUTOUTOUT : Exit_Routine for all
**
*CPU			A	B	C	D	D0	D1	P
*			[S]Nib	?		"Para"	&$Mnemo	&DIS	?

out_sub	C=0	S	** No offset
	D=0	A	** No parameter
	D1=D1-	1	** Adjust &DIS
	RTNCC

out_sb2	CD0EX
	B=C	A
	C+P+1
	D0=C
	P=	0
	RTNCC


out_6	GOSUB	out_sub

P11Out	P=	11	** Read 6 Chars
	GOTO	POut

out_5	GOSUB	out_sub

P9Out	P=	9	** Read 5 Chars
	GOTO	POut

out_4	GOSUB	out_sub
P7Out	P=	7	** Read 4 Chars
POut	A=C	S	Nib2
	GOSUB	mkofs

OUTnof	C=RSTK		** Get Table Start Adr
	A=A+C	A	** Calc Offset
	AD1EX		** #NxtAdr

	C=DAT1	WP	** Get Mnemonic
	?ST=0	sTEMP
	GOYES	OUTrss

	C=P	15
	P=	6
	LCASC	\!\
	P=C	15

OUTrss	DAT0=C	WP	** Write to $
	?ST=0	sEXT.F
	GOYES	not.F

	GOSUB	out_sb2
	LCASC	\F.\
	DAT0=C	4
	GOTO	out81

not.F	?ST=0	sCON
	GOYES	notCON

	GOSUB	out_sb2
	LCASC	\NOC\
	DAT0=C	6

out81	C=B	A
	D0=C

notCON	?D=0	A	** No Parameter ?
	GOYES	nopar

	?ST=1	sGOYES
	GOYES	is?

	D0=D0+	2

is?	D0=D0+	14	** Switch to parameter field
	C=D	W
	?ST=0	sCON
	GOYES	std

	DAT0=C	8

std	DAT0=C	4	** Push parameter data into $

nopar	P=	0
	GOSUB	D0=ramL
	C=0	A
	C=ST
	CSRC
	DAT0=C	B	** Write new User flag status from ST
	INTON

	GOLONG	P#ALoop

*****************************************************
*CPU			A	B	C	D	D0	D1	P
*[S]			#F	?	Nib3	?	&$Mnemo	&Nib4	15
*[A]			ofs	?	PC	"A "	&$Mnemo	&Nib4	15
x8	D1=D1-	1
	GOSUB	GTGO
*CPU			A	B	C	D	D0	D1	P
*[S]			#F	?	Nib4	?	&$Mnemo	&Nib5	15
*[A]			ofs	?	PC	"A "	&$Mnemo	&Nib5	15
	REL(3)	x80
	REL(3)	x81
	REL(3)	x82
	REL(3)	x83
	REL(3)	x84
	REL(3)	x85
	REL(3)	x86
	REL(3)	x87
	REL(3)	x88
	REL(3)	x89
	REL(3)	x8A
	REL(3)	x8B
	REL(3)	x8C
	REL(3)	x8D	** GOVLNG  #hhhhh
	REL(3)	x8E
	REL(3)	x8F	** GOSBVL  #hhhhh

*****************************************************
x8F	ST=1	sGSB
	ST=1	sABS_GO	** Absolute GSB
	GOSUB	v5
	NIBASC	\GOSBVL\
*****************************************************
x8D	ST=1	sREL_GO	** Any GO
	ST=1	sABS_GO	** Absolute GO
	GOSUB	v5
	NIBASC	\GOVLNG\
*****************************************************
x02F	GOSUB	get02F
	NIBASC	\0123456789ABCDEF\

get02F	C=RSTK
	C=C+A	A	#		&chr
	GOTO	wrti	** Write chr into $
*****************************************************

D0=ramL	GOSUB	D0=RAM
	CON(5)	=UserFlags_G
	CON(5)	=UserFlags

	RTNCC

*****************************************************
x8C	P=	3
	D1=D1-	1
	GOSUB	s8CE_S6
	NIBASC	\GOLONG\
*****************************************************
x8E	ST=1	sGSB
	P=	3
	D1=D1-	1
	CD1EX
	D1=C
	D1=D1+	4
	CD1EX
	GOSUB	s8CE
	NIBASC	\GOSUBL\

** s8CE *********************************************
* Build offsets and push into $
*****************************************************
s8CE_P1 P=	1
s8CE_S6	ST=1	sREL_GO
s8CE_CD CD1EX
	D1=C

s8CE	B=C	A		PC
	C=0	A
	C=DAT1	WP			data
	D=C	P
	D=D+D	P
	GONC	posi

	ST=1	sTEMP	** Mark negative jump
	C=-C	WP
	B=B-C	A
	GOTO	negok

posi	B=B+C	A

negok	C=P	15
	D=C	S
	D=C	A	** Save difference
	D0=D0+	16

nocros	GOSUB	albl

cdone	GOSUB	lh5h
	D0=D0+	2
	?ST=1	sTEMP
	GOYES	negsign

	GOSUB	aplus
	GONC	ndone	** B.E.T.

negsign	GOSUB	aminus

ndone	ST=0	sTEMP
	C=D	A
	B=C	A
	GOSUB	lh5h
	D0=D0-	16
	D0=D0-	16
	D0=D0-	10
	CD1EX
	C=D	S
	P=C	15
	P=P+1
	C+P+1
	D1=C
	GOTO	out_6

*****************************************************
x89	ST=1	sGOYES	** This is a pack
x2	GOSUB	nparMI
	NIBASC	\P=  \
*****************************************************
xx16C	GOSUB	GETNC

xx16	ST=1	sTEMP

x016	C=0	A
	CSLC				C[0]:Nib3
	P=	0
	LAHEX	A
	?C<A	P
	GOYES	okLTA16

	C=C-A	P
	P=	1
	C=C+1	P

okLTA16	?ST=0	sTEMP
	GOYES	ok015

	SETDEC
	C=C+1	B	** Range from 1-16	C[B]:1x
	SETHEX

ok015	P=C	0
	CPEX	1
	C=P	0	** Swap nibs 1 and 0	C[B]:x1

	P=	3	** Form ASCII
	C=P	3				C[3:0]:3_x1	P= 3
	CPEX	1				C[3:0]:3_31	P= x
	C=P	2				C[3:0]:3x31	P= x

	P=	0
	?C#0	P
	GOYES	ok16_1

	CSR	A
	CSR	A

	P=	2
	LCHEX	20

ok16_1	ST=0	sTEMP
	D=C	A
	RTNCC

** lh5h *********************************************
**   Load 5 HEX digits into $
**
** IN	: B[A]: hhhhh
** USES : A[A],C[W],P
** CALLS: =CSLW5(0),x02F(1)
**
*CPU			A	B	C	D	D0	D1	P
*			?	?	?	5Nibs	&$Data	&DIS	?
lh5h	C=B	A			5Nibs
lh5hC	P=C	0
	CPEX	4
	C=P	0
	P=C	1
	CPEX	3
	C=P	1			5Nibs ** Order inverted
	GOSBVL	=CSLW5			5Nibs<-
	P=	15
	LCHEX	4			[S] 3

lh5lop	C=0	A			0
	CSR	M
	P=	0
	CPEX	4
	C=P	0
	A=C	A
	A=A+A	A
	GOSUB	x02F
	C=C-1	S
	GONC	lh5lop

	RTNCC

*****************************************************
x88	GOSUB	npar?MI
	NIBASC	\P#  \

x87	ST=1	sGOYES	** This is a pack
x85	GOSUB	nparMI
	NIBASC	\ST=1\

x86	ST=1	sGOYES	** This is a pack
x84	GOSUB	nparMI
	NIBASC	\ST=0\
*****************************************************
x83	ST=1	sGOYES	** Mark NEXT Step is a GO/RTNYES
x82	ST=1	sPAR_N	** NO Parameter ; ST3 is shifted out at Exit
	D=0	A	** No parameter
	A=0	S
	A=A+1	S	1
	?A#C	S
	GOYES	sb0

	GOSUB	nparMI
	NIBASC	\XM=0\

sb0	A=A+1	S	2
	?A#C	S
	GOYES	sr0

	GOSUB	nparMI
	NIBASC	\SB=0\

sr0	A=A+A	S	4
	?A#C	S
	GOYES	mp0

	GOSUB	nparMI
	NIBASC	\SR=0\

mp0     A=A+A	S	8
	?A#C	S
	GOYES	hst0

	GOSUB	nparMI
	NIBASC	\MP=0\

hst0	A=0	S
	A=A-1	S	F
	?A#C	S
	GOYES	hsn0

	GOSUB	out_6
	NIBASC	\CLRHST\

hsn0	ST=0	sPAR_N	** Allow 'n' Parameter
	GOSUB	nparMI
	NIBASC	\HS=0\

*****************************************************
*CPU			A	B	C	D	D0	D1	P
*[S]			#F	?	Nib3	?	&$Mnemo	&Nib4	15
*[A]			ofs	?	PC	"A "	&$Mnemo	&Nib4	15

x80	D=C	S			Nib3	Nib3
	LCHEX	E			E
	?C#D	S
	GOYES	not80E

x80E	D1=D1+	1
	GOSUB	out_5
	NIBASC	\SREQ?\

not80E	P=	15
	LCHEX	C			C	Nib3
	?C>D	S
	GOYES	notC2F
*****************************************************
	D=D-C	S				Nib3-C
	GOSUB	npar
	NIBASC	\C=P P=C     CPEX\

npar?MI ST=1	sGOYES	** Re-use sGOYES

nparMI	D1=D1-	1
	?ST=0	sGOYES	** No ?
	GOYES	npar

npar?	GOSUB	a??

npar	GOSUB	GETNC			Nib4

	?ST=1	sPAR_N
	GOYES	non

	GOSUB	x016

non	C=D	S			Nib3-C
	GOTO	P7Out

npar?6	GOSUB	a??

npar6	D1=D1-	1
	GOSUB	GETNC			Nib4
	GOSUB	x016
	C=0	S
	GOTO	P11Out
*****************************************************
notC2F	P=	15
	LCHEX	8
	?C#D	S
	GOYES	not808

	GOTO	x808

not808	C=D	S
	D=0	A	** No parameter
	GOSUB	P11Out
	NIBASC	\OUT=CSOUT=C A=IN  C=IN  UNCNFGCONFIG\
	NIBASC	\C=ID  SHUTDN      C+P+1 RESET BUSCC \

*****************************************************
GTCI	GOTO	GETNC
*****************************************************
x808	GOSUB	GTGO
*****************************************************
*CPU			A	B	C	D	D0	D1	P
*[S]			#F	?	Nib4	?	&$Mnemo	&Nib5	15
*[A]			ofs	?	PC	"A "	&$Mnemo	&Nib5	15
	REL(3)	x8080	** INTON
	REL(3)	x80810	** RSI
	REL(3)	x8082	** LAHEX   h..h
	REL(3)	x8083	** BUSCB
	REL(3)	x8084	** ABIT=0  n
	REL(3)	x8085	** ABIT=1  n
	REL(3)	x8086	** ?ABIT=0 n
	REL(3)	x8087	** ?ABIT=1 n
	REL(3)	x8088	** CBIT=0  n
	REL(3)	x8089	** CBIT=1  n
	REL(3)	x808A	** ?CBIT=0 n
	REL(3)	x808B	** ?CBIT=1 n
	REL(3)	x808C	** PC=(A)
	REL(3)	x808D	** BUSCD
	REL(3)	x808E	** PC=(C)
	REL(3)	x808F	** INTOFF
*****************************************************
x808F	GOSUB	out_6
	NIBASC	\INTOFF\

x808E	GOSUB	pcman
	NIBASC	\PC=(C)\

x808D	GOSUB	out_5
	NIBASC	\BUSCD\

x808C	GOSUB	pcman
	NIBASC	\PC=(A)\

x8083	GOSUB	out_5
	NIBASC	\BUSCB\

x80810	D1=D1+	1
	GOSUB	out_4
	NIBASC	\RSI \

x8080	GOSUB	out_5
	NIBASC	\INTON\
*****************************************************
pcman	ST=1	sPC
	GOTO	out_6
*****************************************************
x8082
	GOSUBL	LH

	C=0	S
	D1=D1+	1
	GOSUB	out_5
	NIBASC	\LAHEX\

x8084	GOSUB	npar6
	NIBASC	\ABIT=0\

x8085	GOSUB	npar6
	NIBASC	\ABIT=1\

x8086	GOSUB	npar?6
	NIBASC	\ABIT=0\

x8087	GOSUB	npar?6
	NIBASC	\ABIT=1\

x8088	GOSUB	npar6
	NIBASC	\CBIT=0\

x8089	GOSUB	npar6
	NIBASC	\CBIT=1\

x808A	GOSUB	npar?6
	NIBASC	\CBIT=0\

x808B	GOSUB	npar?6
	NIBASC	\CBIT=1\

*****************************************************
**
sub81	B=0	S
	B=B-1	S
	GOSUB	GTCI			Nib4=f
	?B=C	S
	GOYES	is81AF

	GOSUBL	AFS			Nib5=r	** Adjusts carry !
	RTNCC		** We want the carry clear

is81AF	GOTO	GTCI	** -> GETNC

*****************************************************
** C[S]	Nib3	D1 &Nib4
x81
	B=C	S		Nib3				&Nib4
	LCHEX	B			B
	?B#C	S
	GOYES	is81A?

	GOSUB	GTCI			Nib4			&Nib5
	D=0	A	** No parameter
	GOSUB	P9Out


	NIBASC	\!81B?!81B?PC=A PC=C A=PC C=PC APCEXCPCEX\

is81A?	ST=1	sEXT.F	** Set Flag for '.F'
	C=C-1	S		Nib3	A			&Nib4
	?B#C	S
	GOYES	is819?

	GOSUB	sub81
	A=C	S	Nib5
	GOSUB	GTCI			Nib6=n
	GOLONG	sb100

is819?	C=C-1	S		Nib3	9
	?B#C	S
	GOYES	is818?

	GOSUB	sub81
	B=C	S
	P=	15
	LCHEX	8
	B=B+C	S
	GOTO	is81x
*****************************************************
is818?	ST=0	sEXT.F	** We have no more '.F' Extension
	C=C-1	S		Nib3	8
	?B=C	S
	GOYES	is818

	GONC	is81n	** B.E.T.

is818	ST=1	sCON	** We now have a 'CON' Extension
	GOSUB	sub81
	C=D	A
	B=C	W		Nib5;"fs"
	GOSUB	xx16C				"1-16" (from Nib6)
	C=D	A			"1-16"
	GOSBVL	=CSLW4
	C=B	B
	P=	2
	LCHEX	2C	** Put the ',' in place
	D=C	W	** Parameter part is complete !

	C=0	W
	C=B	S
	GOSUB	DAsub02

	LCASC	\+A=A\

	?ABIT=0	3
	GOYES	isplus

	P=	6
	LCASC	\-\
	P=	0
	ABIT=0	3

isplus	C=C+A	B

asl4out	GOSBVL	=ASLW4

do81n
	GOLONG	out81n

is81n	D=0	A	** No parameter

is81x	C=0	W
	C=B	S
	CSLC
	A=C	W

	P=	2
	?ABIT=1	3
	GOYES	rSRB

	?ABIT=1	2
	GOYES	rSRC

	LCASC	\CLS\
	GONC	ok81n

rSRC	LCASC	\CRS\
	GOC	ok81n

rSRB	LCASC	\BRS\

ok81n	ABIT=0	2
	ABIT=0	3

	P=	0
	LCASC	\A\

	GOTO	do81n
RPL

** D0=RAM *******************************************************************
* Entry :	RSTK points to GX var, followed by SX var
* Exit :	D0 address of RAM variable
* Uses :	D0 C[A]
* Stack levels: 1
* Ed. Hist. :
*     1.000 07/23/93 DM alpha
*****************************************************************************

ASSEMBLE

* CPU				C	D0

D0=RAM	D0=(5)	(=addrADISP)+6	magic location (->RAM start val)
	C=DAT0	B		N
	?CBIT#1 3
	GOYES	isSX				carry set if SX

	C=RSTK			->1st
	D0=C				->1st
	C=DAT0	A		1st
	D0=D0+	10			->ret
	CD0EX			->ret	1st
	PC=C

isSX	C=RSTK			->1st
	D0=C				->1st
	D0=D0+	5			->2nd
	C=DAT0	A		2nd
	D0=D0+	5			->ret
	CD0EX			->ret	2nd
	PC=C
RPL


*****************************************************************************
*			ENTRIES CATALOG
*****************************************************************************

** xEC **********************************************************************
* Description:	Extended ROM Entries (Tab) CAT
*		IF NONEXISTENT, creates an index table named ECpar in SRRP
*		THEN lets you browse through Tab online.
*		Subsequent calls to EC cause the program to refer
*		to ECpar.
*		Scan a map for firstchars to jump to.
*		Search for String from next page on.
*		Easy re-search (NXT).
* To do:	- Embed this code into a FAST source editor (Hi Detlef)
* Edition History :
*     0.000 23.01.1992	RH	alpha version
*     1.000 01.02.1992	RH	release
*	100 25.04.1992	RH	New offset scheme into Tab
*	200 28.04.1992	RH	Reverse order to write into {}
*	300 03.05.1992	RH	'GOTO First Char' feature
*	400 04.05.1992	RH	Packing, Bugfix
*	401 18.05.1992	RH	Scan for word (NOT FINISHED YET)
*     2.000 21.05.1992	RH/DM	Finished Scanning (DM/RH)
*				Add Rescan (with key REPEAT) on NXT key
*				Change 'GOTO' key to 'A-Z'
*				BugFix: &{} items saved in scratch
*
*	Enhanced version of the famous Entries Table (RPL.TAB) browser
*	Now EIGHT lines are displayed simulaneously
*	Most things work faster
*	The ADR? key has been omitted 'cause the address and type info
*	are always shown
*	SCAN now finds all (see below)
*
*	16.04.93	RH	Packed (Saved ~300 Bytes)
*	20.04.93	RH	Start
*	24.04.93	RH
*	29.04.93	RH	Add ECget (to stack)
*	02.05.93	RH	Complete A-Z
*	16.05.93	RH	Complete new SCAN
*				Now SCAN will find EACH occurence of $
*****************************************************************************

DEFINE	ECMAXLAMS	EIGHT

DEFINE	ECexit! 	1PUTLAM
DEFINE	ECexit@ 	1GETLAM
DEFINE	ECNxPr		2GETEVAL
DEFINE	ECn!		3PUTLAM
DEFINE	ECn@		3GETLAM
DEFINE	Y!		4PUTLAM
DEFINE	Y@		4GETLAM
DEFINE	INVLINE 	5GETLAM EVAL
DEFINE	BAK_1!		6PUTLAM
DEFINE	BAK_1@		6GETLAM
DEFINE	BAK_2!		7PUTLAM
DEFINE	BAK_2@		7GETLAM
DEFINE	ECTMP$! 	8PUTLAM
DEFINE	ECTMP$@ 	8GETLAM


ASSEMBLE
	XNAME	EC
RPL
::
    TakeOver CKRPLInst

    EditLExists?
    ITE
	ClrDA2bIsEdL
    ::	CK0NOLASTWD
	BlameEC
	InitEdModes			( reset the edit modes )
    ;

    RECLAIMDISP
    ClrDA1IsStat

    POLSaveUI

    InitSFlags

    ERRSET
    ::
	RECLAIMDISP

	GetRPLTab NOTcase
	::  # 60D ERRORSTO ERRJMP
	;

	' ID ECpar RclID ?SKIP
	::
		( *This routine creates a hxs string containing page offsets
		   into RPL.TAB. RPL.TAB must exist. VERY fast: Takes ~2
		   seconds to create the whole table !* )
	    "EC"
	    ARRY
	    [	"Creating ECpar,"
		"Please Wait\1F"
	    ]
	    THREE DUP popup

	    Ec1stOf

	    [BEGIN]
		EcMkECp
	    [WHILE]
		&HXS
	    [REPEAT]

	    DUP' ID ECpar STO
	;

	NULL$				( *LAM 8 - ECTMP$* )

	ZEROZERO			( *LAM 7&6 - BAK_2/1* )

	'                               ( *LAM 5 - INVLINE* )
	::  Y@ EcInvR
	;

	ZEROZERO			( *LAM 4&3 - Y & ECn* )

	'                               ( *LAM 2 - ECNxPr* )
	::  EcNxPr
	    ECn!			( --> hxs $RPL.TAB #PageOffset )
	    EcNxPr2
	;

	FALSE'                          ( *LAM 1 - ECExit* )

	NULLLAM ECMAXLAMS NDUPN DOBIND

	SWAP

	LABEL	ECReDraw
	::  ECn@ ECNxPr INVLINE
	;
					( *POL Parameter* )
	' DispMenu.1                    ( *Level 9* )
	' EChardKeys                    ( *Level 8* )
	TrueTrue			( *Level 6,7* )
	' ECsoftKeys                    ( *Level 5* )
	ONEFALSE' ECexit@               ( *Level 4,3,2* )
	'ERRJMP                         ( *Level 1* )

	POLSetUI POLKeyUI

	ABND
	2DROP
    ;
    ERRTRAP
    ::
	RestSFlags
	POLResUI&Err
    ;

    RestSFlags
    POLRestoreUI
    ClrDAsOK
;


LABEL EChardKeys
::
    kpNoShift #=casedrop
    ::
	DUP#<7 casedrpfls

	kcDownArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcDownArrow
	    ::
		BAK_1! BAK_2!
		INVLINE Y@ #1+DUP EIGHT #= IT
		::  DROP  ECn@ #1+ ECNxPr ZERO
		;

	      LABEL ECudRem
		Y! INVLINE
		BAK_2@ BAK_1@

		SlowG
	    ;
	;

	kcUpArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcUpArrow
	    ::
		BAK_1! BAK_2!
		INVLINE Y@ #1-DUP MINUSONE #= IT
		::  DROP  ECn@ #1- ECNxPr SEVEN
		;
		GOTO ECudRem
	    ;
	;

	kcNextRow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcNextRow
	    ::
		ECTMP$@ NULL$? caseDEADKEY
		4UNROLL 4UNROLL
		ECTMP$@ ECfindS
		4ROLL 4ROLL
	    ;
	;

	kcEnter ?CaseKeyDef
	::  TakeOver
	    LABEL	ECgetItem
	    ::
		ECn@ EcNxPr	( *Transform page count into page offset* )
		DROP Y@
		EcGetEl
	    ;
	    SWAPDROP
	    DUPTYPEHSTR? caseDrpBadKy
	    EditLExists? NOTcase UNROT

	    ?Space/go>
	    Echo$NoChr00

	    LABEL	?Space/go>
	    ::
		EvalSG: ?Space/Go> ?Space/Go>_G
	    ;
	;

	kcOn ?CaseKeyDef
	::  TakeOver
	    TRUE ECexit!
	;

    LABEL ECKeys

	kcRightShift #=casedrpfls
	DROPDEADTRUE
    ;

    kpRightShift #=casedrop
    ::
	kcUpArrow ?CaseKeyDef
	::  TakeOver
	    ZEROZERO Y!
	    ECNxPr INVLINE
	;

	kcEnter ?CaseKeyDef
	::
	    LABEL	BadIfEdit
	    ::
		TakeOver
		EditLExists? NOT?SEMI
		DoBadKey RDROP
	    ;

	    ECgetItem SWAPDROP
	    DUPTYPEHSTR? caseDrpBadKy
	    AdjEdModes
	    SetDA2NoCh
	    $>EDITLINE
	    ClrDA2bIsEdL
	;

	kcOn #=casedrpfls

	GOTO ECKeys
    ;

    2DROP 'DoBadKeyT
;


LABEL	ECsoftKeys
{
    {	"PG\90"
	::  TakeOver
	    REPEATERCH
	    kcMenuKey1
	    ::	BAK_1! BAK_2!
		ECn@ #1- ECNxPr
		BAK_2@ BAK_1@
	    ;
	    INVLINE
	;
    }
    {	"PG\8F"
	::  TakeOver
	    REPEATERCH
	    kcMenuKey2
	    ::	BAK_1! BAK_2!
		ECn@ #1+ ECNxPr
		BAK_2@ BAK_1@
	    ;
	    INVLINE
	;
    }
    {	"scan"
	::  TakeOver
	    "Enter Search-String:"
	    ECTMP$@

	    EditLExists?
	    ITE
		ECscanUtl
	    ::
		{ ONE ONE }
		#TWO#ONE		( *Alphanumeric input* )
		ONE
		NULL{}
		ZEROFALSE
		ZERO
		InputLine
		ClrDA1IsStat
	    ;

	    NOTcase ECReDraw

	    LABEL	ECfindS
	    ::
		NINE 1_#1-SUB$ DUPLEN$
		#0= casedrop ECReDraw

		DUP ECTMP$!

		ECn@ Y@

		EcFind case
		::  DoBadKey ECReDraw
		;

		EIGHT #/
		OVER #0= IT #1-

		ECn!

		DUP#0=ITE #7+ #1-
		Y!

		ECReDraw
	    ;
	;
    }
    {	"a-z"
	::  TakeOver
	    ECgetItem SWAPDROP		( --> hxs $RPL.TAB $tok )
	    GETGOTO			( --> hxs $RPL.TAB #tok )
	    ::	Eca-z ?SEMI
		Y! ECn!
	    ;

	    ECReDraw
	;
    }
    {	::  TakeOver
	    EditLExists?
	    ITE
		"about"
		"astk"
	    MakeStdLabel
	;
	::  TakeOver
	    EditExstCase
	    ::	DispVer $cont DispCoord1
		WaitForKey 2DROP
		ECReDraw
	    ;
	    ECgetItem TYPEHSTR? caseDrpBadKy
	    #>HXS UNROT
	;
    }
    {	"help"
	::  TakeOver
	    EChelp ECReDraw
	;
    }
}


LABEL	ECscanUtl			( $ $ --> $' t | f )
::
    RECLAIMDISP
    SWAP DISPROW3
    NULL$ DispCoord1
    FALSE SWAP
    BEGIN
	DUP CHR \7F >T$ DISPROW7
	LockAlpha
	WaitForKey
	OVER kcOn
	#=ITE
	::  4DROP TRUE NULL$
	;
	::  4 OVER#> case2DROP

	    #4- FORTYNINE #* #+

	    kcEnter #=casedrop
	    ::	SWAPDROPTRUE SWAP
	    ;
	    kcBackspace #=casedrop
	    ::	DUPLEN$ 1_#1-SUB$
	    ;

	    Key>ChrTab SWAP SUB$1# #>CHR
	    DUP CHR_Newline
	    EQUAL ITE_DROP >T$
	;
	OVER
    UNTIL
    UnLockAlpha ClrDAsOK
    SWAPDROP
    DUPNULL$? casedrpfls
    TRUE
;

LABEL	Key>ChrTab
ASSEMBLE
	CON(5)	=DOCSTR
	REL(5)	k>ctEnd 	49 keys/plane * 3
	NIBHEX	142434445464	row 1 - plane alpha
	NIBHEX	748494A4B4C4	row 2
	NIBHEX	D4E4F4051525	row 3
	NIBHEX	354555657585	row 4
	NIBHEX	A095A5A0A0	row 5
	NIBHEX	A0738393F2	row 6
	NIBHEX	A0435363A2	row 7
	NIBHEX	A0132333D2	row 8
	NIBHEX	A003E202B2	row 9
	NIBHEX	162636465666	row 1 - plane alpha-left
	NIBHEX	768696A6B6C6	row 2
	NIBHEX	D6E6F6071727	row 3
	NIBHEX	374757677727	row 4
	NIBHEX	6297A712F3	row 5
	NIBHEX	A006E5F182	row 6
	NIBHEX	A0423A4AB5	row 7
	NIBHEX	A0A0C398BA	row 8
	NIBHEX	A0D3B3D7B7	row 9
	NIBHEX	C8FDB9293959	row 1 - plane alpha-right
	NIBHEX	1949F9C70969	row 2
	NIBHEX	725BD9E8F879	row 3
	NIBHEX	899952E7A918	row 4
	NIBHEX	041BC9A09A	row 5
	NIBHEX	A072E7C532	row 6
	NIBHEX	A02A5A0BF5	row 7
	NIBHEX	A0B8E3A822	row 8
	NIBHEX	A0D8C208A3	row 9
k>ctEnd
RPL


*****************************************************************************
* EC : A-Z Sub-System
*****************************************************************************

					( *Thu	04-30-1992  10:47:14* )
DEFINE	ECOx@	  1GETLAM
DEFINE	ECOx!	  1PUTLAM
DEFINE	ECOy@	  2GETLAM
DEFINE	ECOy!	  2PUTLAM
DEFINE	ECOExit   3GETLAM
DEFINE	ECOExit!  3PUTLAM
					( *USED LAMS: HERE LAM2 - LAM7 = 6* )
DEFINE	NRECOLAM  THREE
DEFINE	CURSH	  EIGHT
DEFINE	CURSW	  SEVEN

LABEL	GETGOTO
::					( $word --> #0/#pos [#1 to #95] )
    POLSaveUI
    ERRSET
    ::
	SetDA1Bad

	DUPTYPECSTR? ?SKIP
	::  DROP SPACE$
	;

	FALSE				( *LAM 3 - Exit Flag* )
	SWAPONE SUB$1# THIRTYTWO #-
	NINETEEN #/ #1+SWAP #1+ 	( *LAM 2,1 - Y,X* )

	' NULLLAM NRECOLAM NDUPN DOBIND

	'                       ( *Level 9* )
	::  ::	DA1OK? ?SEMI
		$ "  !""#$%&'()*+,-./012\n 3456789:;<=>?@ABCDE\n FGHIJKLMNOPQRSTUVWX\n YZ[\5C]^_`abcdefghijk\n lmnopqrstuvwxyz{|}~\n\nUse \90\8F\8E\8D <ENTER>"
		%1 DODISP
		ECOx@ ECOy@
		LABEL	 OCurs
		::  ABUFF SWAPROT
		    EcO1-6*
		    3PICK3PICK
		    3PICKOVER		( --> HB X Y HB X Y X )
		    #7+ OVER #8+	( --> HB X Y HB X Y X+13 Y+7 )
		    SUBGROB INVGROB 4UNROLL GROB!
		    SetDA1Valid
		;
	    ;
	    DispMenu
	;

	' ECAZhardKeys          ( *Level 8* )
	TrueTrue		( *Level 6&7* )
	NULL{}
	ONEFALSE' ECOExit       ( *Level 4&3&2* )
	'ERRJMP                 ( *Level 1* )

	POLSetUI POLKeyUI

	ABND
    ;
    ERRTRAP
	POLResUI&Err

    POLRestoreUI

    ClrDAsOK
    ClrDA1IsStat
;


LABEL	ECAZhardKeys
::
    kpNoShift #=casedrop
    ::	DUP#<7 casedrpfls

	kcUpArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcUpArrow
	    ::	ECOx@ ECOy@
		2DUP EcOKeyU
		LABEL	Oxy!Curs
		::  2DUP ECOy! ECOx!
		    OCurs OCurs
		;
	    ;
	;

	kcLeftArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcLeftArrow
	    ::	ECOx@ ECOy@
		OVER ONE EcOKeyU
		DROP ECOy@ Oxy!Curs
	    ;
	;

	kcDownArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcDownArrow
	    ::	ECOx@ ECOy@
		2DUP EcOKeyD
		Oxy!Curs
	    ;
	;

	kcRightArrow ?CaseKeyDef
	::  TakeOver
	    REPEATERCH
	    kcRightArrow
	    ::	ECOx@ ECOy@
		OVER EIGHT EcOKeyD
		DROP ECOy@ Oxy!Curs
	    ;
	;

	kcEnter ?CaseKeyDef
	::  TakeOver
	    TRUE ECOExit!
	    ECOy@ ECOx@ Ec1-19*1-+
	;

	kcOn ?CaseKeyDef
	::  TakeOver
	    TRUE ECOExit!
	    ZERO
	;

	GOTO ECKeys
    ;

    kpRightShift #=casedrop
    ::
	kcOn #=casedrpfls
	GOTO ECKeys
    ;

    2DROP 'DoBadKeyT
;


LABEL	EChelp
::
    TakeOver

    LABEL	$cont
    "Press any key to continue\1F"  DispCoord1

    ARRY
    [
	"\90\8F\8E\8D  move around"
	"blue\90 goto 1st item"
	"NXT   search again"
	"ENTER name to stack"
	"ON    cancel/exit"
	"OFF   turn off"
    ]

    ARRY
    [
	"PG\8F   goto next page"
	"PG\90    previous page"
	"SCAN  search string"
	"A-Z   goto char"
	"A\8DSTK addr to stack"
    ]

    " " EIGHT disprn
    TWO
    #1+_ONE_DO (DO)

	"EC-HELP " INDEX@ #>$ &$SWAP

	ZEROZERO popup
	WaitForKey 2DROP
    LOOP
;


ASSEMBLE

ECOutBound$	EQU	7

PopUpFrame	EQU	2	* For POPUP; Activates frame chars
OddFlag 	EQU	4	* For BANGROW; Set if $ hasn't even #chars
PopUpLeft	EQU	8	*
PopUpRight	EQU	0	*
PopUpVertLine	EQU	9
PopUpUVertLine	EQU	#A

GetAdisp
	D0=(5)	(=addrADISP)+2
	C=DAT0	A
	D0=C

	RTN

BlameEC
	PCode

	LA(5)	xEC
BlameRW
	CD0EX			I

	RSTK=C
	GOSUBL	D0=RAM
	CON(5)	=LASTROMWDOB_G
	CON(5)	=LASTROMWDOB
	C=RSTK

	DAT0=A	A		    *** write ->x>COD to LASTROMWDOB
	D0=C					I
	GOLONG	loop

Ec1stOf
	PCode
*	Get first offset into RPL.TAB
*					D1
	GOSBVL	=SAVPTR
	C=DAT1	A	&ob1
	B=C	A
	GOSBVL	=GetStrLenStk		&Chr1
	D=C	A
	C=0	A
	LCHEX	10
	P=	3

	D1=D1+	4

lp0T	A=DAT1	A
	?A#0	A
	GOYES	FstOfs

	D1=D1+	5
	D=D-CON A,5
	GONC	lp0T
errit

FstOfs	P=	4
	CD1EX
	A=A+C	A
	A=A-B	A
	GOVLNG	=PUSHhxsLoop
**	( Stack: $RPL.TAB hxs )


EcMkECp
	PCode
*			A	B	C	D1
	GOSBVL	=SAVPTR
	C=DAT1	A			&ob1	&L1
	CD1EX				&L1	&ob1
	D1=D1+	5				&len(ob1)
	A=DAT1	A	len
	CD1EX				&len	&L1
	C=C+A	A
	CD1EX		len		&L1	len+&len
	D1=D1-	5				(len+&len)-5
	A=DAT1	A	#    **  Get last entry from ECpar  **
****************************************
*
****************************************
	D1=C				&L1	&L1
	D1=D1+	5				&L2
	C=DAT1	A			&ob2

	A=A+C	A
	D=C	A

	D1=C					&ob2
	D1=D1+	5				&len(ob2)
	C=DAT1	A			len

	C=C-CON A,10

	AD1EX		A:&len			&LastEntry
	A=A+C	A	A:&EO$
	B=A	A

****************************************
* The loop is run 8 times, you see?
****************************************
	P=	(16-8)
adrlp	D1=D1+	5	Skip adr field
	A=0	A
	A=DAT1	1
	A=A+A	A	#chars -> #nibs
	A=A+1	A	Skip len field
	CD1EX
	?B<=C	A
	GOYES	IsEO$
	C=C+A	A	Skip name field
	CD1EX
	P=P+1
	GONC	adrlp

	AD1EX

	C=D	A	&$
	A=A-C	A

fuckoff P=	4
	GOSBVL	=PUSHhxs
	P=	0
	GOVLNG	=PushTLoop

IsEO$	P=	0
	GOVLNG	=GPPushFLoop
**	( Stack: $RPL.TAB hxs --> $RPL.TAB hxs hxs' T )
**	( Stack: $RPL.TAB hxs --> $RPL.TAB hxs F )

EcInvR
	PCode
	GOSBVL	=POP#
	ST=0	3
	C=0	A

	LCHEX	EE
	ACEX	A
	P=C	0
	?P=	0
	GOYES	EC7row0
	ST=1	3

EC7row0 C=0	A
	GOTO	ECrowIn

ECrowLp C=C+A	A
ECrowIn P=P-1
	GONC	ECrowLp

	A=C	A
	CD0EX
	RSTK=C

	GOSUB	GetAdisp

	C=DAT0	A
	C=C+A	A
	D0=C

	?ST=0	3
	GOYES	EC7row1
	D0=D0-	14
	GONC	EC7row2

EC7row1 D0=D0+	10
	D0=D0+	10	* +20

EC7row2 P=	13
	?ST=0	3
	GOYES	ECinvLp
	P=	15

ECinvLp A=DAT0	W
	A=-A-1	W
	DAT0=A	W
	D0=D0+	16
	P=P-1
	GONC	ECinvLp

	P=	13
	?ST=0	3
	GOYES	ECleavP
	P=	14

ECleavP A=DAT0	WP
	A=-A-1	WP
	DAT0=A	WP

	P=	0
	C=RSTK
	GOVLNG	=D0=cLoop


EcNxPr
	PCode
*			A	B	C	D1
** ECpg2ofs

	GOSBVL	=POP#
	GOSBVL	=SAVPTR
	ST=0	3	#pg
	C=0	A
	C=-C-1	A	#pg		FFFFF	&L1($)
	?A#C	A
	GOYES	ECforwd
	ST=1	3	Mark Wrap from page 1 to last page
	A=0	A

ECforwd R1=A
	B=A	A
	B=B+B	A
	B=B+B	A
	B=B+A	A		#pg*5

	D1=D1+	5				&L2(hxs)
	C=DAT1	A			&hxs
	D1=C					&hxs
	D1=D1+	5		#pg*5/0 	&lenhxs
	C=DAT1	A			len

	C=C-CON A,10			len-10
	D=C	A

	?ST=0	3
	GOYES	ECIinT	* No backpage wrap
	B=C	A		len-5
	GONC	ECIinR

ECIinT	?B<=C	A
	GOYES	ECIinR
	B=0	A	* Wrap to page 1
	C=B	A
	R1=C

ECIinR	D1=D1+	5				&hxsData1
	CD1EX
	C=C+B	A
	D1=C
	A=DAT1	A
	R0=A
	?ST=0	3
	GOYES	ECnoDiv
	C=D	A
	GOSBVL	=DIV5	* #page
	R1=C

ECnoDiv GOVLNG	=Push2#Loop


EcNxPr2
	PCode
*			A	B	C	D	Dn
	GOSBVL	=POP#	#ofs
	GOSBVL	=SAVPTR
	ST=0	PopUpFrame	** NO FRAME (ONLY FOR POPUP) **


	C=DAT1	A	#ofs		&$		1:&&$RPL.TAB
	A=A+C	A	&page

	B=C	A	&page	&$	&$

	D1=C						1:&$
	D1=D1+	5					1:&$Len
	C=DAT1	A

	C=C+B	A	&page	&$	&$end+1
	R2=C		* For later...

	D1=A						1:&page

	GOSUB	GetAdisp

	C=DAT0	A
	D0=C
	D0=D0+	10
	D0=D0+	10	* Skip HB header

	A=0	W
	A=A+CON S,7	* Looping counter

	ST=0	ECOutBound$

ECLP	ST=0	3
	C=DAT1	A	* Get 'Address'

** IsRplPtr *****************************************************************
* Interface :	( # --> t/f )
* Description : Check if the value of # is the address of an RPL entry
* Calls :	Pop#SP GpPshT/FLp =PRLG
* Ed. Hist. :
*     1.000	21.01.1993	DM	alpha
*		19.04.93	RH	Adapted
*****************************************************************************
* CPU			A	C	D1

	A=C	A
	CD1EX
	RSTK=C
	C=DAT1	A		[ob]
	D1=C				[ob]
	C=C-CON A,5		[ob]-5
	?A=C	A	** PTR = [PTR] - 5
	GOYES	ECPfL	** yep, PCO
	P=	0
	LA(5)	(=DupAndThen)-5
	?A=C	A	** PTR = DupAndThen
	GOYES	ECPfL	** yep, ok

	A=DAT1	A	[[ob]]
	LC(5)	=PRLG		PRLG
	?A=C	A	** [[PTR]] = PRLG
	GOYES	ECPfL	** yep, ok
	ST=1	3

ECPfL	C=RSTK
	D1=C
	C=DAT1	A	* Reread

	GOSUB	rev5

	A=C	A	* Nibs reversed
	P=	5
	LAHEX	5

	R3=A

	D1=D1+	5
	GOSUB	ECdisprow
	P=	0
	C=0	A
	LCHEX	CD
	AD0EX
	A=A+C	A
	D0=A
	A=R3
	A=A-1	S
	GONC	ECLP
	GOVLNG	=GETPTRLOOP

rev5	P=C	1	* Reverse nibs
	CPEX	3	*
	CPEX	1	*
	P=C	0	*
	CPEX	4	*
	CPEX	0	* P undefined
	RTNCC


ECdisprow
	ST=1	OddFlag * Preset OddFlag
	ST=0	5	* SPACE-Mark
	ST=0	6

	C=R2.F	A
	B=C	A
	CD1EX
	D1=C
	?B>C	A
	GOYES	ECin$
	ST=1	ECOutBound$

ECin$	B=0	A	*
	C=0	A
	P=	0
	LCHEX	7	* (WindLen-1)/2

	?ST=0	ECOutBound$
	GOYES	ECrowInR
	ST=1	5
	LCHEX	A

ECrowInR
	D=C	A
	?ST=1	ECOutBound$
	GOYES	ECdspA

	C=0	A

	C=DAT1	1
	D1=D1+	1
	GOSUB	ECdispA

	ST=1	OddFlag * Preset OddFlag
	ST=0	5	* SPACE-Mark
	ST=1	6

	P=	0
	B=0	A
	C=0	A
	LCHEX	2
	D=C	A
	LCHEX	6

ECdspA	GOTO	ECdispA
****************************************
* Here: B[A]:#HB_row (1-8)
*	C[A]:$len(bytes)
*	D[A]:#$LenMax ((Bytes-1)/2)
*	D0  :&HBrow
*	D1  :&Char1
*
****************************************


disprn
	PCode
	GOSUB	BANGROW
	GOSBVL	=GETPTR
	GOVLNG	=DropLoop


*******************************************************************************
* BANGROW	The NEW 5x6 font display
*
* ???	: This routine does the hard work of reading and displaying
*	  a complete line of chars (as DISPROWn)
*
* IN/OUT: ( $ #row --> $ )
*
* FEATR : Very fast (~23 ms on a HP48 rev.E)
*	  Only SUPPORTED entries, so runs on ALL HP48's(including GX)
*
*	  To do so, =VDISP has to be changed...(RH)
*
* USES	: A,B,C,D,R4,D0,D1,P,ST4,ST5
* CALLS : POP#,SAVPTR,GETPTRLOOP,GetStrLenStk
* LEVELS: 4
*
* TO DO :
*
* DESCR.: Mentionned items: BANGROW,ECdispA,S4.6,EC,POPUP
*
*	  BANGROW incorporates the new display driver for the HP48.
*	  It's the heart of DISPRN and disprn, which are designed
*	  to replace DISPROWn (from DISPLAY.s in the source).
*	  The main differences are the speed and the size (of code, chars...).
*	  For an example look at the usage of disprn in S4.6, the new six-level
*	  stack display which is a full replacement of STK5 and many others.
*	  This stack environment behaves as the normal 4-level display, even
*	  the interrupt-driven clock works.
*	  it's a user interface, NOT a Sys-RPL decompiler;-)
*
*	  There is a very important general entry (from Mcode): ECdispA.
*	  It allows programmers to do (nearly) whatever they want with
*	  the data to be displayed. As an example look at the new EC
*	  or the new POPUP utility which both utilize special features
*	  of ECdispA.
*
*
* Mods: Date		Prog	What
* ---------------------------------------------------------------------------
*	31.03.93	RH	wrote
*	01.04.93	RH	added doc ; Modified to accept bint from stack
*				display real adr & contents
*	14.04.93	RH	Modified to disp new 5x6 font
*				Included font
*	16.04.93	RH	Packed (Saved ~300 Bytes)
*******************************************************************************
ASSEMBLE
BANGROW
	GOSBVL	=POP#
	GOSBVL	=SAVPTR
	C=0	A
	LCHEX	A	* (WindLen-1)/2
	D=C	A
	LCHEX	EE	* 34*7

	B=0	A	*
	ST=0	PopUpFrame	** NO FRAME (ONLY FOR POPUP) **
	ST=1	OddFlag * Preset OddFlag
	ST=0	5	* SPACE-Mark
	ST=0	6

	A=A-1	A
	GOC	ECinrg0
	GONC	ECrowlp06
****************************************
* Given #row (1-8) in A[A], add row
* offset to next 'row' in VDISP to B[A]
****************************************
ECrowlp6
	B=B+C	A	* +NextRow
ECrowlp06
	A=A-1	A	*
	GONC	ECrowlp6

	GOSUB	GetAdisp

	A=DAT0	A
	A=A+B	A	* &HB+Rofs
	D0=A
	D0=D0+	10
	D0=D0+	10	* Skip HB header

	GOSBVL	=GetStrLenStk

ECdispA
****************************************
* Here: B[A]:#HB_row (1-8)
*	C[A]:$len(bytes)
*	D[A]:#$LenMax ((Bytes-1)/2)
*	D0  :&HBrow
*	D1  :&Char1
*
****************************************
	?CBIT=1 0	* Odd # of chars?
	GOYES	ECNeven
	C=C-1	A
	ST=0	OddFlag * Clr OddFlag
ECNeven CSRB.F	A
*		  $len in C[A]	D1=&Chr1

	?C<=D	A
	GOYES	ECinrg
	ST=0	OddFlag * Clr OddFlag
ECinrg0 C=D	A
ECinrg	D=D-C	A

	DSRC		* D[S]:WinLen
	D=C	A
	C=0	A
	LCHEX	1F
	CDEX	A

****************************************|
* ECMlpRow6	   Disp contents
*					|
*
*	: This loop is run 7 times
*
* MODS	: Date		Prog	What	|
*---------------------------------------|
*	01.04.93	RH	Wrote	|
****************************************|
ECMlpRow6
	R4=C.F	B	  <-+		  |
	GOSUB	ECwrlp6     |		  |
	A=C	A	    |		  |
	C=R4.F	B	    |		  |
	C=C-1	B	    |		  |
	GONC	ECMlpRow6 >-+		  |

* This section fills the
* remaining line with SPACES
	ST=1	OddFlag * Set OddFlag
	ST=1	5	* Set SPACE-Mark

	D=0	A
	DSLC
	C=D	A
	D=0	W
	C=C-1	B	  |		|
	GONC	ECMlpRow6  >-+		   |

	RTNCC		* FINISH;EXIT;LOGOFF;BYE

****************************************
* ECwrlp	  Read and Write PixDat
*
* IN	: D[W]:HexData
* OUT	: P=0;PixDat written
* USES	: A,B,C,D,D0,P,ST4,ST5
* CALLS : pixdat7(3)
*
*	: This routine is called 3+8 times per row := 77 times total
*
* MODS	: Date		Prog	What
*---------------------------------------
*	01.04.93	RH	Wrote
****************************************
ECwrlp6 GOSUB	ECpixdat6 * A[W]: PixelData
	?ST=0	OddFlag * OddFlag clear?
	GOYES	ECwrlpx6

	C=R4.F	B
	?C#0	B	* Any Chrs to write?
	GOYES	ECwrlpx6

	ST=1	5	* IFF Mark THEN Set Mark' for 2nd digit to be SPACE
ECwrlpx6
	GOSUB	ECpixdat6 * A[W]: NEW PixDat ; B[W]: OLD PixDat

	P=	9
	CD0EX		*
	RSTK=C		* Save D0 for later
	CD0EX		* Restore C[A]
	C=0	W

*	: This loop is run 539 times total !

ECwrlp06
	C=A	B	*Copy New row data to C[B]
	ASRC		*
	ASRC		* Shift it away
	CSLC		* Shift left one nib
	C=C+C	X
	C=C+C	X	* Shift left two bits
	C=C+B	B	* Here: PixDat of two ASCII digits crunched into 3 nibs
	BSRC
	BSRC		* Prepare PixDat for next looping
	DAT0=C	X	* Smash into display
	D0=D0+	16	*
	D0=D0+	16	*
	D0=D0+	2	* D0:&NextRow
	P=P+1		* PIPI (Loop Cnt)
	GONC	ECwrlp06

	C=RSTK
	CD0EX		* Restore D0
	D0=D0+	3	* Jump over just written digits
	RTNCC		* P=0

****************************************
* pixdat6	Get pixel data for char
*
* IN	: A[W]:?,D1=&Char
*
* OUT	: A[W]:NEW_PixelData
*	  B[W]:OLD_PixelData;P=0
*
* USES	: A[W],B[W],C[A],D0,D1,RSTK(2)
* ALTERS: A[W],B[W],C[A],D1  (rotated)
*
* MODS	: Date		Prog	What
*---------------------------------------
*	01.04.93	RH	Wrote
*	14.04.93	RH	Modified
****************************************
ECpixdat6
	C=0	W
	P=	0

	?ST=1	PopUpFrame
	GOYES	PPVert?
	GOTO	ECSPC?

PPVert? ?ST=1	PopUpVertLine
	GOYES	PPVertAny
	GOTO	PPLeft?

** Any type of vertical line, including edges **
PPVertAny
	B=A	W
	A=0	W
	P=	4
	?ST=0	PopUpUVertLine
	GOYES	PPVLine
	GONC	PPVULine

PPVLine ?ST=0	PopUpLeft
	GOYES	PPVertMid?
	ST=0	PopUpLeft

	LAHEX	A0A3A023E   ** Upper Left Edge
	RTNCC

PPVertMid?
	CR0EX.F B
	C=C-1	B
	GONC	PPVrightNO
	ST=1	PopUpRight

PPVrightNO
	CR0EX.F B
	?ST=0	PopUpRight
	GOYES	PPVMid

	ST=0	PopUpRight
	ST=0	PopUpFrame
	LAHEX	D0D0D0407	** Upper Right Edge (w/shadow)
	RTNCC

PPVMid	LAHEX	3F003F		** =  (w/o shadow)
	RTNCC


PPVULine
	?ST=0	PopUpLeft
	GOYES	PPUVertMid?
	ST=0	PopUpLeft

	P=	0
	LAHEX	383E023A0A0A	** Lower Left Edge
	RTNCC

PPUVertMid?
	CR0EX.F B
	C=C-1	B
	GONC	PPUVrightNO
	ST=1	PopUpRight

PPUVrightNO
	CR0EX.F B
	?ST=0	PopUpRight
	GOYES	PPUVMid

	ST=0	PopUpRight
	ST=0	PopUpFrame
	P=	0
	LAHEX	F0F0C0D0D0D	** Lower Right Edge (w/shadow)
	RTNCC

PPUVMid
	LAHEX	3F3F003F
	RTNCC


PPLeft? ?ST=0	PopUpLeft
	GOYES	PPright?
	ST=0	PopUpLeft

	B=A	W
	A=0	W

	LAHEX	A0A0A0A0A0A0A	** || (w/o shadow)
	RTNCC

PPright?
	CR0EX.F B
	C=C-1	B
	GONC	PPrightNO
	ST=1	PopUpRight

PPrightNO
	CR0EX.F B
	?ST=0	PopUpRight
	GOYES	ECSPC?
	ST=0	PopUpRight
	B=A	W
	A=0	W
	LAHEX	D0D0D0D0D0D0D  ** || (w/shadow)
	RTNCC


ECSPC?	?ST=0	5	*
	GOYES	ECTST_1F

ECDO_SPC
	LCHEX	20	* SPACE
	GOTO	ECGT_1F


ECTST_1F
	?ST=0	6
	GOYES	ECSTDtst
*******************************************
	C=R3
	P=	5
	C=C-1	P	* Counter-1
	GONC	EChexdig

	C=0	W
	P=	0
	?ST=0	3
	GOYES	ECDO_SPC
	LCASC	\m\
ECrplR	GOTO	ECGT_1F

EChexdig
	P=C	0
	CSR	A	* Shift out digit
	CR3EX		* Get original Data

	C=0	W
	C=P	0

	P=	1
	LCHEX	3
	P=	0

	D=D-CON P,5	* A
	?C<D	P
	GOYES	ECis0-9
	C=C+CON B,7
ECis0-9 D=D+CON P,5	* F

	GOTO	ECGT_1F * BET
*******************************************


ECSTDtst
	C=DAT1	B	* Get $ Data
	D1=D1+	2

	?C>D	B
	GOYES	ECGT_1F * Chr > #1F (...)
	?C#D	B
	GOYES	ECLT_1F
	B=A	W
	A=0	W
	P=	8
	LAHEX	1515	* Chr_...
	RTNCC

ECLT_1F LCHEX	9E	* Map to BoxChr

ECGT_1F CSRC		* MSNib
*			  C[S]:0 C[0]:2

	C=C+C	A	* *2	      4
	C=C+C	A	* *4	      8
	C=C-CON A,8
	B=C	A

	GOSUB	ECget6x7

	REL(4)	C20
	REL(4)	C30
	REL(4)	C40
	REL(4)	C50
	REL(4)	C60
	REL(4)	C70
	REL(4)	C80
	REL(4)	C90
	REL(4)	CA0
	REL(4)	CB0
	REL(4)	CC0
	REL(4)	CD0
	REL(4)	CE0
	REL(4)	CF0

ECget6x7
	C=RSTK
	C=C+B	A	* RSTK+ 8
	B=A	W	* Back up old PixDat
	A=C	A	* Back up &REL
	CD0EX		* Point to REL
	RSTK=C		* Back up old D0
	C=0	A

	P=	3
	C=DAT0	WP	* REL Pointee
	C=C+A	A	* &REL + REL->
	D0=C		* Point to len Nib

	A=0	A
	C=0	A
	C=DAT0	1	* PixDat Length
				C
	D0=D0+	1	* Data field
	P=C	0
	P=P-1

	GONC	ECpdlp0
ECpdlp	A=A+C	A
ECpdlp0 C=C-1	S
	GONC	ECpdlp

	C=RSTK		* Old D0
	CD0EX
	C=C+A	A	* PixDat pointee
	CD0EX		* C:Old D0

	A=0	W
	A=DAT0	WP	* NEW PixDat
	D0=C		* D0 restored
	RTNCC


*		11223344556677
*		--------------

CC0	NIBHEX	B
	NIBHEX	406090F0909
	NIBHEX	206090F0909
	NIBHEX	90006090F09

	NIBHEX	506090F0909	*\
	NIBHEX	006090F0909	*  >  Same except first digit
	NIBHEX	906090F0909	*/

	NIBHEX	A05050F050D
CC7	NIBHEX	60901090604

	NIBHEX	40F0107010F	*\
	NIBHEX	40F0107010F	*  \  Same except first digit
	NIBHEX	A0F0107010F	*  /
	NIBHEX	00F0107010F	*/

*CCC
	NIBHEX	20702020207	*\
	NIBHEX	20702020207	*  \  Same except first digit
	NIBHEX	50702020207	*  /
	NIBHEX	00702020207	*/

** RH-Graphic characters Part 1


CD0	NIBHEX	B
	NIBHEX	E021213121E
	NIBHEX	500090B0D09

	NIBHEX	40609090906	*\
	NIBHEX	40609090906	* \
	NIBHEX	90609090906	*  > Same except first digit
	NIBHEX	50609090906	* /
	NIBHEX	00609090906	*/

CD7	NIBHEX	0000A040A00	**
	NIBHEX	E0915131E01

	NIBHEX	20909090906	*\
	NIBHEX	40909090906	* \  Same except first digit
	NIBHEX	90009090906	* /
	NIBHEX	00909090906	*/

	NIBHEX	409090E0807
	NIBHEX	20E021E0207
	NIBHEX	6050F011F01

C40	NIBHEX	C
	NIBHEX	609090D010E0	* @
	NIBHEX	609090F09090	* A
	NIBHEX	709070909070	* B
	NIBHEX	609010109060	* C
	NIBHEX	709090909070	* D
	NIBHEX	F010701010F0	* E
	NIBHEX	F01070101010	* F
	NIBHEX	609010D090E0	* G
	NIBHEX	909090F09090	* H
	NIBHEX	702020202070	* I
	NIBHEX	808080909060	* J
	NIBHEX	905030509090	* K
	NIBHEX	1010101010F0	* L
	NIBHEX	11B151511111	* M
	NIBHEX	9090B0D09090	* N
	NIBHEX	609090909060	* O

C50	NIBHEX	C
	NIBHEX	709090701010	* P
	NIBHEX	6090909050A0	* Q
	NIBHEX	709090709090	* R
	NIBHEX	E01060808070	* S
	NIBHEX	702020202020	* T
	NIBHEX	909090909060	* U
	NIBHEX	11111111A040	* V
	NIBHEX	11115151B111	* W
	NIBHEX	909090609090	* X
	NIBHEX	909050202020	* Y
	NIBHEX	F080402010F0	* Z
	NIBHEX	E020202020E0	* [
	NIBHEX	001020408001	* \
	NIBHEX	E080808080E0	* ]
	NIBHEX	40A011000000	* ^
	NIBHEX	0000000000F0	* _

C80	NIBHEX	C
	NIBHEX	0080402050F0
	NIBHEX	F00090606090
	NIBHEX	00F111A04000
	NIBHEX	C14040506040
	NIBHEX	804141505020
	NIBHEX	F020402010F0
	NIBHEX	103070703010
	NIBHEX	0000F1A0A0A0
	NIBHEX	2040E0909060
	NIBHEX	804020F000F0
	NIBHEX	102040F000F0
	NIBHEX	0080F060F010
C8C	NIBHEX	000061909061	* \Ga
	NIBHEX	004080F18040
	NIBHEX	004020F12040
	NIBHEX	00404051E040

C90	NIBHEX	C
	NIBHEX	0040E0514040
	NIBHEX	000021518080
	NIBHEX	2040E0909060
	NIBHEX	006010701060
C94	NIBHEX	0000A0514101
	NIBHEX	006090F09060
	NIBHEX	00102040A011
C97	NIBHEX	00C02121E020
	NIBHEX	0000E1909060
	NIBHEX	0000E1504180
	NIBHEX	0000901151A0
	NIBHEX	0040A011F100
	NIBHEX	F1A0A0A0A0A0
	NIBHEX	E0111111A0B1
	NIBHEX	0000E0E0E000	***
	NIBHEX	0000A05151A0

CE0	NIBHEX	C
	NIBHEX	400070E090E0	*\
	NIBHEX	400070E090E0	*  \
	NIBHEX	900070E090E0	*    \ Same except first digit
	NIBHEX	500070E090E0	*    /
	NIBHEX	900070E090E0	*  /
	NIBHEX	502070E090E0	*/

	NIBHEX	00B141F150F1

	NIBHEX	00601010E040

	NIBHEX	400060F01060	*\
	NIBHEX	200060F01060	*  \  Same except first digit
	NIBHEX	A00060F01060	*  /
	NIBHEX	A00060F01060	*/

	NIBHEX	204000404040	*\
	NIBHEX	804000404040	*  \  Same except first digit
	NIBHEX	40A000404040	*  /
	NIBHEX	00A000404040	*/


** RH-Graphic characters Part 2

C20	NIBHEX	D
	NIBHEX	0000000000000	****
	NIBHEX	4040404000400
	NIBHEX	A0A0A00000000	****
	NIBHEX	00A0F1A0F1A00
	NIBHEX	40E150E041F04
	NIBHEX	0021804020900
	NIBHEX	6090609190610
	NIBHEX	4040000000000
	NIBHEX	C020202020C00
	NIBHEX	6080808080600
	NIBHEX	009060F060900
	NIBHEX	004040F140400
	NIBHEX	0000000060201
	NIBHEX	000000F000000	****
	NIBHEX	0000000060600
	NIBHEX	0001804020100

C30	NIBHEX	D
	NIBHEX	6090D0B090600	* 0
	NIBHEX	2030202020700	* 1
	NIBHEX	6090806010F00	* 2
	NIBHEX	F080408090600	* 3

	NIBHEX	C0A090F180800

	NIBHEX	F010708080700	* 5
	NIBHEX	E010709090600	* 6
	NIBHEX	F080402020200	* 7
	NIBHEX	6090609090600	* 8
	NIBHEX	609090E080700	* 9
	NIBHEX	0060600060600	* :
	NIBHEX	0060600060201	* ;
	NIBHEX	0040201020400	* <
	NIBHEX	0000F000F0000	* =
	NIBHEX	0010204020100	* >
	NIBHEX	6090804000400	* ?

C60	NIBHEX	D
	NIBHEX	2020400000000	* `
	NIBHEX	000070E090E00	* a
	NIBHEX	1010709090700	* b
	NIBHEX	0000E01010E00	* c
	NIBHEX	8080E09090E00	* d
	NIBHEX	000060F010600	* e
	NIBHEX	40A0207020200	* f
	NIBHEX	00006090E0807	* g
	NIBHEX	1010709090900	* h
	NIBHEX	4000604040E00	* i
	NIBHEX	8000C08080906	* j
	NIBHEX	1010907050900	* k
	NIBHEX	3020202020700	* l
	NIBHEX	0000F05151110	* m
	NIBHEX	0000709090900	* n
	NIBHEX	0000609090600	* o

C70	NIBHEX	D
	NIBHEX	0000709090701	* p
	NIBHEX	0000E09090E08	* q
	NIBHEX	0000D03010100	* r
	NIBHEX	0000E07080700	* s
	NIBHEX	20207020A0400	* t
	NIBHEX	0000909090E00	* u
	NIBHEX	0000909050300	* v
	NIBHEX	0000115151F00	* w
	NIBHEX	0000906060900	* x
	NIBHEX	00009090E0806	* y
	NIBHEX	0000F04020F00	* z
	NIBHEX	4020201020204	* {
	NIBHEX	2020202020200	* |
	NIBHEX	2040408040402	* }
	NIBHEX	0020518000000	* ~
	NIBHEX	51A051A051A00	* \127 d

CB0	NIBHEX	D
	NIBHEX	E0A0E00000000	****
	NIBHEX	0040E040E0000	****
	NIBHEX	E080E020E0000	****
	NIBHEX	E080E080E0000	****
	NIBHEX	4000000000000	****
	NIBHEX	0000909090711
CB6	NIBHEX	E171716141610
	NIBHEX	0000606000000	****
	NIBHEX	0000000000403
	NIBHEX	4040E00000000	****
	NIBHEX	90906000F0000	****
	NIBHEX	0050A041A0500	**
	NIBHEX	90502051C1010
	NIBHEX	9050A11180810
	NIBHEX	21B06071C1010
	NIBHEX	1000100040300	**

CF0	NIBHEX	D
	NIBHEX	C180E09090600	**
	NIBHEX	5000709090900	**
	NIBHEX	4000609090600	**
	NIBHEX	2000609090600	**
	NIBHEX	A000609090600	**
	NIBHEX	5000609090600	**
	NIBHEX	A000609090600	**
	NIBHEX	0020007000200	**
	NIBHEX	0061905121D00	**
	NIBHEX	4000909090E00	**
	NIBHEX	2000909090E00	**
	NIBHEX	9000909090E00	**
	NIBHEX	9000909090E00	**
	NIBHEX	20009090E0806
	NIBHEX	1070909070101
	NIBHEX	90009090E0806

CA0	NIBHEX	D
	NIBHEX	0000000000000	****
	NIBHEX	2000202020200
	NIBHEX	40E05050E0400
	NIBHEX	40A0207020F00
	NIBHEX	9060909060900
	NIBHEX	11A0F140F1400
	NIBHEX	0040400040400
	NIBHEX	4020609060402
	NIBHEX	A000000000000	****
	NIBHEX	E01171317111E	* CopyRight
	NIBHEX	80E09060F0000	****
	NIBHEX	0041A050A0410
	NIBHEX	000000F080000	****
	NIBHEX	000000F000000	****
	NIBHEX	E01171B111E00
	NIBHEX	F000000000000	****

Eca-z
	PCode
* IF #<>0, THEN

*			A	B	C	D	Dn
	GOSBVL	=POP#
	GOSBVL	=SAVPTR

	CD1EX
	D=C	A				&L1
	D1=C

	A=A-1	A
	GOC	ECAZNCh * ON-Key pressed (ON returns ZERO)

	C=A	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	#*5
	GOSBVL	=GetStrLenStk
	D1=D1+	4	* Skip dummies
	CD1EX

	C=C+A	A	* &Nth ofs field
	D1=C
	A=DAT1	A	ofs

	?A#0	A	* Existing First_Char ?
	GOYES	ECAZCh? * YES
ECAZNCh GOVLNG	=GPPushTLoop	NO

ECAZCh? A=A+C	A	* &First_Char_Element
	B=A	A	* This is the reference adr.
	C=D	A					1:&L1
	D1=C
	C=DAT1	A			&$tab

	RSTK=C
	D1=D1+	5					1:&L2

	C=DAT1	A			&hxs
	D1=C
	D1=D1+	5			&hxsData-5
	C=DAT1	A
	GOSBVL	=DIV5
	C=C-1	A

	D0=C		* !!!! Counter !!!!
	C=RSTK
	D=C	A
	A=0	A

ECAZLp0 D1=D1+	5
	A=A+1	A	page+1
	C=DAT1	A			ofs
	C=C+D	A			&tab+ofs
	D0=D0-	1
	GOC	ECAZout * Out of bounds !

	?C<B	A
	GOYES	ECAZLp0

ECAZout A=A-1	A
	?B=C	A
	GOYES	ECAZsameP
	A=A-1	A	* Correct page number
	D1=D1-	5	* Last offset

ECAZsameP
	R0=A

* Now calculate line...
	A=0	W

	C=DAT1	A			ofs
	C=C+D	A			&tab+ofs
	GOTO	ECAZX1

ECAZLp1 D1=D1+	5	* Skip adr field
	A=DAT1	1	len
	D1=D1+	1	* Skip len field
	CD1EX
	C=C+A	A
	C=C+A	A
	A=A+1	S	* line+1
ECAZX1	D1=C
	?B#C	A
	GOYES	ECAZLp1

	A=0	A
	ASLC		line for Y
	R1=A
	GOSBVL	=PUSH2#
	GOVLNG	=PushFLoop    *  CHANGE


EcGetEl
	PCode
** Stack:	( hxs $RPL.TAB #ofs # row --> hxs $RPL.TAB #adr $tok )
*			A	B	C	D	Dn
ECgetel GOSBVL	=POP2#	ofs		row		1:&&$
	RSTK=C
	GOSBVL	=SAVPTR
	C=RSTK
	P=C	0
	C=DAT1	A	ofs		&$

	D=C	A	* Save &$
	CD1EX				&DSKTOP 	1:&$
	D1=D1+	5
	C=DAT1	A			len

	C=C+D	A	* Beyond $
	R2=C.F	A
	CDEX	A
	GOTO	ECget0

ECgetLp C=0	A
	C=DAT0	1			len

	D0=D0+	1					0:&$+ofs+5+1 = &data
	AD0EX
	A=A+C	A

ECget0	A=A+C	A	ofs		&$
	B=A	A		&$+ofs
	D0=A						0:&$+ofs
	C=DAT0	A			adr
	D0=D0+	5	&$+ofs	&$+ofs	adr	adr	0:&$+ofs+5 = &len
	R0=C.F	A	&$+ofs	&$+ofs	adr	adr	0:&$+ofs
	P=P-1
	GONC	ECgetLp

	CD0EX		&$+ofs	&$+ofs	&$+ofs+5	0:adr
	R1=C

	P=	0
	GOSBVL	=PUSH#

	GOSBVL	=SAVPTR

	A=R2		&$end+1
	C=R1				&$+ofs+5
	D1=C						1:&$+ofs+5
	B=C	A
	C=0	A
	C=DAT1	1			len
	ST=0	3
	?A>B	A
	GOYES	ECin$1
	ST=1	3
	P=	0
	LCHEX	1

ECin$1	GOSBVL	=MAKE$
****************************
* OUT: The usual MAKE$ stuff
****************************

	A=R1
	D1=A						1:&$+ofs+5
	C=DAT1	1			len

	?ST=0	3
	GOYES	ECin$2
	D0=D0-	10	* &prologue
	P=	0
	LC(5)	=DOHSTR
	DAT0=C	A
	D0=D0+	10
	C=0	A
	C=C+1	A

ECin$2	D1=D1+	1					1:&$+ofs+5+1
	P=C	0
	P=P-1

ECputLp C=DAT1	B
	DAT0=C	B
	D0=D0+	2
	D1=D1+	2
	P=P-1
	GONC	ECputLp

ECgetX
	P=	0
	GOSBVL	=GETPTR
	C=R0
	A=C	A
	PC=(A)

EcFind
	PCode
** Stack: hxs $ $scan page item

* CPU			A	B	C	D	Dn	Rn
	GOSBVL	=POP2#	page		item

	R4=A							0:it
	?A=0	A
	GOYES	ECis0
	A=A+A	A
	A=A+A	A
	A=A+A	A	page*8

ECis0	CSRC
	A=C	S

	R0=A

	GOSUBL	PopASP	len$  len$			  1:->1.ch
	C=A	A
	GOSBVL	=GetStrLenC

	C=C-1	A	len$-1
	B=C	A		len$-1
	R2=C							2:len$-1
	CD1EX				->1.ch
	D1=C						1:->1.ch
	R1=C							1:->1.ch

	GOSBVL	=D0=DSKTOP

	C=R4

	A=C	A
	A=A+A	A
	A=A+A	A
	A=A+C	A	*5

	D0=D0+	5
	C=DAT0	A			&hxs
	C=C+A	A			&hxs+ofs
	CD0EX				&L2
	D0=D0+	10
	A=DAT0	A	ofs for RPL.TAB

	D0=C
	D0=D0-	5					1:&L1=&&$RPL.TAB
	C=DAT0	A			&$RPL.TAB(prolog)

	D0=C						1:&$prolog
	C=C+A	A			&OFSstart

	D0=D0+	5					1:&len
	A=DAT0	A	len

	CD0EX				&$len		&OFSstart
	C=C+A	A			&beyond$

	R3=C							3:->TabEnd

* CPU			xxx	len$	xxx	xxx	0:->entry
*							1:->1.ch
*								0:it
*								1:->1.ch
*								2:len$-1
*								3:->TabEnd

** Pre-increment pointers
** so search will begin at Current_Item +1

	D=C	A
	A=R0
	C=A	S
	C=C+1	S
	GOTO	ECshftX

ECshftE A=A+1	A
	D0=D0+	5
	C=0	A
	C=DAT0	1
	P=C	0
	CD0EX
	C+P+1
	C+P+1
	P=	0
	?D>C	A
	GOYES	ECshftOK
	GONC	ECerrNF 	** OUT OF RANGE **

ECshftOK
	D0=C
	D0=D0-	1

ECshftX C=C-1	S
	GONC	ECshftE
	R0=A

*				** Next entry
NxtEntr C=R0.F	A			it
	C=C+1	A			++it
	R0=C.F	A						0:it

	D0=D0+	5					0:->len
	C=0	A			0
	C=DAT0	1			len
	D0=D0+	1					0:->name
	D=C	A				len
	D=D-1	A				len-1

NxtChr	A=DAT0	B	ch
	D0=D0+	2					0:->nxtch

	GOSUB	UPcase
	GONC	NxtCont

	C=D	A
	?B>C	A		** len$ > len ?
	GOYES	NxtCont

	GONC	fndEnt		** BET

NxtCont D=D-1	A				--len
	GONC	NxtChr
*				** Here : Sequence NOT found in current word
	AD0EX		->nxtadr
	D0=A						0:->nxtadr
	C=R3.F	A			->TabEnd
	?A<C	A
	GOYES	NxtEntr

ECerrNF GOVLNG	=GPPushTLoop

fndLp	A=DAT0	B

	GOSUB	UPcase
	GOC	fndCont
*				** Here : Restore Search $ Ptrs
	C=R1.F	A			->1.ch
	D1=C						1:->1.ch
	C=R2.F	A			len$-1
	B=C	A
	GOTO	NxtChr

fndCont D0=D0+	2
fndEnt	D1=D1+	2
	D=D-1	A
	B=B-1	A
	GONC	fndLp

Psh#FLp
	GOVLNG	=Push#FLoop

UPcase	LCHEX	61			'a'
	?A<C	B		< a ?
	GOYES	IsUpp
	LCHEX	7A			'z'
	?A>C	B		> z ?
	GOYES	IsUpp
	LCHEX	20			' '
	A=A-C	B	ch

IsUpp	C=DAT1	B			1.ch
	?A=C	B
	RTNYES
	RTNCC


EcO1-6*
	PCode			 ( #1- #6*  #1- #6* )

	GOSUB	Opop2#-
	A=A+A	A
	A=A+A	A
	A=A+A	A
	ABEX	A
	GOSUB	OmulA6
	C=B	A
	A=A-1	A
Opsh2L	GOVLNG	=Push2#ACLoop

Opop2#- GOSUB	Opop2#
	A=A-1	A
	B=C	A
	RTNCC

OmulA6	A=A+A	A
	C=A	A
	C=C+C	A
	A=A+C	A	** I*6
	RTNCC


EcOKeyU
	PCode

	GOSUB	Opop2#	 * Row	8  Col
	C=C-1	A
	?C#0	A
	GOYES	Onowrap2
	C=B	A
	B=B+CON A,14		19d
	A=A-1	A
	?A#0	A
	GOYES	Onowrap2
	A=B	A
Onowrap2
	GOTO	Onowrap1
Opop2#	GOSBVL	=POP2#	* Col		  Row
	RSTK=C
	GOSBVL	=SAVPTR
	C=0	A
	LCHEX	5
	B=C	A
	C=RSTK
	RTNCC


EcOKeyD
	PCode
* CPU			A	B	C	D
	GOSUB	Opop2#
	C=C+1	A
	?C<=B	A		5
	GOYES	Onowrap1
	C=C-B	A
	B=B+CON A,14		19d
	A=A+1	A
	?A<=B	A
	GOYES	Onowrap1
	A=A-B	A
Onowrap1
	GOTO	Opsh2L


Ec1-19*1-+
	PCode				 ( Col@ #1- #19*  Row@ #1- #+ )

	GOSUB	Opop2#-
mul19+	C=A	A
	ASL	A
	A=A+C	A
	A=A+C	A
	A=A+C	A
	A=A+B	A
OpshAL
	GOVLNG	=PUSH#ALOOP

RPL

*****************************************************************************
* Name	   :	POPUP
* Category :
* ???	   :	Make up a 'pop-up' menu
* Stack    :	arry x y  --> arry
*		where 0<=x<=18 and 0<=y<=5
* Descript.:	Given an Array of String and two bints for upper left corner,
*		this routine will display (up to) six strings, depending on
*		the amount of $ inside the array, surrounded with a double-
*		lined frame. The frame is shadowed.
*		If the array consists of more than six strings, only the
*		first six one are displayed.
*		If there are less than six strings,that number is relevant.
*		POPUP will truncate the number of lines displayed and the
*		strings to fit into the display.
*
* NOTE	   :	The new display consists of 8 (eight) rows plus menu_bar,
*		offsets are option base 0, and vertical offset is in 'chars'
*		which is 6 bits each. The display driver writes two chars
*		at one time (which is 12 bits or 3 nibs).
*
* Mod Note :	Date		Author	Why
*----------------------------------------------------------
*		20.05.93	RH	Start
*		22.05.93	RH	Add doc
*		29.05.93	RH	Add optional title
*					Prepare for POPUPM - POL
*		30.05.93	RH	Change y to 2-digit
*****************************************************************************

*	( $ arry x y --> x y LenMax )

    LABEL	popup
    ::
	DUPTYPEREAL? IT %ABSCOERCE
	SWAP
	DUPTYPEREAL? IT %ABSCOERCE
	SWAP

	    PopItUp
	    NOTcase
	    ::	# 203 DO#EXIT
	    ;
					( --> $ i' x y Max )
	    5ROLL DUPNULL$? caseDROP
	    SIX OVER $>grob
	    grwidth+1			( --> i' x y Max grob 7 grwidth+1 )
	    SWAPOVER MAKEGROB		( --> x y Max $ grob' )
	    OVER #2/ #1+ FOUR		( --> x y Max $ Pwid grob Pwid/2 4 )
	    5ROLL			( --> x y Max Pwid grob Pwid/2 4 $ )
	    5ROLL CENTER$3x5		( --> x y Max grob )
	    4PICK FOUR #* #6+
	    4PICK SEVEN #*
	    ROT XYGROBDISP

	4DROP
   ;

ASSEMBLE

PopItUp
	PCode
*
*			A	B	C	D	Dn
	GOSBVL	=POP2#	x		y		1:&L1' (arry)
	RSTK=C
	C=A	A
	RSTK=C

	GOSUBL	PopASP
	C=RSTK
	ACEX	A

	D1=C						1:&[]
	D=C	A				&[]
	C=0	A			0
	LCHEX	6			6
	B=C	A	x	6	6	&[]	1:&[]
	C=RSTK		x	6	y	&[]	1:&[]
	B=B-C	A	x	6-y	y
	GOC	PPlt0
	?B#0	A
	GOYES	PPgt0		** y <= 5 : OK **

PPlt0	P=	0
	GOVLNG	=GPPushFLoop	** y => 6 : ERROR **

PPgt0	CSRC		* Shift away y

	D1=D1+	10					1:&[]type_field
	D1=D1+	10					1:&[]ElCount

	C=DAT1	A	x	6-y	[]count &[]	1:&ElCount
	D1=D1+	5	x	6-y	[]count &[]	1:&len1

	?C<=B	A		** []count <= (6-y) ? **
	GOYES	PPup26		** Yes, in range  **
	C=B	A		** NO:reduce to (6-y) **
PPup26	B=C	A	x	MIN(c,(6-y))
*********************************************
* Here: 				    *
*  A[A]:   x				    *
*  B[S]:   ?				    *
*  B[A]:   MIN([]count,6) = Items to disp   *
*  C[S]:   y ?				    *
*  D[A]:   &[]				    *
*					    *
*  D0:	   ?				    *
*  D1:	   &LenField of 1st $		    *
*********************************************
	ASRC
	ASRC
	ASRC		* Shift away x to A[14:13]

	A=B	A	items'
	A=A-1	A	items'-1
	BSRC		* Shift away items'
	B=0	A
*********************************************
* Here: 				    *
*  A[S]:   x	   A[A]:   items'-1 = icnt  *
*  B[S]:   items'  B[A]:   0                *
*  C[S]:   y				    *
*		   D[A]:   &[]		    *
*					    *
*  D0:	   ?				    *
*  D1:	   &LenField of 1st $		    *
*********************************************
* BELOW:				    *
* Get the length of the longest $ inside [] *
*********************************************
PPlp0	C=DAT1	A  <--+ icnt	0	len	&[]	1:&len
	?B>C	A     | 	** **
	GOYES	PPno +| 	** **
	B=C	A    || icnt	len	len	&[]
*		     ||
PPno	AD1EX	   <-+| &len	len	len	&[]	1:icnt
	A=A+C	A     | &len+len		&[]
	AD1EX	      | icnt	len	len	&[]	1:&len(Nxt$)
	A=A-1	A     | icnt-1	len	len	&[]
	GONC	PPlp0 +

	A=B	A	LenMax	LenMax
	A=A-CON A,5
	ASRB.F	A	** LenMax in bytes **
*********************************************
* Here: 				    *
*  A[S]:   x	   A[A]:   LenMax (Bytes)   *
*  B[S]:   items'  B[A]:   LenMax (Nibs)    *
*  C[S]:   y	   C[A]:   len		    *
*		   D[A]:   &[]		    *
*					    *
*  D0:	   ?				    *
*  D1:	   &LenField of last $		    *
*********************************************
* BELOW:				    *
* Calculate display row (y) offset	    *
*********************************************
	B=0	A	LenMax
	C=0	A	LenMax	0	0	&[]
	LCHEX	EE	LenMax	0	EE	&[]

	P=C	15
	C=P	12	** Copy y to C[13] **

	GONC	PPlp1x	** BET **

PPlp1	B=B+C	A
PPlp1x	C=C-1	S
	GONC	PPlp1
*********************************************
* Here: 				    *
*  A[S]:   x	   A[A]:   LenMax (Bytes)   *
*  B[S]:   items'  B[A]:   EE*(y-1)         *
*  C[S]:   F	   C[A]:   EE (row (y) ofs) *
*		   D[A]:   &[]		    *
*					    *
*  D0:	   ?				    *
*  D1:	   &LenField of last $		    *
*********************************************
* BELOW:				    *
* Prepare offsets for VDISP		    *
*********************************************
	C=B	S
	P=C	15
	C=P	11	items'

	P=	14
	C=A	P
	P=	13
	C=A	P

	GOSUBL	GetAdisp

	C=DAT0	A	LenMax	y_ofs	&HB	&[]
	B=B+C	A

	C=0	A
	P=C	14	* x high nib
	C=P	1
	P=C	13	* x low nib
	CPEX	0

	P=	0
	C=C+B	A

	D0=C		LenMax	y_ofs	&HB+x+y &[]	0:&HB+x+y
	D0=D0+	10	LenMax	y_ofs	&HB+x+y &[]	0:&HB+x+y
	D0=D0+	10

** Ofs corrected to len field of 1st item **

	C=D	A
	D1=C
	D1=D1+	10
	D1=D1+	15	* &$len1
*********************************************
* Here: 				    *
*  A[S]:   x	   A[A]:   LenMax (Bytes)   *
*  B[S]:   items'  B[A]:   EE*(y-1)         *
*  C[S]:   x	   C[A]:   &[]		    *
*		   D[A]:   &[]		    *
*					    *
*  D0:	   &HB+x+y			    *
*  D1:	   &LenField of 1st $		    *
*********************************************
* BELOW:				    *
* Shift parameters into place		    *
*********************************************

	A=A+1	A	LenMx+1 y_ofs	&[]	&[]	0:&HB+x+y  1:&1st$
	A=A+1	A	LenMx+2 y_ofs	&[]	&[]	0:&HB+x+y  1:&1st$
** This has been done for left and right frame **
	B=A	B	LenMx+2 LenMx+2 &[]	&[]	0:&HB+x+y  1:&1st$
	ASLC
	ASLC		A[3:2]:LenMx+2
	A=B	B	A[3:2]:LenMx+2 ; A[1:0]:LenMx+2
	A=B	S	A[S]  :items'
	C=A	S
	C=A	A

	ST=1	PopUpVertLine	** Mark vertical frame line to draw **
	ST=0	PopUpUVertLine	** NOT lower frame line at this time **
*********************************************
* Here: 				    *
*  C[S]:   items'                           *
*  C[3:2]: LenMax+2			    *
*  C[1:0]: LenMax+2			    *
*					    *
*  D0:	   &HB+x+y			    *
*  D1:	   &LenField of 1st $		    *
*********************************************
* BELOW:				    *
* Do the loop				    *
*********************************************

PPlpM	CD0EX
	RSTK=C		** Save D0 **
	CD0EX

	GOSUB	FRdspA
	P=	0
	C=0	A
	LCHEX	EE
	B=C	A
	C=RSTK
	C=C+B	A
	D0=C
	ST=0	PopUpVertLine	** NO vertical frame line at this time **

	C=R0
	B=C	A
	BSRC
	BSRC
	C=B	B
	C=C-1	S
	GONC	PPlpM

	ST=1	PopUpVertLine	** Mark vertical frame line to draw **
	ST=1	PopUpUVertLine	** But this time it's the lower frame line **
	GOSUB	FRdspA

** Get items' and x coordinate.. **
	C=R0
	P=C	12	y
	C=P	4
	RSTK=C
	C=0	A
	P=C	11	i'
	C=P	0
	R0=C
	P=C	14	x

	C=P	1
	P=C	13

	C=P	0
	R1=C
	P=	0

** ..and push them **
	GOSBVL	=PUSH2#
	GOSBVL	=SAVPTR

	C=RSTK
	A=0	A
	CSRC
	CSRC
	A=C	B

** Now push y and LenMax **
	R1=A
	P=C	2
	C=0	A
	CPEX	0
	R0=C

	P=	0
	GOSBVL	=PUSH2#

	GOVLNG	=PushTLoop

FRdspA	D=0	A
	D=C	B				LenMax+1

	C=C-1	B
	C=C-1	B	** For PopUpFrame counter **
	R0=C

	D=D-1	A			lenM-1	lenM
	DSRB.F	A				(lenM-1)/2
	C=0	A

	?ST=0	PopUpVertLine
	GOYES	PPnoD1+
	C=R0.F	B
	GONC	PPdsp

PPnoD1+ C=DAT1	A
	C=C-CON A,5
	CSRB.F	A			len
	C=C+1	A	* Add 1 for left frame
	D1=D1+	5

PPdsp	ST=0	3
	ST=1	PopUpFrame
	ST=1	OddFlag
	ST=0	5
	ST=0	6

	ST=1	PopUpLeft
	ST=0	PopUpRight

	GOLONG	ECdispA
****************************************
* Here:
***	B[A]:#HB_row (1-8)
*	C[A]:$len(bytes)
*	D[A]:#$LenMax ((Bytes-1)/2)
*	D0  :&HBrow
*	D1  :&Char1
*
****************************************

grwidth+1
	PCode
	GOSUBL	PopASP
	D1=A		** &grob
	D1=D1+	15
	A=DAT1	A
	A=A+1	A	** Width +1
	GOLONG	OpshAL
RPL


*****************************************************************************
*			MEDIUM FONT STACK DISPLAY
*****************************************************************************


*****************************************************************************
*		SYS-RPL STACK
*****************************************************************************


** x4/5/7 *******************************************************************
* Interface :	( --> )
* Description : System stack display, main entry.
* Calls :	dispStack
* Defines :	Ltab? LTab
* Ed. Hist. :
*     1.000 09/16/92	RG	alpha
*****************************************************************************

ASSEMBLE
	XNAME	4/5/7
RPL
::
    fQuit DUP TstF		( if active.. )
    case
    ::	f5/7 5/7?
	case
	::  ClrF		( ...and in 7 mode, reset to 5 mode... )
	    ClrF		( ...and signal quit )
	;
	SetF			( ...if in 5 mode, signal 7 mode... )
	DROP			( ...and leave staying active )
    ;

    CKRPLInst

    SetF			( ..signal active and start )

    ' Ltab? @LAM
    ITE_DROP			( our env. already exists )
    ::
	::
	    UNDO_TOP? NOT?SEMI	( ..the top environment is the	  )
				( old LastStack environment..	  )
	    UNDO_ON? IT ABND	( abandon it.			  )
	;

	GetRPLTab
	{
	    LABEL Ltab	LAM \r1
	    LABEL Ltab? LAM \r2
	}
	BIND

	CacheStack		( *recreate Last Stack env., if neccessary* )
    ;

    ERRSET			( prepare to pass control to VLM )
    LABEL	RplUI
    ::
	BEGIN			( main user interface )
	    AtUserStack

	    SysMenuCheck	( menu handler )

				( Display handler: library's medium font  )
				( size display object responsible for	  )
				( updating the status area, stack area,   )
				( edit line, and menu labs of the display )

	    DA2aOK?NOTIT	 ( if the stack area is invalid... )
				 ( ...then maybe display the stack )
	    ::			 ( ?DispStack )
		KEYINBUFFER? NOT ( if there's no key in key buffer.. )
		DA2aLess1OK?	 ( ..OR stack area can be updated quickly.. )
		ORcase dispStack ( ..then display the stack )
		SetDA2aBad	 ( ..otherwise signal bad display area 2a )
	    ;

	    DA2bOK?NOTIT	( if the edit area is invalid.. )
		DispEditLine	( ..then display the edit line )

	    Disp?Status 	( Status display depends on mode )

	    DA3OK?NOTIT 	( if the menu area is invalid.. )
		?DispMenu	( ..then maybe display the menu labels )

	    ClrDAsOK		( reset "display areas OK" assertions )

	    GetKeyOb		( wait for key, then return key object )

	    SpecKO?Ch		( check for replaced objects, eg. IStk )

	    ERRSET		( prepare to handle DoKeyOb errors )
		DoKeyOb 	( process the key object )
	    ERRTRAP		( declare SysErrorTrap the error handler )
		SysErrorTrap

	    fQuit TstF		( proceed until flag is set )
	NOT_UNTIL (UNTIL)
    ;
    ERRTRAP			( error handler not able to handle error, )
	ERRJMP			( pass control to VLM )
;

LABEL	SpecKO?Ch
::
    'SG: Enter/Dup Enter/Dup_G     EQcase DoKEnter
    'SG: UArrow/View UArrow/View_G EQcase DoKIstk
    'SG: DArrow/Edit DArrow/Edit_G EQcase DoKEdit
;

LABEL	DoKIstk 		( in case \|^ is pressed.. )
::				( .. if there's no edit line, activate the )
    NoEditLine? ?SKIP		( interactive stack )
    ::				( ..if there's only one row in the edit line )
	EDITPARTS #1=?SKIP	( activate the interactive stack. )
	RDROP
    ;

    DROP' IStk
;

LABEL	DoKEdit 		( in case \|v is pressed.. )
::
    EditLExists? ?SEMI		( ..and no editline exists.. )
    fSysED TstF NOT?SEMI	( we're in sedit mode.. )
    DROP' editLevel1            ( edit object in level 1 )
;

LABEL	DoKEnter		( in case ENTER is pressed.. )
::
    NoEditLine? ?SEMI		( ..and editline exists.. )
    fSysED TstF NOT?SEMI	( ..and we're in sedit mode.. )
    DROP' stdEnter              ( do special std enter )
;

** stdEnter *****************************************************************
* Interface :	( --> )
* Description : Parse and eval the editline
* Ed. Hist. :
*     1.000 04/09/93	DM	alpha
*****************************************************************************

LABEL	stdEnter
::
    TakeOver
    'NOP KeyOb! CacheStack      ( clear <keyob> and save stack for LastStack )

    cursorblink-		( Turn off the cursor. )

    Custom? IT			( CustomEnter, use the normal parser )
    ::
	' ID_AlphaEnter
	@ NOT?SEMI		( AlphaEnter doesn't exist, bye )
	RDROP			( We'll use AlphaEnter instead the parser )

	EDITLINE$		( --> AlphaEnter edit$ )
	DUP SaveLastEdit
	InitEd&Modes
	SWAP			( --> edit$ AlphaEnter )
	EVAL AtUserStack	( Evaluate AlphaEnter and mark user stack )

	COLA E&E.3		( Get back <keyob> and process it )
    ;

    CompEdit$ NOTcase KeyOb0

    EVAL AtUserStack

    E&E.3
;

** CompEdit$ ****************************************************************
* Interface :	( --> .. T/F )
* Description : Compile editline
* Ed. Hist. :
*     1.000 04/09/93	DM	alpha
*****************************************************************************

LABEL	CompEdit$
::				( Try to parse the editline. If an error
				  occurs during parsing, save a copy of
				  EDITLINE$ in LastEdit )
    EDITLINE$ InitEdLine
    1LAMBIND AtUserStack
    ERRSET
    ::	1GETLAM
	$ "{ " !insert$
	->Rpl TRUE
    ;
    ERRTRAP
    ::	DropSysObs FALSE
    ;

    1ABNDSWAP

    case			( Parsing was successful, )
    ::	SaveLastEdit		( so save a copy of EDITLINE$ in LastEdit, )
	InitEdModes		( initialize the editing modes )

	INNERDUP #1= ITE
	::  DROP' ' SWAP 2Ob>Seco
	;
	::  #1+
	    '
	    ::	R> INCOMPDROP
	    ;
	    OVER #1+UNROLL	( --> ob n-1 .. 1 #n )
	    ::N
	;

	TRUE			( return the parsed result and TRUE )
    ;
				( compiling failed )
    ERROR@ #EXITERR #<>
    case			( hard error during compile )
    ::	SaveLastEdit
	ERRJMP
    ;

    EditString

    ERROR@ GETTHEMESG		( --> $e )
    SEP$NL			( --> $e $p )
    DUP ":" OVERLEN$ POS$REV
    #1+ OVERLEN$ SUB$		( --> $e $p )
    DOSTR> COERCE #2-		( --> $e #p )

    SetCursorPos		( --> $e )
    DispEdLine2 		( --> $e )

    #Error: JstGETTHEMSG
    NEWLINE$&$ !insert$

    DoWarning
    SetDA2aNoCh SetDA3NoCh
				( Indicate display area 2b is temporarily
				  valid and that it does show the edit line )
    SetDA2bIsEdL

    FALSE
;

** dispStack ****************************************************************
* Interface :	( --> )
* Description : Display data stack in full or abbreviated form.
* Uses :
* Modifies :
* Calls :	dispStack1 disp1ELev&1 dispLevel SCREENup5 SCREENup7
* Defines :	dispStack1 SCREENup5 SCREENup7
* Ed. Hist. :
*     1.000 09/16/92	RG	alpha
*	001 10/03/92	RG	Error messages are now frozen in the status
*				area while in the seven level mode
*****************************************************************************

LABEL	dispstack
::
    CKRPLInst
    COLA dispStack
;

LABEL	dispStack
::
    TOADISP			( ensure alpha display is used )

    DA2aLess1OK?		( if the stack can lose one row from the )
				( top or bottom to become valid.. )
    ClrNewEditL 		( clear display update shortcut flag used )
				( by "DA2aLess1OK?" )
    case
    ::				( ..then maybe roll up the stack display )
	SetDA2aValid		( signal display area 2a valid, since it )
				( will be assumed valid* )
	NoRollDA2?		( if display area 2 should not be rolled.. )
	case ClrNoRollDA2	( ..then just clear signal that stack disp. )
				( should not be rolled up to become valid )
	HARDBUFF
	5/7? case SCREENup7
	SCREENup5
    ;

    ClrNoRollDA2		( clear signal that stack display should )
				( not be rolled up to become valid )
    ERRSET
	dispStack1
    ERRTRAP			( if failed, try again or display partial stack )
    ::				( dispStackErr, low memory error stack display )
	DropSysObs		( drop any system objects from the stack )
	ERROR@ #0=case		( if the error was an Attn key abort.. )
	    dispStack		( ..then restart the stack display **** )
				( assume the error was insufficient memory )
	#NoRoomForSt JstGETTHEMSG
				( display a "No Room to Show Stack" warning )
	DISPSTATUS2 ERRBEEP
	SetDA1Temp

	SetAbbrevStk		( signal to abbreviate stack display to )
				( conserve memory )
	dispStack1		( display the stack )
	ClrAbbrevStk		( for good measure, clear signal to do an )
				( abbreviated stack display )
    ;

    SetDA2aValid		( signal display area 2a is valid )
;


LABEL	dispStack1		( Main functionality of "dispStack" )
::
    LINESOFSTACK		( calculate the number of DA 2a rows )
    DUP#0=csDROP		( if the edit line fills DA 2, then leave )

    ONESWAP			( init. the current stack level number )

    5/7? ITE
    ::
	DA1Temp? case #1+
	#3+
    ;
	#1+

    ZERO_DO (DO)		( for each display row to fill: )
	ISTOP@
	5/7?
	DA1Temp? NOTAND
	?SKIP #2+ INDEX@ #-

	OVERDUP 		( get the stack level number )
	#3+

	::  DEPTH		( try to get the stack level object )
	    #1- OVER#<
	    casedrop disp1ELev&1
	    PICK dispLevel
	;

	SWAP#1+SWAP		( increment the current stack level number )
    +LOOP			( adjust the row number and loop )
    DROP			( drop stack level number )
;


ASSEMBLE

ScPaSP	GOVLNG	=PopASavptr

SCREENup7
*				 Roll up the display for seven level stack
	PCode

	GOSUB	ScPaSP
	C=0	A
	LC(1)	5

	ACEX	A

	B=C	A
	LC(5)	20+(34*0)		   Offset to Stack Row4
	C=C+B	A
	D0=C		      D0:->Stack Row4	 (Destination)
	LC(5)	20+(34*8)		   Offset to Stack Row3

	GOTO	upentr

SCREENup5
*				Roll up the display for five level stack
	PCode

	GOSUB	ScPaSP
	C=0	A
	LC(1)	3

	ACEX	A

	B=C	A
	LC(5)	20+(34*16)		    Offset to Stack Row4
	C=C+B	A
	D0=C		      D0:->Stack Row4	 (Destination)
	LC(5)	20+(34*24)		    Offset to Stack Row3
upentr	C=C+B	A
	D1=C		      D1:->Stack Row3	 (Source)
	LC(1)	16-8
	D=C	A	      Pixel row counter (8)

uprow	C=D	B  <--------
	P=C	0	    | P: pixel row counter (10)
*			    |
* Copy 10 rows of 34 nibs   |
upr2	C=DAT1	W  <----    |
	DAT0=C	W	|   |
	D0=D0+	16	|   |
	D1=D1+	16	|   |
	C=DAT1	W	|   |
	DAT0=C	W	|   |
	D0=D0+	16	|   |
	D1=D1+	16	|   |
	C=DAT1	B	|   |
	DAT0=C	B	|   |
	D0=D0+	2	|   |
	D1=D1+	2	|   |
	P=P+1		|   |	 Decr pxl row count;  Row copied?
	GONC	upr2 ---    |	 No.
	A=A-1	A	    |	 Decr n; All done?
	GONC	uprow  -----	     No.
gplp	GOVLNG	=GETPTRLOOP
RPL

** dispLevel ****************************************************************
* Interface :	( #DispRow #Level Obj --> #Rows )
* Description : Display a stack level according to display format.
* Calls :	disp1ALev&1 disp1RLev&1
* Ed. Hist. :
*     1.000 09/16/92	RG	alpha
*****************************************************************************

LABEL	dispLevel
::
    AbbrevStack?		( *if the stack is to be abbreviated..* )
    case disp1ALev&1		( *..then display the single-row abbrevi.* )
				( *level and return 1 row used* )
    setStdWid

    OVER #1<>			( *if the level number is not 1..* )
    case disp1RLev&1		( *..single-row* )


    FIFTYTWO TestSysFlag	( *if not in multi-row mode..* )
    case disp1RLev&1		( *..single-row* )

    IsObPCO? case disp1RLev&1

    INHARDROM? case disp1RLev&1


    ::				( *if not a possible multi-row object..* )
	CK&DISPATCH0
	list   FALSE
	seco   FALSE
	symb   FALSE
	unitob FALSE
	TAGGED FALSE
	any    TRUE
    ;

    case disp1RLev&1		( *single-row* )

    SWAPDROP			( *drop #Level* )

*****************************************************************
* ENTRY:	#DispRow Obj
* EXIT: 	#Rows
* ABSTRACT:	Display a possible multi-row stack level one object.
* DATE: 	10/03/92
*****************************************************************

    5/7?
    DA1Temp? NOTAND
    ITE ZERO TWO		( --> #b ob #t )
    3PICKSWAP #-		( --> #b ob #r )
    SWAPOVER			( --> #b #r obj #r )

    SETSTKDC
    ExecInt: Rpl->nLine 	( --> #b #r $.$ #r' )

    DUP #2+ROLL 		( --> #b $.$ #r' #r )
    OVER#= IT SetNoRollDA2
    DUP #2+ROLL 		( --> $.$ #r #b )
    OVER			( --> $.$ #r #b #r )
    ZERO_DO (DO)
	ROT			( --> $.$ #r #d $ )
	ISTOP-INDEX
	#1= ITE "1: " "   "
	!insert$
	OVER DISPN
	#1-
    LOOP

    DROP
;

** disp1RLev&1/disp1ELev&1/disp1ALev&1 **************************************
* Interface :	( #DispRow #Level Obj True --> #1 )
*		( #DispRow #Level FASLE    --> #1 )
* Description : Display a one row stack level object.
* Ed. Hist. :
*     1.000 10/03/92	RG	alpha
*****************************************************************************

LABEL	disp1RLev&1
::
    SETSTKDC
    ExecInt: Rpl->1Line

    SWAP stackitw

    SWAP DISPN			( *display the level and object* )
    ONE
;

LABEL	disp1ELev&1
::
    #:>$

    SWAP DISPN
    ONE
;

LABEL	disp1ALev&1
::
    SWAP #:>$			( *make "n: "* )
    SWAP GET_THE_TYPE		( *make "n: type"* )

    SWAP DISPN			( *display the level and object* )
    ONE
;

** roll&edit ****************************************************************
* Interface :	( ob .. ob #lev --> ob .. ob )
* Description : Edit level #lev.
* Calls :	editLevel1
* Ed. Hist. :
*     1.000 11/18/92	DM	alpha
*****************************************************************************

LABEL	roll&edit
::
    Roll&Do: editLevel1
;

** editLevel1 ***************************************************************
* Interface :	( ob --> ob' )
* Description : Edit level 1.
* Calls :	editDeco$ xEC ->RPL
* Ed. Hist. :
*     1.000 11/18/92	DM	alpha
*****************************************************************************

LABEL	editLevel1
::
    DoLevel1:
    ::
	AdjEdModes
	editDeco$

	NULL$SWAP			( Prompt )
	ONE				( Cursor pos. )

      LABEL	InpErr

	ZEROZERO			( last ins/repl mode, cur. entry mode )
	TWO				( alpha lock disab. )
	{
	    <SkipKey
	    >SkipKey
	    <DelKey
	    >DelKey
	    {	"EC" xEC
	    }
	    {	"CC" xCC
	    }
	    {	"\90STK"
		IStk
	    }
	    TogInsertKey
	}				( Edit menu )
	ONE				( 1st row )
	TRUE				( attn aborts )
	ZERO				( return $ )
	InputLine NOTcaseFALSE
					( --> $ )
	1LAMBIND
	AtUserStack
	ERRSET
	::  1GETLAM ->Rpl TRUE
	;
	ERRTRAP
	::  DropSysObs FALSE
	;

	case ABNDTrue

	1GETABND			( --> $ )

	ERROR@ DUP GETTHEMESG		( --> $ #e $e )
	SWAP #EXITERR
	#=ITE
	::  SEP$NL			( --> $ $e $p )
	    DUP ":" OVERLEN$ POS$REV
	    #1+ OVERLEN$ SUB$		( --> $ $e $p )
	    DOSTR> COERCE
	;
	    ONE 			( --> $ $e #p )

	SWAP				( --> $ #p $e )
	#Error: JstGETTHEMSG
	NEWLINE$&$ !insert$
	DISPSTATUS2 ERRBEEP
	VERYVERYSLOW
	NULL$ UNROT			( --> 0$ $ #p )

      GOTO InpErr
    ;
;

** Rpl->1Line ***************************************************************
* Interface :	( ob --> $ )
* Ed. Hist. :
*     1.000 11/10/92	DM	alpha
*****************************************************************************

LABEL	Rpl->1Line
::
    DUPTYPERRP? casedrop dir$

    IsObPCO? case PcoStkDeco
    INHARDROM? case BIStkDeco

    ChkRef
					( *Initial:* )
    DUPDUP OSIZE #1-			( *rs,rs,#len* )
    NULL$ DUP GetRPLTab 		( *semistk,sol,RPLTab,ExRPLTab* )
    ' NULLLAM DECOLAMS NDUPN DOBIND
					( --> rs $ )
    @sol SWAP DCObj ROTDROP		( --> rs' $' )
    GOTO r->Entry

    LABEL	r->Loop
	@sol ROT DCObj			( --> $ $sol rs' $' )
	ROTDROP CHR_Space >H$		( --> $dc rs' $' )
	ROTSWAP !append$		( --> rs' $dc' )
      LABEL	r->Entry
	?ATTNQUIT
	OVER @rs rs- @rsLen #>		( --> rs' $dc' f )
	OVERLEN$ DcompWidth@ #> OR
	NOT?GOTO r->Loop

    SWAPDROP
    ABND
;

** Rpl->nLine ***************************************************************
* Interface :	( ob #r --> $1 .. $r' #r' )
* Description : Decompiles ob, uses max. #r (>0) rows.
* Ed. Hist. :
*     1.000 11/11/92	DM	alpha
*****************************************************************************

LABEL	Rpl->nLine
::
    SWAP				( --> #r ob )

    DUPTYPERRP? case2drop
    ::	dir$ ONE
    ;

    IsObPCO? case
    ::	SWAPDROP
	PcoStkDeco ONE
    ;

    INHARDROM? case
    ::	SWAPDROP
	BIStkDeco ONE
    ;

    ChkRef SWAP 			( --> ob #r )
    OVERDUP OSIZE #1-			( *r,rs,#len* )
    NULL$ DUP GetRPLTab 		( *semistk,sol,RPLTab,ExRPLTab* )
    ' NULLLAM MRDECOLAMS NDUPN DOBIND   ( --> ob )

    ZEROSWAP				( --> #0 ob )
    NULL$				( --> #0 ob 0$ )

    LABEL	mldc_Loop
	@sol DUP			( --> rs $ $s $s )
	4ROLL DCObj			( --> $ $sol $sol' rs' $' )

	ROT 4ROLL			( --> $ rs' $' $sol' $sol )
	LEN$ OVERLEN$ #>		( --> $ rs' $' $sol' f *SEMI* )
	?GOTO mldc_Semi

	DUPLEN$ @sol LEN$ #<		( --> $ rs' $' $sol' f *COL* )
	?GOTO mldc_Nl

	OVERLEN$			( --> $ rs' $' $sol' # )
	5PICK LEN$ #+
	DcompWidth@ #<			( *no NL* )
	?GOTO mldc_AppSp

      LABEL	mldc_Nl 		( --> .. # $ rs' $' $sol' )
	!insert$			( --> .. # $ rs' $' )
	3PICK NULL$?
	ITE
	    ROTDROP			( --> .. # rs' $' )
	::  4ROLL #1+DUP 4UNROLL	( --> .. $ #' rs' $' #' )
	    @mlrows #< ?SEMI
	    ABND 2DROP RDROP
	;

	GOTO mldc_EOS?

      LABEL	mldc_Semi		( --> .. # $ rs' $' $sol' )
	!insert$			( --> .. # $ rs' $' )

	3PICK NULL$?
	ITE
	::  ROTDROP			( --> .. # rs' $' )
	    ROTSWAP			( --> .. rs' # $' )
	;
	::  4ROLL #1+SWAP		( --> .. $ rs' #' $' )

	    OVER @mlrows #< ?SEMI
	    ROT 2DROP RDROP ABND	( --> .. $ #' )
	;

	UNROT #1+SWAP			( --> .. $ $' #' rs' )

	OVER @mlrows #=
	OVER @rs rs- @rsLen #>
	ORcase
	:: DROP ABND
	;

	NULL$				( --> .. $ $' #' rs' 0$ )
	GOTO mldc_Loop

      LABEL	mldc_AppSp		( --> $ rs' $' $sol' )
	4PICK NULL$?
	ITE
	    !insert$

	::  DROP CHR_Space >H$
	;

	ROTSWAP !append$		( --> .. rs' $ )

      LABEL	mldc_EOS?
	OVER @rs rs- @rsLen		( --> rs' $dc' f )
	#>case
	::  SWAPDROPSWAP ABND #1+
	;

	?ATTNQUIT
    GOTO mldc_Loop
;

** editDeco$ ****************************************************************
* Interface :	( ob --> $ )
* Description : Decompiles ob for editing.
* Ed. Hist. :
*     1.000 11/18/92	DM	alpha
*****************************************************************************

LABEL	editDeco$
::
    CKRPLInst
    TWENTYTWO !DcompWidth
    MINUSONE
    ExecExt:
    ::	ReportOff
	Rpl->nLine
    ;
    DUP#1= caseDROP
    #1-
    ZERO_DO (DO)
	SWAP CHR_Newline >T$
	!insert$
    LOOP
;


LABEL	PcoStkDeco			( pco --> $name | $ptr )
::
    ob># SWAPDROP
    GetRPLTab NOT
    ITE_DROP
    ::	SrchRTNam NOT?SEMI
	RDROP
    ;

    #>x$ ptr$ SWAP&$
;


LABEL	BIStkDeco			( rw --> $name | $ptr )
::
    ob>#
    GetRPLTab NOT
    ITE_DROP
    ::	SrchRTNam NOT?SEMI
	SWAPDROP RDROP
    ;

    SWAP				( --> #addr ob )
    DUPROM-WORD? IT
    ::	DUP ObPtrDeco NOT?SEMI		( --> #addr ob [id] )
	UNROT2DROP ID>$ CHR_x >H$
	RDROP
    ;

    DROP #>x$ ptr$ SWAP&$
;

*****************************************************************************
*			  INTERACTIVE STACK
*****************************************************************************

*****************************************************************************
*		DEFINES
*****************************************************************************


ASSEMBLE
RPL

DEFINE	ISExit! 	1PUTLAM
DEFINE	ISExit@ 	1GETLAM
DEFINE	SelPos! 	2PUTLAM
DEFINE	SelPos@ 	2GETLAM
DEFINE	SelLev! 	3PUTLAM
DEFINE	SelLev@ 	3GETLAM
DEFINE	SelLevDelta!	4PUTLAM
DEFINE	SelLevDelta@	4GETLAM
DEFINE	ISMax!		5PUTLAM
DEFINE	ISMax@		5GETLAM
DEFINE	ISMin!		6PUTLAM
DEFINE	ISMin@		6GETLAM

DEFINE	NRISLAMS	SIX


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** xIStk *******************************************************************
* Interface :	( --> )
* Description : Provides an interface to select and operate on stack items.
* Ed. Hist. :
*     0.000 11/14/1992	DM	alpha version
*****************************************************************************

LABEL	IStk
::
    TakeOver

    UStackDepth
    #0=case
    ::	EmptyStack$ DoWarning
	SetDA23NoCh
    ;

    NoEditLine? IT
    ::
	CacheStack
	InitEdModes
    ;

    POLSaveUI
    ERRSET
    ::
	TOADISP
	setStdWid

	DEPTH UStackDepth #-

	5/7? ITE ONE THREE
	EIGHT OVER#-

	ROT ONE SEVEN		( select stack level 1 and lower display pos )
	FALSE'                  ( initialize exit condition to FALSE )

	NULLLAM NRISLAMS NDUPN
	DOBIND			( save IStk variables )

	' IStkDisp              ( specify IStk display object )
	' IStkKeys              ( specify IStk key handler )

	TrueTrue		( specify IStk and standard key handling )
	EditLExists?		( if there's an edit line... )
	SelLevDelta@ #0<> OR
	ITE			( ...OR the selected level offset is non-zero... )
	::  ' IStkMenuEd        ( ...then specify the editing IStk menu )
	;
	    IStkMenu		( ...else specify the non-editing IStk menu )

	ONEFALSE'               ( specify the IStk menu row and )
				( no suspended environments allowed )
	ISExit@ 		( specify IStk exit condition )
	'ERRJMP                 ( specify IStk error handler )
	POLSetUI		( set the IStk user interface )
	ClrDAsOK		( ensure display areas are updated )
	POLKeyUI		( display, read, and evaluate )
	ABND			( abandon the IStk environment )
    ;
    ERRTRAP
	POLResUI&Err

    POLRestoreUI
    ClrDAsOK
;

*** IStkDisp ****************************************************************
* Interface :	( --> )
* Description : The IStk display object
*****************************************************************************

LABEL	IStkDisp
::
    DA2OK? NOT_IT	( interactive stack area is invalid... )
	?DispIStk	( ...then maybe display the interactive stack )

    LABEL	Disp?Status
    ::
	5/7? case ClrDA1IsStat

	DA1OK?NOTIT	( status area is invalid... )
	    ?DispStatus ( ...then maybe display the system status )
    ;

    DA3OK?NOTIT 	( menu labels are invalid... )
	?DispMenu	( ...then maybe display them )

    ClrDAsOK
;

*** ?DispIStk ***************************************************************
* Interface :	( --> )
* Description : Display interactive stack according to the key-in-buffer
*	state. If there is no key in the key buffer, then display the
*	interactive stack.  Otherwise, delay display but signal that the
*	display is invalid.
*****************************************************************************

LABEL	?DispIStk
::
    KEYINBUFFER?		( no key in the key buffer... )
    case			( ... signal that the stack area is invalid )
    ::
	SetDA2aBad
	SetDA2bBad
    ;

    SelLev@ SelPos@ #+-1	( calculate the highest-numbered stack )
				( level to display )
    ISMax@
    ZERO_DO (DO)		( for each level: )
	ISTOP-INDEX ISMin@ #+-1 ( calculate the display row )
					( --> #h #r )
	OVER OVER#- #1+DUP	( calculate the level number )
					( --> #h #r #h-r+1 #h-r )
	#3+				( --> #h #r #h-r #l )
	disp1RowLev		( pick & display the one-row object )

	ISTOP-INDEX ISMin@ #+-1
	SelPos@
	#= IT			( this display row is the selected position.. )
	    showSel		( ..indicate the selected level )
    LOOP
    DROP
    SetDA2Valid 		( signal interactive stack area valid )
;

*** IStkKeys ****************************************************************
* Interface :	( #KeyCode #Plane  --> KeyDef TRUE )
*		( #KeyCode #Plane  --> FALSE )
* Description : The IStk key handler
*****************************************************************************

LABEL	IStkKeys
::
    OVER SEVEN #<		( a menu key... )
    case2drop FALSE		( ...do standard definition )

    kpNoShift			( plane is unshifted... )
    #=casedrop
    ::
	kcUpArrow   ?CaseKeyDef IStkUp&Rep	( move pointer up )
	kcDownArrow ?CaseKeyDef IStkDn&Rep	( move pointer down )
	kcNegate    ?CaseKeyDef IStkEdit	( edit the selected level )
	kcBackspace ?CaseKeyDef IStkDrop	( discard selected level )
	kcEnter     ?CaseKeyDef IStackEnter	( quit interactive stack )
	kcOn	    ?CaseKeyDef IStackAttn	( quit interactive stack )

	GOTO IKeyRem
    ;

    kpLeftShift 		( plane is left-shifted... )
    #=casedrop
    ::
	kcUpArrow   ?CaseKeyDef IStkPgUp	( move pointer one page up )
	kcDownArrow ?CaseKeyDef IStkPgDn	( move pointer one page down )
	kcNegate    ?CaseKeyDef IStkEdit	( edit the selected level )

	GOTO IKeyRem
    ;

    kpRightShift		( plane is right-shifted... )
    #=casedrop
    ::
	kcOn #=casedrpfls		( do standard "off" key definition )

	kcUpArrow   ?CaseKeyDef IStkFarUp	( move pointer far up )
	kcDownArrow ?CaseKeyDef IStkFarDn	( move pointer far down )
	kcNegate    ?CaseKeyDef IStkVisit	( visit the selected level )

      LABEL	IKeyRem
	kcNextRow    #=casedrpfls	( do standard "1st Row" key definition )
	kcLeftShift  #=casedrpfls	( do standard Left-shift key definition )
	kcRightShift #=casedrpfls	( do standard Right-shift key definition )

	DROPDEADTRUE		( otherwise, bad key )
    ;

    2DROP 'DoBadKeyT            ( otherwise, bad key )
;

*** IStkUp&Rep **************************************************************
* Interface :	( --> )
* Description : Move interactive stack one level up and repeat until key
*		is released.
*****************************************************************************

LABEL	IStkUp&Rep
::
    TakeOver
    SelLev@ IStackDepth #1-
    #=case		( highest-numbered level is already selected... )
	DoBadKey	( ...beep )

    REPEATERCH		( repeat until key is released )
    kcUpArrow
    ::
	SelLev@ IStackDepth #3-
	#=		( highest-numbered level is already selected... )
	?SEMI		( ...do nothing )

	UnshowSel		( clear the current selected level indication )
	SelLev@ #1+ SelLev!	( adjust the selected level )
	SelPos@ ISMin@ #=ITE	( selected position is the top of the window... )
	::  HARDBUFF		( ...move the display down and display new lev )
	    5/7? ITE
		SCREENdn7	( move the top 6 levels down )
		SCREENdn5	( move the top 4 levels down )

	    ISMin@ SelLev@ DUP #4+
	    disp1RowLev 	( pick & display the new selected level )
	;
	::			( ...else move the selected position )
	    SelPos@ #1- SelPos! ( adjust the selected position )
	;

	showSel 		( indicate the new selected level )

	LABEL	SlowG
	::
	    EvalSG: NOP SLOW
	;
    ;

    SetDAsNoCh
;

ASSEMBLE

SCREENdn5
*				Roll down the display for five level stack
	PCode

	GOSUBL	ScPaSP

	C=A	A
	RSTK=C

	A=0	A
	LA(1)	3		row offset
	B=A	A
	LC(5)	8*34		row's worth
	D=0	A

sd2	D=D+C	A  <---
	B=B-1	A      |
	GONC	sd2 ---
*				D[A]:row offset in nibs  (n-1)*8*34
	C=RSTK

	B=C	A
	LC(5)	20+(34*16)	Offset to Stack Row5
	GOC	sd5

SCREENdn7
	PCode

	GOSUBL	ScPaSP

	C=A	A
	RSTK=C

	A=0	A
	LA(1)	5		row offset
	B=A	A
	LC(5)	8*34		row's worth
	D=0	A
sd1	D=D+C	A  <---
	B=B-1	A      |
	GONC	sd1 ---
*				D[A]:row offset in nibs  (n-1)*8*34
	C=RSTK

	B=C	A
	LC(5)	20+(34*0)	Offset to Stack Row7
sd5	C=C+B	A
	C=C+D	A
	D1=C			D1:->Destination
	B=C	A
	LC(5)	8*34
	B=B-C	A
	C=B	A
	D0=C			D0:->Source
	LC(1)	16-8
	D=C	A		D: # of pix rows per char row
	LC(5)	16*34
	R0=C			size of backup step

downrow C=D	B  <---------
	P=C	0	     |	P:pixel row counter  (8)
dnr2	C=DAT0	W  <-----    |
	DAT1=C	W	 |   |
	D0=D0+	16	 |   |
	D1=D1+	16	 |   |
	C=DAT0	W	 |   |
	DAT1=C	W	 |   |
	D0=D0+	16	 |   |
	D1=D1+	16	 |   |
	C=DAT0	B	 |   |
	DAT1=C	B	 |   |
	D0=D0+	2	 |   |
	D1=D1+	2	 |   |
	P=P+1		 |   |
	GONC	dnr2  ---    |
	C=R0		     |
	AD0EX		     |
	A=A-C	A	     |	back up source
	AD0EX		     |
	AD1EX		     |
	A=A-C	A	     |	back up target
	AD1EX		     |
	A=A-1	A	     |
	GONC	downrow  ----

	GOLONG	gplp
RPL

*** IStkDn&Rep **************************************************************
* Interface :	( --> )
* Description : Move interactive stack one level down and repeat until key
*		is released.
*****************************************************************************

LABEL	IStkDn&Rep
::
    TakeOver
    SelLev@ #1=case	( lowest-numbered level is already selected... )
	DoBadKey	( ...beep )

    REPEATERCH
    kcDownArrow
    ::
	SelLev@ #1=	( lowest-numbered level is already selected... )
	?SEMI		( ...do nothing )

	UnshowSel		( clear the current selected level indication )
	SelLev@ #1- SelLev!	( adjust the selected level )
	SelPos@ SEVEN #=ITE	( selected position is bottom of the window... )
	::  HARDBUFF		( ...move the display up and display a new lev )
	    5/7? ITE
		SCREENup7	( move the top 6 levels up )
		SCREENup5	( move the top 4 levels up )

	    SEVEN SelLev@ DUP #4+
	    disp1RowLev 	( pick & display the new selected level )
	;
	::			( ...else move the selected position )
	    SelPos@ #1+ SelPos! ( adjust the selected position )
	;

	showSel 		( indicate the new selected level )

	SlowG
    ;

    SetDAsNoCh
;

*** IStkPgUp ****************************************************************
* Interface :	( --> )
* Description : Move interactive stack n levels up
*****************************************************************************

LABEL	IStkPgUp
::
    TakeOver
    IStackDepth SelLev@ 2DUP#=	( highest level is already selected... )
    case2drop DoBadKey		( ...beep )

    2DUPSWAP ISMax@ #MAX ISMax@ #-
    #>ITE			( new level will be too high... )
    ::				( ...adjust )
	DROP SelLev!		( drop the proposed level, select highest level )
    ;
    ::
	ISMax@ #+ SelLev!	( select the proposed level )
	DROP			( drop the highest level number )
    ;
    ?adjSelPos			( maybe adjust the selected position )
    SetDA13NoCh
;

*** IStkPgDn ****************************************************************
* Interface :	( --> )
* Description : Move interactive stack n levels down
*****************************************************************************

LABEL	IStkPgDn
::
    TakeOver
    SelLev@ DUP #1=		( lowest level is already selected... )
    casedrop DoBadKey		( ...beep )

    DUP ISMax@ #1+ #<ITE	( new level will be too low... )
    ::				( ...adjust )
	DROPONE SelLev! 	( select the first level )
	SEVEN SelPos!		( select the bottom position )
    ;
    ::
	ISMax@ #- SelLev!	( select the proposed level )
	?adjSelPos		( maybe adjust the selected position )
    ;

    SetDA13NoCh
;

*** IStkFarUp ***************************************************************
* Interface :	( --> )
* Description : Move interactive stack to the highest-numbered level
*****************************************************************************

LABEL	IStkFarUp
::
    TakeOver
    IStackDepth SelLev! 	( select the highest level )
    ?adjSelPos			( maybe adjust the selected position )
    SetDA13NoCh
;

*** IStkFarDn ***************************************************************
* Interface :	( --> )
* Description : Move interactive stack to level 1
*****************************************************************************

LABEL	IStkFarDn
::
    TakeOver
    ONE SelLev! 		( set the selected level )
    SEVEN SelPos!		( set the selected position )
    SetDA13NoCh
;

*** IStkDrop ****************************************************************
* Interface :	( obn ... obm+1 obm obm-1 ... ob1
*		  --> obn ... obm+1 obm-1 ... ob1 )
* Description : Discard the selected stack level
*****************************************************************************

LABEL	IStkDrop
::
    BadIfEdit			( beep if there is an edit line existent )
    SelLev@&Ck ROLLDROP 	( discard the selected object )
    ?adjSel/Exit		( maybe adjust the selected level or exit )
    SetDA13NoCh 		( signal status and menu label areas unchanged )
;

*** IStkMenu ****************************************************************
* Interface :	( --> IStkMenu )
* Description : The non-saving, non-editing IStk menu
*****************************************************************************

LABEL	IStkMenu
::
    NoExitAction		( ensure this menu is not saved in LastMenu )
    {
	LABEL	IStkEchoKey
	{   $_ECHO
	    IStkEcho
	}
	{   "EDIT"
	    {
		::  TakeOver		( --> )
		    SelLev@ UNCOERCE
		    fSysED fITE
			roll&edit
			Roll&View	( view/edit the specified level )
		    ?adjSel/Exit	( maybe adjust the selected level or exit )
		;
		DoBadKey
		::  TakeOver		( --> )
		    SelLev@ PICK	( copy the selected object )
		    EvalSG:
			IndirectView	( indirect-view the specified level )
			G_IndirectView
		    ?adjSel/Exit
		;
	    }
	}
	{   xPICK
	    IStackPick
	}
	{   xROLL
	    IStackRoll
	}
	{   xROLLD
	    IStackRollD
	}
	{   "PRG"
	    ::				( obn ... ob1 --> :: obn ... ob1 ; )
		IStkDoN: ::N
	    ;
	}
	{   xDUPN
	    IStackDupN
	}
	{   "DRPN"
	    ::				( obn ... ob1 --> )
		IStkDoN: NDROP		( NDROP the selected objects )
	    ;
	}
	{   "KEEP"
	    ::	TakeOver		( obm ... obn ... ob1 --> obn ... ob1 )
					( Keep the selected stack levels )
		DEPTH UNCOERCE CKNNOLASTWD
		DROP			( claim the entire stack )
		SelLev@ 		( create the to-keep mata-ob )
		DEPTH #1- OVER#-
		OVER#2+UNROLL		( create the to-drop meta-ob )
		psh			( swap the meta-obs )
		N+1DROP ( "NDROP DROP" ) ( drop the to-drop meta-ob and the to-keep count )
		?adjSel/Exit
		SetDA13NoCh
	    ;
	}
	{   "LEVEL"
	    IStackLevel
	}
	{   "REV"
	    ::	SelLev@&Ck reversym DROP
		AUStk&13NoCh
	    ;
	}
	{   x>LIST
	    ::				( obn ... ob1 --> { obn ... ob1 } )
		LABEL	IStkDoN:
		::
		    SelLev@&Ck 'REVAL   ( combine the selected objects )
		    ?adjSel/Exit
		    SetDA13NoCh
		;
		P{}N
	    ;
	}
	{   ::
		LABEL	Set?box/std:
		::
		    TakeOver
		    'R'R TstF Box/StdLabel
		;
		"S-ED" fSysED
	    ;
	    ::	LABEL	ToggleFKey:
		::
		    TakeOver
		    'R DUP fITE ClrF SetF
		;
		fSysED
		SetDA12NoCh
	    ;
	}
	{   ::	Set?box/std: "5/7" f5/7
	    ;
	    ::	ToggleFKey: f5/7
		EIGHT
		5/7? ITE ONE THREE
		DUP ISMin! #- ISMax!
		?adjSelPos
	    ;
	}
    }
;

*** IStkMenuEd **************************************************************
* Interface :	( --> IStkMenuEd )
* Description : The editing IStk menu
*****************************************************************************

LABEL	IStkMenuEd
{
    IStkEchoKey
}

*** IStkEcho ****************************************************************
* Interface :	( --> )
* Description : Copy the selected level to the edit line
*****************************************************************************

LABEL	IStkEcho
::
    TakeOver
    SelLev@ SelLevDelta+ PICK	( copy the selected level )
    DUP
    fSysED fITE
	editDeco$
	EchoDecomp		( dc as if for editing, no "'" around names )
    CkChr00 NOT 		( echoed obj would have any null chr.. )
    case2drop			( ..do a warning )
    ::	Err#Chr00 JstGETTHEMSG
	DoWarning
	SetDA23NoCh
    ;

    SWAP AdjEdModes DROP	( adjust the edit modes according to obj type )
    NoEditLine? ITE		( this will be the beginning of a new edit line.. )
    ::				( ...set up the editing menu for subs. opera. )
	IStkMenuEd ONE StartMenu
				( set up the editing IStk menu )
	SetDA2NoCh
    ;
	SetDA23NoCh
				( echo the selected object to the edit line )
				( with appropriate spacing )
    ?Space/go> Echo$NoChr00 ?Space/go>
;

*** IStkEdit ****************************************************************
* Interface :	( --> )
* Description : Edit the selected level.
*****************************************************************************

LABEL	IStkEdit
::
    BadIfEdit			( beep if there is an edit line existent )
    SelLev@ UNCOERCE
    fSysED fITE
	roll&edit
	Roll&Edit		( edit the specified level )
    ?adjSel/Exit		( maybe adjust the selected level or exit )
;

*** IStkVisit ***************************************************************
* Interface :	( --> )
* Description : Visit the selected level
*****************************************************************************

LABEL	IStkVisit
::
    BadIfEdit			( beep if there is an edit line existent )
    SelLev@ PICK		( copy the selected object )
    EvalSG: Visit Visit_G	( visit the specified level )
    ?adjSel/Exit		( maybe adjust the selected level or exit )
;

*** ?adjSel/Exit ************************************************************
* Interface :	( --> )
* Description : Maybe adjust the selected level and display position or
*		maybe exit according to the change in the stack depth.
*		To compact code, this word also signals a valid user stack.
*****************************************************************************

LABEL	?adjSel/Exit
::
    AtUserStack 		( signal a valid user stack )
    DEPTH ZERO #=casedrop	( stack is empty... )
	SetISExit		( ...signal to exit )
    DUP SelLev@ #<ITE		( stack depth < selected level... )
	SelLev! 		( ...select the highest level )
	DROP			( ...else drop the stack depth )
    ?adjSelPos			( maybe adjust the selected position )
;

*** ?adjSelPos **************************************************************
* Interface :	( --> )
* Description : Maybe adjust the selected display position according to the
*		current stack depth and selected level
*****************************************************************************

LABEL	?adjSelPos
::
    IStackDepth 		( calculate interactive stack depth )
    SelLev@ #- SEVEN ISMin@ #-
    #MIN #1+			( calculate maximum display position )

    EIGHT SelLev@ ISMax@ #MIN #- ( calculate minimum display position )

    SelPos@ ROT #MIN #MAX
    SelPos!			( adj with favor to min pos, set new disp pos )
;

*** IStk Utilities **********************************************************
*****************************************************************************

LABEL	showSel 	( --> )
::
    GROB 1A 80000600003070F0F1F0703000
    >selPict			( replace colon with pointer )
;

LABEL	UnshowSel	( --> )
::
    GROB 1A 80000600000060600060600000
    >selPict			( replace pointer with colon )
;

LABEL	>selPict	( grobItem --> )
::
    ABUFF			( --> gr tg )
    SelLev@ #>$ LEN$ #6*	( calculate x-offset of pointer )
    SelPos@ #1- #8*		( calulate y-offset of pointer )
    GROB!			( replace current item with new )
;

LABEL	disp1RowLev	( #DispRow #Level #Stkentry --> )
::
    SelLevDelta+ ?PICK

    case			( specified level has an object.. )
    ::	disp1RLev&1 DROP	( ..decompile the level's full object )
    ;

    #:>$ SWAP DISPN		( ..else just decompile the level )
;


*****************************************************************************
*			  CHARACTER SET CATALOG
*****************************************************************************

*****************************************************************************
*		DEFINES
*****************************************************************************

ASSEMBLE
RPL

DEFINE	CCx@		1GETLAM
DEFINE	CCx!		1PUTLAM
DEFINE	CCy@		2GETLAM
DEFINE	CCy!		2PUTLAM
DEFINE	1st?		3GETLAM
DEFINE	1st?!		3PUTLAM
DEFINE	Cofs		4GETLAM
DEFINE	Cofs!		4PUTLAM
DEFINE	CExit		5GETLAM
DEFINE	CExit!		5PUTLAM
DEFINE	BIN?		6GETLAM
DEFINE	BIN!		6PUTLAM
DEFINE	Iopar?		7GETLAM

DEFINE	NRCSCLAMS	SEVEN


*****************************************************************************
*		OBJECTS
*****************************************************************************


*** CC **********************************************************************
* Interface :	( --> )
* Description : character set catalog
* Ed. History :
*     1.000	22.04.1992	RH	start
*	001	13.12.1992	DM	review the code, made absolute
*****************************************************************************

ASSEMBLE
	XNAME	CC
RPL
::
    TakeOver CKRPLInst

    EditLExists?
    ITE
	ClrDA2bIsEdL
    ::	CK0NOLASTWD
	BlameCC
    ;

    ClrDA1IsStat

    InitSFlags

    POLSaveUI
    ERRSET
    ::
	'
	LABEL	iopar
	ID IOPAR @
	ITE
	    DROPFALSE
	    TRUE

	FalseFalse ZERO TRUE ONEONE	( *Iopar,BIN,CExit,Cofs,1st?,CCy,CCx* )

	' NULLLAM NRCSCLAMS NDUPN DOBIND

	'                               ( *CSCDisp* )
	::
	    ::	DA1OK? ?SEMI
					( ** This code will do the hard work ** )
		NULL$ SIXTEEN EXPAND Cofs
		CCDisp DROP

		CCx@ CCy@

		LABEL	Cbigbar 	( #x #y --> )
		::
		    HARDBUFF UNROTSWAP
		    cc2#-1*6
		    3PICK3PICK 3PICKOVER	( *HB X Y HB X Y X* )
		    SEVEN #+OVER #7+		( *HB X Y HB X Y X+13 Y+7 * )
		    SUBGROB INVGROB
		    4UNROLL GROB!
		;

		SetDA1Valid
	    ;

	    DA3OK? ?SEMI
	    N>$ #>CHR CHR>$ DUP $>GROB
	    HARDBUFF # 76 ELEVEN GROB!
	    KVISLF
	    HARDBUFF # 6C THIRTYNINE
	    XHI FORTYSIX GROB!ZERODRP
	    DUP $>GROB DUPGROBDIM SWAPDROP
	    #2/ # 79 SWAP#- ROT LEN$ FOUR
	    #= IT #1-
	    THIRTYNINE HARDBUFF UNROT GROB!

	    DispMenu
	    SetDA3Valid
	;

	'                               ( *CSCKeys* )
	::  ONE #=casedrop
	    ::	DUP#<7 casedrpfls
		ELEVEN ?CaseKeyDef
		::  TakeOver
		    REPEATERCH
		    ELEVEN
		    ::	CCx@ CCy@ 2DUP
			ccup
			LABEL	RC!big
			::
			    2DUP Cbigbar
			    CCy! CCx!
			    Cbigbar
			    SetDA3Bad
			    SlowG
			;
		    ;
		;
		SIXTEEN ?CaseKeyDef
		::  TakeOver
		    REPEATERCH
		    SIXTEEN
		    ::	CCx@ CCy@ OVER ONE
			ccup
			DROP CCy@
			RC!big
		    ;
		;
		SEVENTEEN ?CaseKeyDef
		::  TakeOver
		    REPEATERCH
		    SEVENTEEN
		    ::	CCx@ CCy@ 2DUP
			ccdn
			RC!big
		    ;
		;
		EIGHTEEN ?CaseKeyDef
		::  TakeOver
		    REPEATERCH
		    EIGHTEEN
		    ::	CCx@ CCy@ OVER EIGHT
			ccdn
			DROP CCy@
			RC!big
		    ;
		;
		kcEnter ?CaseKeyDef
		::  TakeOver
		    EditLExists? NOTcase
		    ::	N>$ DUP UNCOERCE SWAP
			#>CHR CHR>$ >TAG
		    ;

		    N>$ DUP#0=csDROP
		    #>CHR CHR>$ Echo$NoChr00
		;
		FORTYFIVE ?CaseKeyDef
		::  TakeOver TRUE CExit!
		;
		COLA CsCKeys
	    ;
	    TWO #=casedrop
	    LABEL	CsCKeys
	    ::	kcLeftShift #=casedrpfls
		kcRightShift #=casedrpfls
		DROPDEADTRUE

	    ;
	    THREE #=casedrop
	    ::	kcOn #=casedrpfls
		COLA CsCKeys
	    ;
	    2DROP 'DoBadKeyT
	;

	TrueTrue
					( *CSCMenu* )
	{
	    {	xSWAP
		::  TakeOver
		    SetDA1Bad
		    SetDA3Bad
		    CCx@ CCy@ Cbigbar
		    1st? NOT DUP 1st?!
		    ITE
			ZERO
			BINT_128d
		    Cofs!
		;
	    }
	    {	::  TakeOver "BIN"
		    BIN? Box/StdLabel
		;
		::  TakeOver
		    BIN? NOT BIN!
		    DispMenu
		;
	    }
	    {	::  TakeOver
		    BIN? case
		    ::
			LABEL	CGETDESC
			::
			    "0000000"

			    LABEL	N>$
			    ::
				CCx@ CCy@ ccn>$ Cofs #+
			    ;

			    DOBIN
			    #>HXS hxs>$ CDR$ CDR$
			    &$ DUPLEN$ DUP SEVEN
			    #-SWAP SUB$
			;

			FIVE
			1_#1-SUB$ MakeInvLabel
		    ;
		    DOHEX N>$ #>HXS hxs>$
		    CDR$ CDR$ INSERT_SPACE
		    CHR_# >H$ MakeInvLabel
		;
		DoBadKey
	    }
	    {	::  TakeOver
		    BIN? case
		    ::	CGETDESC FIVE EIGHT
			SUB$ MakeInvLabel
		    ;
		    "%" N>$ #>$
		    DUPLEN$ TWO #>?SKIP INSERT_SPACE
		    &$ MakeInvLabel
		;
		DoBadKey
	    }
	    NullMenuKey
	    {	$_EXIT
		::  TakeOver
		    TRUE CExit!
		;
	    }
	}

	ONEFALSE' CExit
	'ERRJMP

	RECLAIMDISP
	"RPL48 CHARSET CATALOG"
	$>grob HARDBUFF TEN ZERO GROB!
	StatusBound HARDBUFF ZERO SIX GROB!
	"5\D77" MakeInvLabel HARDBUFF # 6E TWENTY GROB!
	"TIO " GetIOPAR
	6UNROLL 5DROP
	IOCheckReal %IP># DUP
	THREE #>case SetIOPARErr
	FORTYEIGHT #+ #>CHR
	>T$ MakeInvLabel
	HARDBUFF # 6E FORTYEIGHT GROB!

	POLSetUI
	POLKeyUI

	Iopar?
	ABND
	NOT?SEMI
	' iopar PURGE
    ;
    ERRTRAP
    ::	RestSFlags
	POLResUI&Err
    ;

    RestSFlags
    POLRestoreUI
    ClrDAsOK
;


ASSEMBLE

BlameCC
	PCode

	LA(5)	xCC
	GOLONG	BlameRW

ccn>$
	PCode
					( Col@ #1- #8*	Row@ #1- #+ )
	GOSUB	pop2#-
	A=A+A	A
	A=A+A	A
	A=A+A	A
	A=A+B	A
	GOLONG	OpshAL

cc2#-1*6
	PCode
					( #1- #6*  #1- #6* )
	GOSUB	pop2#-
	GOSUB	mulA6
	A=A+CON A,7
	ABEX	A
	GOSUB	mulA6
	C=B	A
Cpsh2L	GOLONG	Opsh2L

pop2#-	GOSUB	Cpop2#
	A=A-1	A
	C=C-1	A
	B=C	A
	RTNCC

mulA6	A=A+A	A
	C=A	A
	C=C+C	A
	A=A+C	A	** I*6
	RTNCC

savPtr	GOVLNG	=SAVPTR

ccup
	PCode

	GOSUB	Cpop2#	* Row  8  Col
	C=C-1	A
	?C#0	A
	GOYES	nwrp2
	C=B	A
	B=B+B	A
	A=A-1	A
	?A#0	A
	GOYES	nwrp2
	A=B	A
nwrp2	GOTO	nwrp1

Cpop2#	GOSBVL	=POP2#	* Col		Row
	RSTK=C
	GOSUB	savPtr
	P=	0
	C=0	A
	LCHEX	8
	P=	0
	B=C	A
	C=RSTK
	RTNCC

ccdn
	PCode
**			A	B	C	D
	GOSUB	Cpop2#
	C=C+1	A
	?C<=B	A
	GOYES	nwrp1
	C=C-B	A
	B=B+B	A
	A=A+1	A
	?A<=B	A
	GOYES	nwrp1
	A=A-B	A
nwrp1	GOTO	Cpsh2L


************************************
*
*  DSP - The FAST ASCII Chart
*
************************************

sCLEAR	EQU	2

CCDisp	PCode
*				A	B	C	D	D0	D1
	GOSBVL	=POP#
	GOSBVL	=SAVPTR
	C=0	A
	LCHEX	124
	B=C	A

	GOSUBL	GetAdisp

	C=DAT0	A
	C=C+B	A
	D0=C							&Body(ADISP)+ofs

	A=A-CON B,8
	R2=A.F	B		** R2: MINUSONE

	CD0EX
	D0=C

******************************
* HERE:
* R2: \A\
* R3: &Body(ADISP)
* R4: Loop Cnt
******************************
	A=0	A
	LAHEX	7

OuterL	R4=A.F	A		** R4[A]: OuterLoop Counter
	A=0	S
	A=A+1	S

InnerL	R3=C.F	A		** R3[A]: &Body(ADISP)
	R4=A.F	S		** R4[S]: InnerLoop Counter

**ASC_8***********************
*
* Create a register full
* of ASCII characters
*
******************************
*				A	B	C	D	D0	D1
ASC_8	A=0	W
	LCHEX	08		** Step size

	A=R2.F	B		Chr
	P=	9		** Loop count

ASClp	A=A+C	B
	B=A	B
	ASRC
	ASRC
	A=B	B
	P=P+1
	GONC	ASClp

	A=A+C	B
	R2=A.F	B
	ASRC
	ASRC
**END_ASC_8*******************

	GOSBVL	=D1=DSKTOP	** Get level 1 adr
	C=DAT1	A
	CD1EX			** Get $ adr
	D1=D1+	10		** Point to body of $
	DAT1=A	W		** Write char data to $

******************************
*
* Get the pixel data for
* these eight characters
*
******************************
	D=0	A
	D=D-1	A
	GOSBVL	=GET3X5 	** GET3X5 gets a maximum of EIGHT chars,
*				** so , don't worry, be happy!
******************************
	A=R3
	D0=A

	C=0	A
	LCHEX	4B
	B=C	A		** Nib offset to next row (from last write!)

	D1=D1+	1		** Skip over coloumn count field

	D=0	S
	D=D+CON S,4		** Row loop counter

*				A	B	C	D	D0	D1
shift2	P=	8	<---+
	C=0	W	    |
	GONC	getfst	    |
*			    |
shift	D1=D1+	11	<-+ |
*			  | |
getfst	C=DAT1	B	  | |
	C=C+C	B	  | |
	CSRC		  | |
	CSRC		  | |
	P=P+1		  | |
	GONC	shift	--+ |
*			    |
	A=0	W	    |
	GOSUB	shf8_6	    |
	C=C+C	W	    |
	C=C+C	W	    |	** Shift left because of nib boundary
	GOSUB	nxs0	    |
	CSRB		    |
	CSRB		    |	** Shift right
	GOSUB	shf8_6	    |
*			    |
** Char     8 7 6 5 4 3 2 1 |
*			    |
	P=	12	    |
	DAT0=C	WP	    |	** Write row for eight characters
	D0=D0+	16	    |
	D0=D0+	16	    |
	D0=D0+	2	    |	** Jump to next Display row
*			    |
	CD1EX		    |
	C=C-B	A	    |
	D1=C		    |	** Jump to next pixel data row
*			    |
	D=D-1	S	    |
	GONC	shift2	----+

	C=0	A
	P=	0
	LCHEX	9E
	B=C	A
	CD0EX
	C=C-B	A
	A=R4
	A=A-1	S
	GOC	InnerEX
	GOTO	InnerL

InnerEX A=A-1	A
	GOC	exx
	CD0EX

	C=0	A
	LCHEX	7F

	B=C	B
	C=R2.F	B
	C=C-B	B
	R2=C.F	B
	LCHEX	B4
	B=C	A
	CD0EX
	C=C+B	A
	GOTO	OuterL

exx	GOVLNG	=GETPTRLOOP  GPLoop

**shf8_6**********************
*
* Shift pixel data from w=8
* to w=6 ; Right-justified
*
* In other words: Crunch it !
*
******************************

shf8_6	B=0	S
	B=B+1	S
	GOSUB	nxs1

nxs0	P=P+1
	B=0	S
nxs1	P=P+1
	A=C	WP
	C=0	WP
	CSRB
	CSRB
	C=C!A	WP
	B=B-1	S
	GONC	nxs1
	RTNCC
**END_nxshift*****************

RPL

*****************************************************************************
*		ROMPART end
*****************************************************************************

ASSEMBLE

	CON(4)	0			CRC
=SYSEND

RPL

*****************************************************************************
*		End of RPL.S
*****************************************************************************
